2005-04-01  Richard Sandiford  <rsandifo@redhat.com>

	* except.c (finish_eh_generation): Deal with RESX jumps that we could
	not prove were dead.

2005-03-31  Richard Sandiford  <rsandifo@redhat.com>

	Backport from mainline:

	2004-11-28  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>
	* gcse.c (insert_store): Error if try to insert store on abnormal edge.
	(store_motion): Don't move store if any edge we'd want to move it
	to is abnormal.

2005-03-31  Richard Sandiford  <rsandifo@redhat.com>

	* cfgrtl.c (cfg_layout_merge_blocks): If block B's footer starts with
	a BARRIER, make sure it is the first instruction in the merged footer.

2005-03-31  Richard Sandiford  <rsandifo@redhat.com>

	* reload.c (subst_reloads): When adding a REG_LABEL note to a jump
	instruction, also update its JUMP_LABEL.

2005-03-31  Richard Sandiford  <rsandifo@redhat.com>

	* tree.def (GOTO_SUBROUTINE_EXPR): Bump number of operands to 3.
	* tree.c (fold_checksum_tree): Check the first operand of a
	GOTO_SUBROUTINE_EXPR.
	* gengtype.c (adjust_field_tree_exp): Update GOTO_SUBROUTINE_EXPR
	rtl information.
	* tree.c (first_rtl_op): Return 1 for GOTO_SUBROUTINE_EXPR.
	* expr.c (expand_expr_real): Remove GOTO_SUBROUTINE_EXPR handling
	from TRY_FINALLY_EXPR case.  Make the GOTO_SUBROUTINE_EXPR code
	expand the cleanup expression when the expression is first expanded.
	* stmt.c (expand_decl_cleanup): Create a GOTO_SUBROUTINE_EXPR if
	the cleanup is not safe to reevaluate.

2005-03-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/linux.h (SUBTARGET_DRIVER_SELF_SPECS): Make -pthread
	imply -shared-libgcc.
	(MD_FALLBACK_FRAME_STATE_FOR): New macro.

2005-03-11  Richard Sandiford  <rsandifo@redhat.com>

	* configure: Regenerate with autoconf 2.13.

2005-02-04  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md ("tls_indirect_call"): Turn into libcall-like
	expand.
	("*tls_indirect_call"): New, reference hard regs directly.
	* config/frv/frv.c (gen_inlined_tls_plt): Adjust.

2005-01-22  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (movcc_fp_destination_operand): New.
	(gpr_or_memory_operand): Fix typo in comment.
	(gpr_or_memory_operand_with_scratch): New.
	* config/frv/frv.h (PREDICATE_CODES): Add the two new predicates.
	* config/frv/frv.md (movcc_fp, movcc_fp_internal): Use
	movcc_fp_destination_operand.
	(reload_incc_fp): Use gpr_or_memory_operand_with_scratch.
	Legitimize memory addresses using a scratch register.

2005-01-10  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (bdesc_2arg): Remove __MDPACKH.
	(frv_init_builtins): Change its prototype to take 4 uhalf arguments.
	(frv_expand_mdpackh_builtin): New function.
	(frv_expand_builtin): Use it to expand __MDPACKH.
	* config/frv/media.h (__MDPACKH): Update prototype.

2004-12-13  Alexandre Oliva  <aoliva@redhat.com>

	* reload.c (find_reloads): Avoid committing to narrow register
	classes.
	* config/frv/frv.h: Reorder few-register classes involving gr8,
	gr9, gr14 and gr15.  Remove duplicate such classes.  Adjust all
	uses.
	* config/frv/frv.c (frv_class_likely_spilled_p): Add GR8_REGS,
	GR9_REGS, GR89_REGS, FDPIC_FPTR_REGS, FDPIC_REGS.

2004-12-10  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.h (ASM_OUTPUT_DWARF_DTPREL): Define.
	* config/frv/frv-protos.h (frv_output_dwarf_dtprel): Declare.
	* config/frv/frv.c (TLS_BIAS): Define.
	(frv_output_dwarf_dtprel): New.

2004-12-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_sort_insn_group): Always initialize
	packet_group->nop.

2004-12-03  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-modes.def (CC_NZ): Define.  Fix comment typos.
	* config/frv/frv-protos.h (frv_select_cc_mode): Declare.
	(condexec_intop_cmp_operator): Delete.
	* config/frv/frv.c (comparison_string): New function.
	(frv_print_operand): Use it to handle 'c' and 'C'.
	(relational_operator): Redefine in terms of integer_relational_operator
	and float_relational_operator.
	(signed_relational_operator, unsigned_relational_operator): Delete.
	(integer_relational_operator): New predicate, combining the above.
	Check the mode of the first operand but leave frv.md to check the rest.
	(float_relational_operator): Just check the mode of the first operand;
	leave frv.md to check the rest.
	(intop_compare_operator): Assume the result is compared with zero
	in mode CC_NZmode.  Allow PLUS and MINUS.  Leave frv.md to check
	the operand predicates.
	(condexec_intop_cmp_operator): Delete.
	(frv_ifcvt_modify_tests, frv_ifcvt_modify_multiple_tests)
	(frv_hard_regno_mode_ok): Handle CC_NZmode.
	(frv_select_cc_mode): New function.
	* config/frv/frv.h (SELECT_CC_MODE): Use frv_select_cc_mode.
	(REVERSIBLE_CC_MODE): Include CC_NZmode.
	(PREDICATE_CODES): Replace entries for signed_relational_operand and
	unsigned_relational_operator with one for integer_relational_operator.
	Delete entry for condexec_intop_cmp_operator.
	* config/frv/frv.md (movcc_nz, *internal_movcc_nz, reload_incc_nz)
	(reload_outcc_nz, *cmpsi_cc_nz, *cond_exec_cmpsi_cc_nz): New patterns.
	(*combo_intop_compare2, *combo_intop_compare4): Delete.
	(*combo_intop_compare1): Change mode to CC_NZ.
	(*combo_intop_compare2): Likewise.  Renamed from *combo_intop_compare3.
	(branch_{un,}signed_true, branch_{un,}signed_false)
	(*scc_{un,}signed, *scc_neg1_{un,}signed, *ck_{un,}signed)
	(*movqicc_internal1_{un,}signed, *movqicc_internal2_{un,}signed)
	(*movhicc_internal1_{un,}signed, *movhicc_internal2_{un,}signed)
	(*movsicc_internal1_{un,}signed, *movsicc_internal2_{un,}signed)
	(*movsfcc_has_fprs_{un,}signed, *movsfcc_no_fprs_{un,}signed)
	(*return_{unsigned_,}true, *return_{unsigned_,}false): Merge these
	pattern pairs.  Use integer_relational_operator.  Remove mode from
	icc_operand.

2004-11-23  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_ifcvt_modify_insn): Don't leave alone
	scratch insns that set a register live at the join point.

2004-11-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md ("tls_indirect_call"): Add a use of GR15.
	* config/frv/frv.c (gen_inlined_tls_plt): Pass it picreg.

2004-11-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md ("load_or_call"): Move before "unknown".

2004-10-08  Richard Sandiford  <rsandifo@redhat.com>

	* cgraph.c (cgraph_function_possibly_inlined_p): Check whether
	inline limits are being disregarded.

2004-10-04  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (*adddi3_internal): Change name to...
	(adddi3): ...replacing the exisiting define_expand.  Combine
	alternatives.  Fix the range of the constant constraints ('J' instead
	of 'NOP').  Remove bogus operands[2] check.  Use simplify_gen_subreg
	to extract the lower and upper halves of the DImode operands.
	Always use addi3_lower and adddi3_upper, not the subdi3 forms.
	(adddi3_lower): Fix the range of the constant constraints and
	remove the bogus operands[2] check.
	(adddi3_upper): Use gpr_or_int10_operand as the predicate for
	operand 2.  Use addxi to handle constant operands.
	(subdi3_lower, subdi3_upper): Don't handle constant operands.

2004-09-09  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (acc_operand, accg_operand): Use REGNO.

2004-09-02  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (CONDITONAL_REGISTER_USAGE): Delete.
	(EPILOGUE_USES): Remove IACC handling.
	* config/frv/frv.c (frv_read_iacc_argument): Turn the IACC register
	into a global register.

2004-09-02  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc: Match frv*-*-*linux*.
	(cpu_type): Map frv* to frv.
	(with_cpu): Map frv550-*-*linux* to fr550.  Accept fr550.

2004-08-27  Alexandre Oliva  <aoliva@redhat.com>

	* combine.c (simplify_comparison, case SIGN_EXTEND, ZERO_EXTEND):
	Do not drop the extend if we'd have to add a paradoxical subreg
	later.  Include optabs.h and insn-codes.h.
	* Makefile.in (combine.o): Depend on $(OPTABS_H).

2004-08-24  Alexandre Oliva  <aoliva@redhat.com>

	* c-parse.in (maybe_type_qual): Do not emit line number notes
	during parsing.

2004-07-26  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/linux.h (TARGET_C99_FUNCTIONS): Define to 0.

2004-07-16  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (movqi_internal, movhi_internal,
	movsi_internal): Add backup alternatives for memory inputs.

2004-06-08  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.h (CALL_REALLY_USED_REGISTERS): Clear for gr0,
	gr1, gr2, gr16, gr17, gr28, gr29, gr30, gr31, and fake arg ptr. 

2004-05-24  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.h (EPILOGUE_USES): Mark IACC registers as used.
	(CALL_REALLY_USED_REGISTERS): New.

2004-05-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_expand_load_builtin,
	frv_expand_store_builtin): Protect arguments from queue.

2004-03-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (MASK_OPTIMIZE_MEMBAR, TARGET_OPTIMIZE_MEMBAR): New.
	(TARGET_SWITCHES): Add -moptimize-membar and -mno-optimize-membar.
	(struct machine_function): Remove.
	* config/frv/frv.md (UNSPEC_BUILTIN_{LOAD,STORE}): Delete.
	(builtin_read*, builtin_write*): Delete.
	(optional_membar*): Add constant address and io-type arguments.
	* config/frv/frv.c (struct frv_io): New.
	(struct machine_function): Moved from frv.h.  Add has_membar_p.
	(frv_same_doubleword_p, frv_io_fixed_order_p, frv_io_union)
	(frv_extract_membar, frv_io_check_address, frv_io_handle_set)
	(frv_io_handle_use_1, frv_io_handle_use, frv_optimize_membar_local)
	(frv_optimize_membar_global, frv_optimize_membar): New functions.
	(frv_reorg): Call frv_optimize_membar when appropriate.
	(bdesc_loads, bdesc_stores): Use the membar code as the icode field.
	(frv_expand_builtin): Adjust calls accordingly.
	(frv_io_address_cookie): New function.
	(frv_expand_load_builtin, frv_expand_store_builtin): Emit a normal
	load or store rather than a special insn.  Add ccnstant address and
	io-type operands to the membar.

2004-02-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/t-frv (MULTILIB_OPTIONS): Add -mcpu=frv multilibs.
	(MULTILIB_DIRNAMES): Add corresponding entry here.
	(MULTILIB_EXCEPTIONS): Remove -mcpu=frv/-mno-pack exception.

2004-02-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/media.h (__accg0-7, __accg0-7, __ACC, __ACCG): Delete.
	* config/frv/frv.h (TARGET_CPU_CPP_BUILTINS): Define __CPU_*__ macros.
	* config/frv/frv.c (frv_final_prescan_insn): Insert mnop.p before M1
	only insns if packing optimizations are disabled.
	(frv_acc_group_1): Check for accumulator guards too.
	(frv_acc_group): Return ACC_GROUP_NONE unless compiling for the fr550.
	(frv_int_to_acc): Turn all ACCs and ACCGs into global registers.
	* config/frv/frv.md (UNSPEC_MASACCS, UNSPEC_MDASACCS): New constants.
	(maddaccs, msubaccs, *maddacc): Turn destination operand into a single
	ACC/ACCG pair.  Remove match_dup from inputs.  Remove masaccs handling.
	(mdaddaccs, mdsubaccs, *mdaddacc): Likewise dual ACC/ACCG pair.
	(masaccs, mdasaccs): Turn into define_insns.

2004-02-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/media.h (ACC8-11, ACCG8-11): Define.
	* config/frv/frv-protos.h (FRV_CPU_FR405, FRV_CPU_FR450): New.
	(fr400_submodel): Delete.
	* config/frv/frv.h (MASK_DEFAULT_FR450, ACC_MASK): New macros.
	(TARGET_MEDIA_REV2): Handle new FRV_CPUs.
	(TARGET_FR405_BUILTINS, TARGET_MEDIA_FR450): Likewise.
	(ACC_LAST, ACCG_FIRST): Bump by 4.
	(ACCG_LAST, AP_FIRST, SPR_FIRST, SPR_LAST): Bump by 8.
	(FIXED_REGISTERS, CALL_USED_REGISTERS, REG_ALLOC_ORDER)
	(REG_CLASS_CONTENTS, REGISTER_NAMES): Add acc8-11 and accg8-11.
	* config/frv/frv.c (fr400_submodel): Delete.
	(frv_default_flags_for_cpu, frv_issue_rate): Handle new FRV_CPUs.
	(frv_override_options): Use them for the appropriate -mcpu options.
	(frv_conditional_register_usage): Remove redundant ACC handling.
	(acc_operand, accg_operand): Require hard registers.  Use ACC_MASK
	to check whether a register is valid.
	(even_acc_operand, quad_acc_operand): Redefine in terms of acc_operand.
	(frv_int_to_acc): Use ACC_MASK to check whether a register is valid.
	* config/frv/frv.md: Add fr450 media scheduler.
	(IACC0_REG): Bump by 8.
	(define_attr cpu): Add fr405 and fr450.
	(fr400_i1_{int,sethi,setlo,scan}): Extend to fr405 and fr450.
	(fr400_i1_{mul,div}): Extend to fr405.
	(fr450_i1_{mul,div}): New reservations.
	(fr400_i1_{macc,cut}): Restrict to the fr405 and fr450.
	(fr400_i2, fr400_i4, fr400_m*): Extend to fr405.
	(fr450_i2_{gload,fload}, fr450_i4_{movfg,movgf}): New reservations.
	(fr400_i3, fr400_i5, fr400_b): Extend to fr405 and fr450.
	(mexpdhw, cmexpdhw): Fix predicate and constraints for operand 0.
	(mclracca8): Use ACC_MASK to find the second bank of 4 registers.

2004-02-16  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_sort_insn_group_1): Remove unused variable.
	(frv_fill_unused_units): Likewise.
	(frv_align_label): Fix condition.

2004-02-13  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (LABEL_ALIGN_AFTER_BARRIER): Make logarithmic.

2004-02-12  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_acc_group): New function.
	* config/frv/frv.h (LABEL_ALIGN_AFTER_BARRIER): Define.
	* config/frv/frv.md: Describe the packing algorithm and the reasons
	for constructing the DFA in this way.  Rewrite fr550 media scheduler
	to cope with instructions that can only issue to odd or even units.
	(define_attr type): Add "mnop".
	(define_attr acc_group): New.
	(define_query_cpu_unit c): New.
	(define_reservation control): Renamed from "c".
	(define_insn_reservation control): Use both "c" and "control".
	(define_insn_reservation fr300_lat[12]): Likewise.
	(define_automaton fr400_media): New.
	(define_cpu_unit fr400_m1a,fr400_m1b,fr400_m2): New.
	(define_reservation fr400_m1,fr400_m2): New.
	(define_insn_reservation fr400_m[1-4]_1): Use fr400_m1.
	(define_insn_reservation fr400_m[1-4]_2, fr400_m5): Use fr400_m2.
	(mnop): New pattern.
	* config/frv/frv.c (NUM_NOP_PATTERNS): New macro.
	(enum frv_insn_group): Add GROUP_C.
	(frv_unit_names, frv_unit_groups): Add a separate control unit.
	(NTH_UNIT, UNIT_NUMBER): New macros.
	(frv_unit_codes, frv_type_to_unit): Moved to head of file.
	(frv_nops, frv_num_nops): New variables.
	(frv_override_options): Initialize frv_unit_codes and frv_type_to_unit.
	(frv_function_prologue): Clear frv_nops.
	(frv_acc_group_1, frv_acc_group): New functions.
	(frv_insn_unit): New, replacing old frv_get_insn_attr.
	(frv_issues_to_branch_unit_p): Moved.
	(frv_packet): Make static.  Allocate insns[] statically.  Add groups[].
	(frv_start_packet): Initialize frv_packet.groups[].
	(frv_add_insn_to_packet, frv_insert_nop_in_packet): New functions.
	(frv_for_each_packet): Remove handle_label argument.  Use
	frv_add_insn_to_packet.
	(frv_find_unit, frv_init_packet_insn): Delete.
	(frv_compare_insns): Compare rtx insns rather than frv_packet_insns.
	(frv_sort_insn_group_1, frv_sort_insn_group): New.
	(frv_reorder_packet): Use frv_sort_insn_group.  Simplify.
	(frv_pack_insns): Remove once-per-compilation initialization code.
	(frv_align): Remove.
	(frv_packet_address): New variable.
	(frv_count_nops, frv_align_insert): Delete.
	(frv_align_label): Remove label argument.  Rework so that the function
	is called at the end of a packet and searches ahead for a label.
	(frv_fill_unused_units, frv_reorder_packet): New functions.
	(frv_register_nop): New function.
	(frv_reorg): Remove frv_align initialization code.  Set up frv_nops[].

2004-02-05  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_emit_movsi): Use GOT relocations for
	symbols in sections named by the user.

2004-02-05  Richard Sandiford  <rsandifo@redhat.com>

	* gcse.c (FOR_EACH_REGNO): New macro.
	(oprs_unchanged_p, record_last_set_info, oprs_not_set_p, mark_set)
	(mark_clobber, compute_kill_rd, expr_killed_p, compute_transp)
	(reg_set_info): Iterate over all registers in a REG.

2004-02-05  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (FRV_BUILTIN_READ{8,16,32,64})
	(FRV_BUILTIN_WRITE{8,16,32,64}): New enum values.
	* config/frv/frv.c (bdesc_loads, bdesc_stores): New arrays.
	(frv_init_builtins): Add __builtin_read* and __builtin_write*.
	(frv_expand_builtin): Expand them.
	(frv_volatile_memref, frv_expand_load_builtin)
	(frv_expand_store_builtin): New functions.
	* config/frv/frv.md (UNSPEC_BUILTIN_LOAD, UNSPEC_BUILTIN_STORE)
	(UNSPEC_OPTIONAL_MEMBAR): New constants.
	(builtin_read{8,16,32,64}, builtin_write{8,16,32,64})
	(optional_membar{8,16,32,64}): New patterns.

2004-02-02  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_expand_builtin): Remove bogus SCAN check.
	* config/frv/frv.md (scan): Remove condition.

2004-01-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/linux.h (TARGET_OS_CPP_BUILTINS): New.

2004-01-27  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc (frv-*-*linux*): Handle like *-*-linux*.
	* config/frv/t-linux (EXTRA_MULTILIB_PARTS): Remove, obviated by
	the above.

2004-01-26  Richard Sandiford  <rsandifo@redhat.com>

	* doc/invoke.texi: Add -mcpu=fr405 and -mcpu=fr450.
	* config/frv/frv-protos.h (fr400_submodel): New enum and variable.
	* config/frv/frv.c (fr400_submodel): Define.
	(frv_override_options): Handle -mcpu=fr405 and -mcpu=fr450.
	Set fr400_submodel to FR400_SUBMODEL_STANDARD for -mcpu=fr400.
	(bdesc_2arg): Add entries for mqlclrhs and mqlmths.
	(bdesc_2argimm): Add entries for mqsllhi and mqsrahi.
	(frv_init_builtins): Register new builtins.
	(frv_expand_builtin): Check whether they're available.
	Use submodel-specific error messages.
	* config/frv/frv.h (TARGET_FR403_BUILTINS): Remove.
	(TARGET_FR405_BUILTINS, TARGET_MEDIA_FR450): New macros.
	(TARGET_MEDIA_FR450): Use fr400_submodel.
	(FRV_BUILTIN_MQSLLHI, FRV_BUILTIN_MQSRAHI)
	(FRV_BUILTIN_MQLCLRHS, FRV_BUILTIN_MQLMTHS): New builtin enums.
	* config/frv/frv.md: Replace all uses of TARGET_FR403_BUILTINS
	with TARGET_FR405_BUILTINS.
	(type attribute): Add mqlimh and mqshift.
	(fr400_m1_2): Include them.
	(UNSPEC_MQLCLRHS, UNSPEC_MQLMTHS, UNSPEC_MQSLLHI)
	(UNSPEC_MQSRAHI): New constants.
	(mqlclrhs, mqlmths, mqsllhi, mqsrahi): New patterns.
	* config/frv/t-frv (MULTILIB_MATCHES): Use fr400 multilibs for
	-mcpu=fr405 and -mcpu=fr450.

2004-01-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (symGOT2reg_hilo, symGOTOFF2reg_hilo): Add
	one more pseudo to further improve code generation.
	2003-12-18  Ulrich Weigand  <uweigand@de.ibm.com>
	* loop.c (move_movables): Handle combination of m->consec,
	m->move_insn_first, and m->insert_temp all nonzero correctly.

2004-01-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_pack_insn_p): Move tomcat check from here...
	(frv_for_each_packet): ...to here.  End a packet before an exception-
	throwing instruction unless the instruction is guaranteed to be in
	the last slot.  End packets after an exception-throwing instruction.
	(frv_get_insn_type): New, split out from...
	(frv_init_packet_insn): ...here.
	(frv_issues_to_branch_unit_p): New function.

2004-01-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (movdi_ldd): Introduce explicit indirection
	inside UNSPEC.

2004-01-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (movdi_ldd): Remove explicit indirection.
	Prevent hoisting.
	* config/frv/frv.c (frv_get_funcdesc_alias_set): Remove.
	(frv_print_operand_memory_reference): Don't handle UNSPEC_LDD.
	(frv_print_operand): Likewise.
	(frv_legitimate_address_p): Likewise.
	(dbl_memory_one_insn_operand): Likewise.

2004-01-10  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_funcdesc_gotoff_mem_p): Removed.
	(frv_print_operand_memory_reference): Handle UNSPEC_LDD.
	(frv_print_operand): Likewise, in %I.
	(frv_legitimate_address_p): Removed mem argument, added
	allow_double_reg_p.  Adjust all callers.  Add code to handle
	UNSPEC_LDD in regular movdi, disabled for now.
	(frv_expand_fdpic_call): Emit movdi_ldd.
	(ldd_address_operand): New.
	(dbl_memory_one_insn_operand): Accept UNSPEC_LDD.
	* config/frv/frv.h (GO_IF_LEGITIMATE_ADDRESS): Adjust.
	(PREDICATE_CODES): Add ldd_address_operand.
	* config/frv/frv-protos.h (frv_legitimate_address_p): Adjust.
	* config/frv/frv.md (movdi_ldd): New.

2004-01-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_get_funcdesc_alias_set): Forward declare.
	(frv_funcdesc_gotoff_mem_p): New.
	(frv_legitimate_address_p): Add mem argument.  Adjust all
	callers.  Use it to check for function descriptor loads.
	(frv_expand_fdpic_call): Set the offset of the MEM to the UNSPEC.
	(dbl_memory_one_insn_operand): Use it to recognize it.
	* config/frv/frv.h (GO_IF_LEGITIMATE_ADDRESS): Adjust.
	* config/frv/frv-protos.h (frv_legitimate_address_p): Adjust.
	* config/frv/frv.md (symGOT2reg_hilo, symGOTOFF2reg_hilo): Use
	separate pseudo for intermediate computations if possible.
	(symGOTOFF2reg_i): Fix harmless typo.

2004-01-09  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (iacc_operand, even_iacc_operand): Delete.
	* config/frv/frv.h (SPR_LAST): Bump by 2.
	(IACC_FIRST, IACC_LAST): Define.
	(FIXED_REGISTERS): Add entries for iacc0h and iacc0l.
	(CALL_USED_REGISTERS, REG_ALLOC_ORDER, REGISTER_NAMES): Likewise.
	(REG_CLASS_CONTENTS): Include iacc0 in SPR_REGS and ALL_REGS.
	(PREDICATE_CODES): Remove entries for iacc_operand and
	even_iacc_operand.
	(FRV_BUILTIN_FIRST_NONMEDIA): Define.
	* config/frv/frv.c (iacc_operand, even_iacc_operand): Delete.
	(output_move_single): Handle moves of zero into SPRs.
	(bdesc_1arg): Remove entries for IACCreadl and IACCreadll.
	(bdesc_iacc_sets): Remove.
	(frv_init_builtins): Change prefetch arguments to "const void *".
	(frv_read_iacc_argument): New function.
	(frv_expand_iacc_sets): Delete.
	(frv_expand_prefetches): Pass the address of the prefetch area
	to the pattern, not a MEM.
	(frv_split_iacc_move): New function.
	(frv_expand_builtin): Only check TARGET_MEDIA for media builtins.
	Extend error checking to handle TARGET_FR403_BUILTINS and
	TARGET_FR500_FR550_BUILTINS.  Handle moves to and from IACC0 here.
	Remove walk of bdesc_iacc_sets.
	* config/frv/frv.md (IACC0_REG): New constant.
	(type): Add macc, scan and cut.
	(fr400_i1_macc, fr400_i1_scan, fr400_i1_cut): New insn reservations.
	(smul, umul, addss, subss, slass, scan): Add type attributes.
	(smu, smass, smsss, scutss): Likewise.
	(smu, smass, smsss): Set IACC0_REG.
	(smass, smsss, scutss): Use IACC0_REG.
	(iaccreadl, iaccreadll, iaccsetl, iaccsetll): Delete.
	(frv_prefetch0, frv_prefetch): Use a (prefetch ...) pattern with
	a register_operand for the address.

2004-01-09  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (dbl_memory_one_insn_operand): Check whether the
	MEM has a specific alias set before comparing it against
	frv_get_funcdesc_alias_set().

2003-12-18  Alexandre Oliva  <aoliva@redhat.com>

	* unwind-dw2-fde-glibc.c (_Unwind_IteratePhdrCallback): Cast
	relocated p_vaddr to vaddr type.

	* config/frv/frv-protos.h (frv_expand_fdpic_call): Return void.
	* config/frv/frv.c (frv_get_funcdesc_alias_set): New.
	(frv_expand_fdpic_call): Propagate incoming MEM's expr to funcdesc
	MEM, or use a funcdesc alias set.  Use regular move instead of
	ldd.
	(dbl_memory_one_insn_operand): Recognize function descriptors by
	type or by alias set, and don't split them.
	* config/frv/frv.md (call, call_value): Never use call_internal
	for fdpic.
	(call_internal, call_value_internal): Never match for FDPIC.
	(call_fdpicdi, call_fdpicsi, call_value_fdpicdi,
	call_value_fdpicsi): Require FDPIC.
	(ldd): Removed.

2003-12-17  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.h (CRT_GET_RFIB_DATA): Define for __FRV_FDPIC__.
	* unwind-dw2-fde-glibc.c: Don't include elf-fdpic.h any more.
	(_Unwind_IteratePhdrCallback): Adjust type of load_base for FRV
	FDPIC.  Compute data base address.

	* config/frv/linux.h (SUBTARGET_DRIVER_SELF_SPECS): Enable -mfdpic
	before the other self-specs are processed.

	* config/frv/t-linux (CRTSTUFF_T_CFLAGS, TARGET_LIBGCC2_CFLAGS):
	Build with -fPIC.

2003-12-15  Alexandre Oliva  <aoliva@redhat.com>

	* unwind-dw2-fde-glibc.c: Don't include bits/elf-fdpic.h if
	inhibit_libc is defined.

2003-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* unwind-dw2-fde-glibc.c: Include bits/elf-fdpic.h for
	__FRV_FDPIC__.
	(__RELOC_POINTER): Define.
	(_Unwind_IteratePhdrCallback): Use it.
	* config/frv/frv.h (Twrite): Define.
	(TRANSFER_FROM_TRAMPOLINE): Use it.
	* config/frv/linux.h (INVOKE__main): Undefine.
	(Twrite): Override.

2003-12-08  Alexandre Oliva  <aoliva@redhat.com>

	2003-11-30  Andreas Schwab  <schwab@suse.de>
	* Makefile.in ($(DESTDIR)$(infodir)/%.info): Fix missing semicolon.

	* config/frv/frv.md (subdi3, negdi2): Merge expands into _internal
	insn_and_splits, by using match_scratch.

2003-12-02  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (move_source_operand): Allow CONSTANT_P_RTX.

2003-11-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (int_2word_operand): Reject LABEL_REFs,
	SYMBOL_REFs and CONSTs in FDPIC mode.

	* gcc/config.gcc (with_cpu): Default to fr400 on frv-*-*linux*.

2003-11-29  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (move_source_operand): Don't accept symbolic
	constants.
	* config/frv/frv.md (*movhi_internal, *movsi_internal): Use an 'n'
	rather than 'i' constraint for the 2-instruction alternative.
	(*movsi_2word): New, incorporating existing int_2word_operand splitter.

2003-11-29  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (EXTRA_CONSTRAINT_FOR_Q): Renamed from
	EXTRA_CONSTRAINT_FOR_Y.
	(EXTRA_CONSTRAINT): Remove handling of 'Y'.
	* config/frv/frv.c (small_data_symbolic_operand): Delete.
	* config/frv/frv.md (*movsi_internal): Remove 'Q' constraint.
	(addsi3): Change 'Y' constraint to 'Q'.

2003-11-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (small_data_symbolic_operand): Re-introduce
	mostly-dummy.

2003-11-28  Richard Sandiford  <rsandifo@redhat.com>

	* stmt.c (expand_asm_operands): Check whether force_const_mem
	succeeded.

2003-11-28  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_issue_rate): Declare.
	* config/frv/frv.h (DRIVER_SELF_SPECS): Make -mno-pack imply
	-mno-media and -msoft-float.
	(CPP_SPEC, CPP_FRV_SPEC, CPP_FR550_SPEC, CPU_FR500_SPEC): Delete.
	(CPP_FR400_SPEC, CPP_SIMPLE_SPEC, CPP_CPU_DEFAULT_SPEC): Delete.
	(SUBTARGET_EXTRA_SPECS, EXTRA_SPECS): Delete.
	(TARGET_CPU_CPP_BUILTINS): Define the macros that were previously
	handled by CPP_SPEC.
	* config/frv/frv.c (frv_issue_rate): Make global.

2003-11-28  Richard Sandiford  <rsandifo@redhat.com>

	* gcse.c (remove_back_edge_insertions): New function.
	(compute_pre_data, store_motion): Use it.

2003-11-28  Richard Sandiford  <rsandifo@redhat.com>

	* toplev.c (rest_of_compilation): Do block reordering after
	if-conversion.

2003-11-28  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (define_cpu_unit fr550_load0, fr550_load1): New.
	(define_cpu_unit fr550_store0, fr550_store1): New.  Only allow
	fr550_store1 if fr550_store0 has already been used.
	(define_insn_reservation fr550_load): Add load unit restrictions.
	(define_insn_reservation fr550_store): Add store unit restrictions.

2003-11-27  Richard Sandiford  <rsandifo@redhat.com>

	* reload.c (CONST_POOL_OK_P): New macro.
	(find_reloads): Use it to decide whether a constant can be forced
	into memory.
	* config/frv/frv.h (LEGITIMATE_PIC_OPERAND_P): Return true if the
	constant satisfies got12_operand.
	(frv_cannot_force_const_mem): Always return true for TARGET_FDPIC.
	(frv_legitimate_address_p): Check for valid unspec offsets using
	got12_operand rather than frv_legitimate_fdpic_operand_p.
	(frv_legitimate_fdpic_operand_p): Delete.
	(frv_emit_movsi): Abort if we try to use the FDPIC register during
	or after reload.
	(frv_legitimate_constant_p): Return LEGITIMATE_PIC_OPERAND_P if
	TARGET_FDPIC.
	* config/frv/frv.md (*movdf_double): Add alternatives for CONST_DOUBLE.

2003-11-25  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.md (negdi2, negdi2_internal): New.

2003-11-25  Catherine Moore  <clm@redhat.com>

	* config/frv/frv-protos.h (iacc_operand, even_iacc_operand): Declare.
	* config/frv/frv.c (iacc_operand, even_iacc_operand): New.
	(bdesc_1arg):  Add __SCUTSS, IACCreadl, IACCreadll.
	(bdesc_2arg): Add __SMUL, __UMUL, __ADDSS, __SUBSS, __SLASS, __SCAN.
	(bdesc_int_void2arg): New.
	(bdesc_iacc_sets): New.
	(bdesc_prefetches): New.
	(frv_init_builtins):  Add support for new builtins.
	(frv_expand_int_void2arg): New.
	(frv_expand_iacc_sets): New.
	(frv_expand_prefetches): New.
	(frv_expand_builtin):  Add support for new builtins.
	* config/frv/frv.h (TARGET_FR403_BUILTINS): New.
	(TARGET_FR500_FR550_BUILTINS): New.
	(PREDICATE_CODES): Add iacc_operand, even_iacc_operand.
	(frv_builtins): Add new builtins.
	* frv.md (smul, umul, smass, smsss, smu, addss, subss): New patterns.
	(slass, scan, scutss, iaccreadl, iaccreadll, iaccsetl): New patterns.
	(iaccsetll, frv_prefetch0, frv_prefetch): New patterns.
	(UNSPEC_SMUL, UNSPEC_UMUL, UNSPEC_SMU, UNSPEC_ADDSS): New constants.
	(UNSPEC_SUBSS, UNSPEC_SLASS, UNSPEC_SCAN, UNSPEC_INTSS): New constants.
	(UNSPEC_SCUTSS, UNSPEC_PREFETCH0, UNSPEC_PREFETCH): New constants.
	(UNSPEC_IACCREADll, UNSPEC_IACCreadl, UNSPEC_IACCsetll): New constants.
	(UNSPEC_IACCsetl, UNSPEC_SMASS, UNSPEC_SMSSS): New constants.
	
2003-11-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (fdpic_operand, fdpic_got12_operand)
	(frv_fdpic_fptr_operand): Don't declare here.
	* config/frv/frv.h (EXTRA_CONSTRAINT_FOR_Y): Call got12_operand
	rather than fdpic_got12_operand.
	(PREDICATE_CODES): Remove symbolic_operand entry.  Add entries for
	got12_operand and const_unspec_operand.
	* config/frv/frv.c (got12_operand): Renamed from fdpic_got12_operand.
	(gpr_or_int12_operand, dbl_memory_one_insn_operand): Update calls.
	(symbolic_operand): Remove.
	(const_unspec_operand): New predicate.
	* config/frv/frv.md (*movsi_got): Use got12_operand.
	(*movsi_high_got, *movsi_lo_sum_got): Use const_unspec_operand.

2003-11-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_expand_epilogue): Remove parameter.
	* config/frv/frv.c (frv_expand_epilogue): Don't pretend to deal
	with sibcalls.
	* config/frv/frv.md (epilogue): Update call to frv_expand_epilogue.
	(sibcall_epilogue): Remove.
	(*return_true, *return_false): New patterns.

2003-11-18  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_output_addr_const_extra): Remove.
	* config/frv/frv.h (OUTPUT_ADDR_CONST_EXTRA): Remove definition.
	* config/frv/frv.c (frv_unspec): New structure.
	(frv_small_data_reloc_p, frv_const_unspec_p): New functions.
	(frv_print_operand_memory_reference): Use frv_const_unspec_p to
	validate CONST indices.  Use frv_output_const_unspec to print them.
	(frv_print_operand): Update call to unspec_got_name.  Use
	frv_output_const_unspec to print constant unspecs.
	(frv_legitimate_fdpic_operand_p): Return true if frv_const_unspec_p.
	Reject UNSPECs otherwise.
	(unspec_got_name): Take the relocation number as argument, not an
	rtx containing it.
	(frv_output_addr_const_extra): Remove, replacing with...
	(frv_output_const_unspec): ...this new function.
	(frv_find_base_term): Use frv_const_unspec_p & frv_small_data_reloc_p.
	(gpr_or_int12_operand): Use fdpic_got12_operand.
	(dbl_memory_one_insn_operand): Likewise.
	(fdpic_got12_operand): Use frv_const_unspec_p.
	(frv_emit_movsi): Use frv_const_unspec_p to check for CONSTs that
	are already legitimate.  Use frv_small_data_reloc_p when deciding
	whether to use HIGH/LO_SUM for R_FRV_GOTOFF12 and R_FRV_GPREL12.

2003-11-18  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/t-linux (SHLIB_MAPFILES): Override so as to export...
	* config/frv/libgcc-frv.ver: ... frv-specific symbols.  New file.

	* config/frv/frv-abi.h (CREATE_DOUBLE_SHIFT): Use branch to local
	label, for real this time.

	* config/frv/frv.c (frv_local_funcdesc_p): Update to new
	representation of visibility.
	(fdpic_got12_operand, symbolic_operand): Mark unused arguments as
	such.

2003-11-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (MASK_LINKED_FP, TARGET_LINKED_FP): New macros.
	(TARGET_SWITCHES): Add -mlinked-fp and -mno-linked-fp.
	* config/frv/frv.c (frv_override_options): Set MASK_LINKED_FP unless
	it was explicitly disabled.
	(frv_stack_info): There is no need to save the link register in every
	frame unless TARGET_LINKED_FP is true.
	(frv_frame_pointer_required): If !TARGET_LINKED_FP, only require a
	frame pointer if the stack pointer might change value.
	(frv_return_addr_rtx): Check and process "count" argument.

2003-11-16  Fred Fish  <fnf@redhat.com>

	* genmultilib: Pick up dont_builds from ${10} not $10 (which is ${1}0)

2003-11-14  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_legitimize_address): Remove.
	(frv_find_base_term): Declare.
	* config/frv/frv.h (LEGITIMIZE_ADDRESS): Do nothing.
	(FIND_BASE_TERM): Define.
	(PREDICATE_CODES): Remove pic_register_operand, pic_symbolic_operand,
	small_data_register_operand, small_data_symbolic_operand.  Add
	symbolic_operand.
	* config/frv/frv.c (const_small_data_p, plus_small_data_p): Delete.
	(frv_print_operand_memory_reference, output_move_single): Remove
	special handling for unlegitimized sdata addresses.
	(frv_legitimate_address_p): Don't allow sums of SDA_BASE_REG
	and symbolic addresses.
	(frv_legitimize_address, frv_legitimize_fdpic_address): Delete.
	(frv_find_base_term): New function.
	(int_2word_operand): Check specifically for symbolic address constants.
	(pic_register_operand, pic_symbolic_operand): Delete.
	(small_data_register_operand, small_data_symbolic_operand): Delete.
	(dbl_memory_one_insn_operand): Don't call plus_small_data_p.
	Allow UNSPEC_GOT constants if !TARGET_FDPIC.
	(move_source_operand): Only accept CONSTs if they're a two-insn
	symbolic constant.
	(fdpic_got12_operand): Don't require TARGET_FDPIC.
	(frv_emit_movsi): Legitimize sdata and -mlibrary-pic addresses
	using gen_symGOTOFF2reg*.
	(frv_ifcvt_rewrite_mem): Remove (plus gr16 ...) special cases.
	(frv_rtx_costs): Give all MEM addresses a cost of 0.  Give MEMs
	themselves a cost of 3 insns.
	* config/mips/mips.md (*movsi_got): Allow for !TARGET_FDPIC too.
	Change predicate to symbolic_operand.
	(*movsi_high_got, *movsi_lo_sum_got): Likewise.
	(*movsi_lda_sdata): Delete.
	(*movsi_pic, movsi_high_pic, movsi_lo_sum_pic): Delete.

2003-11-13  Stan Cox  <scox@redhat.com>

	* config/mep/mep.c (mep_add_operand): Also recognize CONST(UNSPEC(PLUS)
	(mep_multiple_address_regions): Scan entire list.

2003-11-10  Catherine Moore  <clm@redhat.com>

	* rcsp.c (unroll): Don't use VARRAY_FREE for pending_jump_packets.
	(finish_RCSP_interface): Don't use VARRAY_FREE for generic VARRAYs.

2003-11-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (MASK_ALIGN_LABELS, TARGET_ALIGN_LABELS): New.
	(TARGET_SWITCHES): Add -malign-labels and -mno-align-labels.
	* config/frv/frv.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(frv_packet_insn, frv_compare_insns, frv_find_unit): Move down file.
	(frv_finish_packet): Remove reordering code.  Take a new callback
	argument and call it for each completed packet.
	(frv_pack_insns): Split out most code to...
	(frv_for_each_packet): ...this new function.  Generalize.  Take two
	callback arguments, one for labels and one for packets.  Update calls
	to frv_finish_packet.
	(frv_unit_names, frv_unit_groups): New, taken from frv_reorder_packet.
	(frv_unit_codes, frv_subclass_names, frv_subclass_codes): Likewise.
	(frv_type_to_unit, frv_type_to_subclass): Likewise.
	(frv_init_packet_insn): New function, taken from frv_reorder_packet.
	(frv_reorder_packet): Adjust after above.  Reorder the rtl stream here,
	not frv_finish_packet.
	(frv_align): New structure.
	(frv_count_nops, frv_align_insert, frv_align_label): New functions.
	(frv_align_packet, frv_reorg): Likewise.
	* config/frv/frv.md (define_attr type): Add fnop.
	(define_insn_reservation fr500_farith): Include fnop.
	(define_insn_reservation fr550_f1): New.
	(fnop): New instruction.

2003-11-06  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (MASK_LONG_CALLS, TARGET_LONG_CALLS): Define.
	(TARGET_SWITCHES): Add -mlong-calls and -mno-long-calls.
	(EXTRA_CONSTRAINT_FOR_S): Check whether the value is a call_operand.
	* config/frv/frv.c (call_operand): Don't allow global symbols if
	TARGET_LONG_CALLS.

2003-11-05  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc: Add t-slibgcc-elf-ver and support --with-cpu for
	frv-*-*linux*.
	* config/frv/frv-abi.h (CREATE_DOUBLE_SHIFT): Use branch to local
	label.
	* config/frv/frv.h (DRIVER_SELF_SPECS): Add blank before
	-multilib-library-pic.
	(LINK_SPEC): Add -z text for -mfdpic.
	* config/frv/frvbegin.c (__ROFIXUP_LIST__): Don't define on FDPIC.
	* config/frv/frvend.c (__ROFIXUP_END__): Likewise.
	* config/frv/linux.h (STARTFILE_SPEC, ENDFILE_SPEC, LINK_SPEC):
	Override.
	(OPTION_DEFAULT_SPECS, HAS_INIT_SECTION, INIT_SECTION_ASM_OP,
	FINI_SECTION_ASM_OP, CRT_CALL_STATIC_FUNCTION): Define.
	* config/frv/t-linux (EXTRA_MULTILIB_PARTS): Use
	crtstuff-generated files.

2003-11-02  Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (prloop.o): Depend on TM_H.

2003-10-31  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc: Add frv-*-*linux*.
	* config/frv/linux.h, config/frv/t-linux: New.

2003-10-31  Richard Sandiford  <rsandifo@redhat.com>

	* Makefile.in (OBJS-common): Add prloop.o.
	(prloop.o): New rule.
	* rtl.h (post_reload_loop_optimize): Declare.
	* toplev.c (rest_of_compilation): Call it after 3rd if-conversion pass.
	* prloop.c: New file.

2003-10-28  Nick Clifton  <nickc@redhat.com>

	* cfglayout.c (duplicate_insn_chain): Skip RCSP notes.

	* sched-rgn.c (schedule_insns): When recovering from RCSP, zero
	the branch probability notes before reconstructing the basic
	blocks, since they are now invalid.

2003-10-27  Nick Clifton  <nickc@redhat.com>

	* read-rtl.c: Add some characters that might be escapred in
	redact strings.

2003-10-27  Nick Clifton  <nickc@redhat.com>

	* toplev.c (rest_of_handle_sched): If performing RCSP, do not call
	find_basic_blocks before cleaning up the CFG.

2003-10-21  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/t-spe-helper.sed: Take config/ into account.

2003-10-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (define_insn_reservation fr500_i1_sethi): Set
	latency to 1.  Add bypass for fr500_setlo.
	(define_insn_reservation fr400_i1_sethi): Likewise fr400_i1_setlo.

2003-10-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (CPU_FR550_SPEC): Define __FRV_VLIW__ to 8.
	* config/frv/frv.c (frv_issue_rate): Return 8 for FRV_CPU_FR550.
	(frv_packet): Add mems[] and num_mems fields.
	(struct frv_packet_insn): Add subclass field.
	(frv_compare_insns): Compare insns by subclass as well as unit number.
	(frv_reorder_packet): Add i2, f2, i3 and f3 units.  Handle fr550
	media restrictions.
	(frv_registers_conflict_p_1): Check for memory conflicts.
	(frv_registers_update_1): Record clobbered memrefs.
	(frv_start_packet): Reset memref count.
	* config/frv/frv.md: Add fr550 scheduler.
	(define_query_cpu_unit i2,i3,f2,f3): New units.
	(define_reservation c): Include them.

2003-10-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (ISSUE_RATE): Remove.
	(CLEAR_VLIW_START, SET_VLIW_START, PACKING_FLAG_USED_P): Remove.
	(CPU_UNITS_QUERY): Define.
	* config/frv/frv.c (REGSTATE_LIVE): Remove.
	(REGSTATE_UNUSED, REGSTATE_MASK, REGSTATE_CONDJUMP): Remove.
	(regstate_t): New typedef.
	(SET_PACKING_FLAG, CLEAR_PACKING_FLAG, PACKING_FLAG_P): New macros.
	(frv_insn_packing_flag): Update comments to mention new -1 value.
	(frv_function_prologue): Don't set frv_insn_packing_flag.
	(frv_asm_output_mi_thunk): Use frv_issue_rate to detect whether
	packing is enabled.
	(frv_asm_output_opcode): Return the original opcode if an insn
	isn't packed.
	(frv_final_prescan_insn): Simplify after PACKING_FLAG_P changes.
	(frv_registers_update): Remove.
	(frv_registers_used_p, frv_registers_set_p): Remove.
	(FOR_EACH_REGNO): New macro.
	(frv_packet): New variable.
	(frv_packet_insn): New structure.
	(frv_compare_insns, frv_find_unit, frv_reorder_packet, frv_cond_flags)
	(frv_regstate_conflict_p, frv_registers_conflict_p_1)
	(frv_registers_conflict_p, frv_registers_update_1)
	(frv_registers_update, frv_start_packet, frv_start_packet_block)
	(frv_finish_packet, frv_pack_insn_p): New functions.
	(frv_pack_insns): Rewrite to use them.
	* config/frv/frv.md (define_automaton nodiv): Split into...
	(define_automaton integer, float_media, branch): ...three automota.
	(define_cpu_unit sl*, fr400*): Remove.
	(define_reservation i0,i1,f0,f1,m0,m1,b0,b1): Remove in favor of...
	(define_query_cpu_unit i0,i1,f0,f1,b0,b1): ...these new units.
	(define_reservation c): Redefine in terms of the new units.
	(define_cpu_unit idiv1,idiv2,div1,div2,root): Move out of fr500 area.
	(define_insn_reservation fr500_control, unknown, fr400_c)
	(define_insn_reservation fr400_unknown): Remove in favor of...
	(define_insn_reservation control): ...this generic reservation.
	(define_insn_reservation *): Allocate units from high to low.
	(define_insn_reservation fr400_*): Use the new generic units.
	(define_insn_reservation fr400_i2_gload, fr400_i2_fload): Combine.
	(define_insn_reservation fr400_i3_gstore, fr400_i3_fstore): Likewise.
	(define_insn_reservation fr400_i4_movfg, fr400_i4_movgf): Likewise.

2003-10-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (define_attr type): Add fscmp, fdcmp, fsmadd and
	fdmadd.  Remove fmas and m7.
	(define_automota fr500_integer, fr500_media): New.
	(define_cpu_unit l0): Rename to fr500_load0 and move to fr500_integer.
	(define_cpu_unit l1): Likewise fr500_load1.
	(define_cpu_unit s0): Likewise fr500_store0.
	(define_cpu_unit add0,add1,mul0,mul1): Remove.
	(define_cpu_unit m1_0,m1_1,m7): Remove.
	(define_cpu_unit m[234]_0,m[234]_1,m5,m6): Add fr500_ prefix.
	Move to fr500_media.
	(define_insn_reservation b1/b3): Rename to fr500_branch.
	(define_insn_reservation b4): Rename to fr500_call.
	(define_insn_reservation fr500_farith, fr500_fcmp, fr500_fdiv,
	fr500_fsqrt): New, replacing...
	(define_insn_reservation f1, f2, f3, f4_div, f4_root): ... these.
	(define_insn_reservation i6, b2, b5, b6, f5, f6, f7, m7): Remove.
	(define_insn_reservation i2_gload, i2_fload): Combine into fr500_i2.
	(define_insn_reservation i3_gstore, i3_fstore): Likewise fr500_i3.
	(define_insn_reservation i4_move_fg, i4_move_gf): Likewise fr500_i4.
	(define_insn_reservation trap, control): Likewise fr500_control.
	(define_insn_reservation m1-m7): Add fr500_ prefix.
	(*muladdsf4, *mulsubsf4): Change type to fsmadd.
	(*muladddf4, *mulsubdf4): Likewise fdmadd.
	(*cmpsf_cc_fp): Likewise fscmp.
	(*cmpdf_cc_fp): Likewise fdcmp.

2003-10-10  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (enum frv_cpu): Add FRV_CPU_FR550.
	* config/frv/frv.h (CPP_SPEC): Handle -mcpu=fr550.
	(CPP_FR550_SPEC, MASK_DEFAULT_FR550): New macros.
	(EXTRA_SPECS): Map cpp_fr550 to CPP_FR550_SPEC.
	(TARGET_MEDIA_REV2): Include FRV_CPU_FR550.
	* config/frv/frv.c (frv_default_flags_for_cpu): Handle FRV_CPU_FR550.
	(frv_issue_rate): Likewise.
	(frv_override_options): Parse -mcpu=fr550.
	(frv_expand_builtin): Generalize !TARGET_MEDIA_REV2 error.
	* config/frv/frv.md (define_attr cpu): Add fr550.
	* config/frv/t-frv (MULTILIB_OPTIONS): Replace -mcpu=simple multilib
	with -mcpu=fr550.
	(MULTILIB_DIRNAMES): Alter accordingly.

2003-10-08  Nick Clifton  <nickc@redhat.com>

	* sched-rgn.c: Move RCSP code to seperate files.
	* rcsp.c: New file.  Imported from Vlad's private repository.
	* rcsp-core.c: New file.  Likewise
	* rcsp-int.h: New file.  Likewise
	* Makefile.in: Add new files, update dependencies.

2003-10-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/t-frv (EXTRA_HEADERS): Install media.h.

2003-10-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.h (LINK_SPEC): Pass -melf32frvfd to the linker
	when -mfdpic even if a linker script is explicitly listed.

2003-10-04  Nick Clifton  <nickc@redhat.com>

	* opts.c (common_handle_option): Add code to handle RedHat
	specific options.

2003-10-02  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_override_options): Clear asm_out
	unaligned_op for SImode on FDPIC.
	(frv_emit_movsi): Use compute_reloc_for_constant to compute the
	argument passed to decl_readonly_section.
	(frv_assemble_integer): Revert 2003-09-30's change, but make the
	whole block run with FDPIC even with -fno-PIC.

2003-10-02  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_cannot_force_const_mem): Don't force
	symbol or label plus offset to memory.
	(frv_emit_movsi): Emit GPREL only if -mgprel-ro.  Emit 32-bit
	GOTOFF and GPREL for LABEL_REF.
	* config/frv/frv.h (DRIVER_SELF_SPECS): Add -mgprel-ro with
	-mfdpic unless -mno-gprel-ro, -fpic or -fpie.
	(MASK_GPREL_RO, TARGET_GPREL_RO): New.
	(TARGET_SWITCHES): Added gprel-ro and no-gprel-ro.
	* doc/invoke.texi: Document them.

2003-09-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv-protos.h (frv_gen_GPsym2reg): Declare.
	(frv_splittable_got_operand): Removed.
	* config/frv/frv.c (frv_cannot_force_const_mem): Reject HIGH and
	LO_SUM.  Add comments.
	(frv_override_options): Moved enabling of FDPIC to
	DRIVER_SELF_SPECS.  Don't enable MASK_DWORD.
	(frv_local_funcdesc_p): Remove unnecessary heck for flag_pie.
	(frv_legitimize_fdpic_address): Don't duplicate logic in
	frv_emit_movsi.
	(frv_gen_GPsym2reg): New.
	(unspec_got_name): Added gprel.
	(frv_expand_fdpic_call): Add support for inlining PLTs.
	(fdpic_fptr_operand): Renamed from frv_fdpic_fptr_operand.
	(gpr_or_int12_operand): Added GPREL12.
	(pic_symbolic_operand): Match even if !flag_pic for FDPIC.
	(small_data_symbolic_operand): Fail if FDPIC.
	(fdpic_splittable_got_operand): Removed.
	(fdpic_got12_operand): Added GPREL12.
	(frv_emit_movsi): Reorganize to avoid duplication.  Emit GPREL
	when appropriate.  Fix sdata GOTOFF.
	(frv_legitimate_constant_p): Require legitimate PIC operand for
	FDPIC with pic, but only a legitimate fdpic operand for non-pic.
	(frv_assemble_integer): Move FDPIC funcdesc handling out of
	flag_pic case.
	(frv_asm_out_constructor, frv_asm_out_destructor): Abort if
	frv_assemble_integer fails.
	* config/frv/frv.h (DRIVER_SELF_SPECS): New.
	(SUBTARGET_DRIVER_SELF_SPECS): New.
	(ASM_SPEC): Don't pass -mno-fdpic.
	(LINK_SPEC): Pass -melf32frvfd for FDPIC.
	(MASK_INLINE_PLT, TARGET_INLINE_PLT): New.
	(TARGET_SWITCHES): Add -minline-plt, -mno-inline-plt and
	-multilib-library-pic.
	(PREDICATE_CODES): Added fdpic_operand, fdpic_fptr_operand,
	condexec_si_media_operator, condexec_sf_add_operator and
	condexec_sf_conv_operator.  Removed condexec_sf_binary_operator
	and condexec_sf_unary_operator.
	* config/frv/frv.md (R_FRV_GPREL12, R_FRV_GPRELHI, R_FRV_GPRELLO):
	New.
	(movsi_got, movsi_high_got, movsi_lo_sum_got): Move before
	movsi_internal.  Give them internal names.  movsi_got has type
	int.
	(fdpic got splitters): Remove.
	(symGPREL2reg, symGPREL2reg_hilo): New.
	* config/frv/t-frv (MULTILIB_MATCHES): Don't map -fpic and -fPIC
	to -mlibrary-pic.  Map -multilib-library-pic to it.
	* doc/invoke.texi: -mfdpic, -minline-plt, -multilib-library-pic:
	Document.

2003-09-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_function_symbol_referenced_p): Declare.
	(TARGET_CANNOT_FORCE_CONST_MEM): Define to...
	(frv_cannot_force_const_mem): New function.
	(const_small_data_p, plus_small_data_p): Update comments on sdata
	on FDPIC.
	(frv_override_options): Set flag_pie for FDPIC too.
	(frv_conditional_register_usage): Mark gr16 and gr17 as non-fixed,
	call-saved registers on FDPIC.
	(frv_stack_info): Don't preserve the PIC register on FDPIC, and
	don't force LR to be preserved.
	(frv_expand_prologue): Likewise.
	(frv_asm_output_mi_thunk): Use 12-bit funcdesc gotoff for -fpic.
	(frv_frame_pointer_required): Don't force it just because the
	FDPIC register is used.
	(frv_legitimate_address_p) <CONST>: Accept a legitimate FDPIC
	operand only if !condexec_p.
	(frv_legitimize_address): Return the FDPIC-legitimized address.
	Don't match small data here on FDPIC.
	(frv_legitimate_fdpic_operand_p): Don't accept unadorned function
	symbols.  Use TRUE/FALSE instead of 1/0.
	(frv_local_funcdesc_p): New.
	(frv_legitimize_fdpic_address): Rewrite to use GOTOFF and 12-bit
	immediates when possible.
	(pic_symbolic_operand): Accept SYMBOL_REFs and CONSTs in FDPIC.
	(dbl_memory_one_insn_operand): Accept addresses that add a REG and
	an UNSPEC_GOT.
	(frv_emit_movsi): Handle FDPIC before small data.  Use GOTOFF and
	12-bit immediates when possible.
	(frv_legitimate_constant_p): In FDPIC, reject SImode operands that
	are not legitimate pic operands.
	(frv_in_small_data_p): Re-enable for FDPIC.
	* config/frv/frv.h (SDA_BASE_REG): Remove comment about FDPIC.
	(FRV_GLOBAL_P): Removed.
	* config/frv/frv.md: Add modes to CONSTs.
	(movsi_got): New.
	(movsi_lo_sum_got): Use separate matches instead of match_dup.
	(movsi_high_pic, movsi_lo_sum_pic): Match on non-FDPIC only.
	(fdpic splittable operations): Match on flag_pic != 1.

2003-09-22  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_asm_out_constructor,
	frv_asm_out_destructor): Pass to frv_assemble_integer the size in
	bytes, not bits.

2003-09-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/frv/frv.c (frv_assemble_integer): Reject complex
	expressions referencing function SYMBOL_REFs.

	* config/frv/frv.c (frv_function_symbol_referenced_p): New.
	(move_source_operand): Reject CONSTs that reference function
	SYMBOL_REFs on FDPIC.
	(frv_emit_movsi): If we get such a CONST, break it up.
	* config/frv/frv.h (CPP_SPEC): Define __FRV_FDPIC__ for -mfdpic.
	(TRANSFER_FROM_TRAMPOLINE): Use different definitions for FDPIC.

	* config/frv/frv.c (frv_print_operand) <I>: Recognize PLUS without
	MEM.
	(frv_assemble_integer): Don't use funcdesc for LABEL_REFs.
	(frv_trampoline_size): Increase for FDPIC.
	* config/frv/frv.h (TRAMPOLINE_ALIGNMENT): Bump to 64 for FDPIC.
	(TRANSFER_FROM_TRAMPOLINE): Handle FDPIC trampolines.
	
	* config/frv/frv.c (frv_legitimize_fdpic_address, frv_emit_movsi):
	Disable use of GOTOFF for now.
	(const_small_data_p, plus_small_data_p, frv_in_small_data_p):
	Disable use of small data in FDPIC for now.
	(frv_asm_output_mi_thunk): Implement for FDPIC.
	* config/frv/frv.h (SDA_BASE_REG): Set to -1 with FDPIC.
	
	* config/frv/frv.c (frv_asm_out_constructor): Use
	frv_assemble_integer for FDPIC pointers.
	(frv_asm_out_destructor): Likewise.
	* config/frv/frv.md (ldd): Fix order of operands.  Use
	address_operand for input.

2003-09-18  DJ Delorie  <dj@redhat.com>

	* config/frv/frv.c (frv_legitimate_fdpic_operand_p): Remove UNSPEC_PIC.
	(unspec_got_name): Correct typo.
	(frv_emit_movsi): Pre-expand splittable GOTs.
	(frv_expand_fdpic_call): Rename gen_lddi to gen_ldd.
	* config/frv/frv.md (lddi): Fix syntax error, rename to ldd.
	(symGOT2reg_hilo, symGOTOFF2reg_hilo): New.
	* config/frv/t-frv: Add -mfdpic multilibs.
	* config/frv/frv.h (ASM_SPEC): Pass -mfdpic/-mno-fdpic.
	(TARGET_SWITCHES): Add -mno-fdpic, fix documentation.
	
	
	* config/frv/frv.c (frv_override_options): -mfdpic assumes
	flag_pic, default to 32-bit pics, require DWORD ops.
	(frv_override_options): Add W and Z constraints.
	(frv_expand_prologue): No pic prologue for -mfdpic.
	(frv_asm_output_mi_thunk): Support -mfdpic (soon).
	(frv_print_operand_memory_reference): Handle GOT constants.
	(frv_legitimate_address_p): Allow GOT constants.
	(frv_legitimize_address): Handle GOT addresses too.
	(frv_legitimate_fdpic_operand_p): New.
	(frv_legitimize_fdpic_address): New.
	(unspec_got_name): New.
	(frv_output_addr_const_extra): New.
	(frv_expand_fdpic_call): New.
	(frv_fdpic_fptr_operand): New.
	(gpr_or_int12_operand): Handle GOT operands.
	(int_2word_operand): Handle GOT operands.
	(fdpic_operand): New.
	(fdpic_splittable_got_operand): New.
	(fdpic_got12_operand): New.
	(frv_emit_movsi): Handle GOT operands.
	(frv_assemble_integer): -mfdpic doesn't use rofixups.
	(frv_print_operand): Support 'g' code for GOT operands.

	* config/frv/frv-protos.h: Add prototypes as needed.

	* config/frv/frv.md (R_FRV_GOT12, R_FRV_GOTHI, R_FRV_GOTLO,
	R_FRV_FUNCDESC, R_FRV_FUNCDESC_GOT12, R_FRV_FUNCDESC_GOTHI,
	R_FRV_FUNCDESC_GOTLO, R_FRV_FUNCDESC_VALUE,
	R_FRV_FUNCDESC_GOTOFF12, R_FRV_FUNCDESC_GOTOFFHI,
	R_FRV_FUNCDESC_GOTOFFLO, R_FRV_GOTOFF12, R_FRV_GOTOFFHI,
	R_FRV_GOTOFFLO): New.
	(movsi_high_got, movsi_lo_sum_got): New.
	(*movsi_pic): Don't use this splitter for -mfdpic.
	(addsi3): Allow GOT references also.
	(call, call_value): Handle -mfdpic separately.
	(call_fdpicdi, call_fdpicsi, lddi, call_value_fdpicdi,
	call_value_fdpicsi): New.
	(symGOT2reg, symGOT2reg_i, got splitters, symGOTOFF2reg,
	symGOTOFF2reg_i): New.

	* config/frv/frv.h (MASK_FDPIC): New.
	(TARGET_FDPIC): New.
	(TARGET_SWITCHES): Add -mfdpic.
	(FDPIC_FPTR_REGNO): New.
	(FDPIC_REGNO): New.
	(OUR_FDPIC_REG): New.
	(enum reg_class): Add FDPIC_REGS, FDPIC_FPTR_REGS, and
	FDPIC_CALL_REGS.
	(REG_CLASS_NAMES): Likewise.
	(REG_CLASS_CONTENTS): Likewise.
	(EXTRA_CONSTRAINT_FOR_Y): New, for 12-bit GOTs.
	(EXTRA_CONSTRAINT): Add it here.
	(FRV_GLOBAL_P): New.
	(OUTPUT_ADDR_CONST_EXTRA): New.

2003-09-07  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (ifcompare_plus_move): Workaround iwmmxt code
	generation problem by disabling the pattern responsible.

2003-09-03  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Remove redundant xscale sanitization.

2003-07-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.h (PREDICATE_CODES): Define.

2003-06-16  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (mn10300_unspec_int_label_counter):
	Moved from...
	* config/mn10300/mn10300.md (GOTaddr2picreg): ... here.
	* config/mn10300/mn10300.h: GTY-declare it.

2003-06-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (mn10300_encode_section_info): Fix
	prototype.  Use incoming RTL argument.

2003-05-01  Nick Clifton  <nickc@redhat.com>

	* version.c (bug_report_url): Change URL to enterprise.redhat.com/gnupro.

2003-04-21  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/t-spe-helper.sed: New.

2003-04-21  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/eabispe.h: Set 128 bit long doubles.

2003-04-03  Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (TEXI2POD): Use the etc/ script, instead of contrib/.

2003-04-03  Aldy Hernandez  <aldyh@redhat.com>

	* gcc.c (handle_braces): Remove last change.
	Skip white space after comment in spec.
	Fix typo in "unrecognised".

2003-04-02  Aldy Hernandez  <aldyh@redhat.com>

        * gcc.c (handle_braces): Allow empty braces.

2003-03-24  Nick Clifton  <nickc@redhat.com>

	* version.c (bug_report_url): Change address to
	https:://enterprise.redhat.com/portal/.

2003-01-28  Nick Clifton  <nickc@redhat.com>

	* gcc.c (process_command): Ignore null command line arguments.

2003-01-27  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (arm_output_mi_thunk): Use entirely seperate
	Thumb version.  Add code to handle very large deltas.
	(cf g++ testcase: g++.dg/compat/break/bitfield7.C with -mthumb).

2002-12-18  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.c (use_return_insn): Do not use an inline return
	if NOPs are going to be inserted.

2002-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/vr.h (SUBTARGET_MIPS_AS_ASM_SPEC): Remove.  Define...
	(SUBTARGET_ASM_SPEC): ...this instead.

2002-12-13  Nick Clifton  <nickc@redhat.com>

	* config/arm/crti.asm: Enforce 64-bit stack alignment.
	* config/arm/crtn.asm: Enforce 64-bit stack alignment.
	* config/arm/t-arm-elf: Disable APCS-26 multilib - it is not
	really needed anymore.

2002-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md (int_label): Move C statements...
	(GOTaddr2picreg): ... here.

2002-11-13  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (call_indirect): Fix up long call code.
	(call_value_indirect): Likewise.
	(arm_output_mi_thunk): Fix thumb mode thunk generation.

2002-10-03  Nick Clifton  <nickc@redhat.com>

	* config/d10v/d10v.md (addhi3_no_small_insns/6): Duplicate fix
	applied to addhi3_small_insns.

2002-09-13  Nick Clifton  <nickc@redhat.com>

	* config/d10v/d10v.md (addhi3_small_insns/6): Restrict 2nd operand
	to real constants, not symbolic ones whoes name might alias a
	register name.  (JN test case 02081904.c).

2002-09-12  Nick Clifton  <nickc@redhat.com>

	* config/d10v/d10v.md (call_internal1): Do not rely upon the
	predicate to enforce an indirect call, place the REG in the rtl
	template.  (JN test case 02080602.c)

2002-08-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/t-vr (MULTILIB_MATCHES): Define.

2002-08-15  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.h (ENCODE_SECTION_INFO): Move...
	* config/mn10300/mn10300.c (mn10300_encode_section_info):
	... here.  New function.
	(TARGET_ENCODE_SECTION_INFO): Define to it.

2002-08-14  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h (SELECT_RTX_SECTION): Remove definition.
	(TARGET_ASM_SELECT_RTX_SECTION): Define.
	* config/arm/arm-protos.h (arm_elf_select_rtx_section): Prototype.
	* config/arm/arm.c (arm_elf_select_rtx_section): New function.

2002-08-07  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md (cond_call): Use unsigned comparison
	test. (107503).

2002-08-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (override_options): If a vr41xx processor
	is selected, and no FPU switch was given, assume no FPU is
	available.

2002-07-31  Eric Christopher  <echristo@redhat.com>

	* elf5000.h: Remove.
	* elf5400.h: Ditto.
	* elf5500.h: Ditto.
	* elfb4320.h: Ditto.
	* elfb5000.h: Ditto.
	* elfb5500.h: Ditto.
	* elfbvr4111.h: Ditto.
	* elfbvr4xxx.h: Ditto.
	* elflvr4181.h: Ditto.
	* elfl4320.h: Ditto.
	* elfl5000.h: Ditto.
	* elfl5500.h: Ditto.
	* elflvr4111.h: Ditto.
	* elflvr4xxx.h: Ditto.
	* t-vr4100: Ditto.
	* t-vr4111: Ditto.
	* t-vr4181: Ditto.
	* t-vr4300: Ditto.
	* t-vr4xxx: Ditto.
	* t-vr5000: Ditto.
	* t-vr5500: Ditto.
	* vr.h: Add copyright. Update.
	* config.gcc (mips64vr4*-elf, mips64vr5*-elf): Remove configurations.
	Update mips64vr-elf configuration.

2002-07-26  Richard Sandiford  <rsandifo@redhat.com>

	* config.gcc (mips64vr-*-elf, mips64vrel-*-elf): New configurations.
	* config/mips/vr.h
	* config/mips/t-vr: New files.

2002-07-25  Nick Clifton  <nickc@redhat.com>

	* config/v850/v850.c (function_arg): If size of arg is not known,
	pass it on the stack.

2002-07-24  Nick Clifton  <nickc@redhat.com>

	* config/v850/v850.h (OUTPUT_ADDR_CONST_EXTRA): Replace macro with
	invocation of v850_output_addr_const_extra.
	* config/v850/v850-protos.h: Prototype v850_output_addr_const_extra.
	* config/v850/v850.c (v850_output_addr_const_extra): New function.
	Handle generating references to switch tables, even when
	redundant.

2002-07-24  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Add v850e1 target.  Allow --with-cpu to accept
	v850e1.
	* config/v850/v850.h: Accept v850e1 as a default CPU.
	Accept -mv850e1 as a command line option.
	* doc/invoke.texi: Document new -mv850e1 command line switch.
	* config/v850/t-v850: Treat -mv850e1 as a multilib alias for
	-mv850e.  Do not build seperate v850 multilib directories.

2002-07-23  Nick Clifton  <nickc@cambridge.redhat.com>

	* expr.c (emit_move_insn_1): Do not consider unaligned bitfields
	at the start of a packed structure to be unaligned.

2002-07-08  Michael Meissner  <meissner@redhat.com>
	    Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (TUNE_MIPS5400): New.
	(RTX_COSTS): Add vr5xxx costs.

2002-07-08  Michael Meissner  <meissner@redhat.com>
	    Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_use_dfa_pipeline_interface): New.
	(TARGET_SCHED_USE_DFA_PIPELINE_INTERFACE): Use it.
	* config/mips/mips.md: Replace the 5400 scheduler with a DFA version.

2002-07-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (define_attr cpu): Reorder to match mips.h.

2002-07-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md: Add imadd type.  Update scheduler description
	to use imadd as well as imul.
	(*mul_acc_si, *madsi): Change imul alternatives to imadd.
	(*mul_acc_di, *mul_acc_64bit_di): Likewise.
	(*msac, *msac_di): Likewise
	(*mul_sub_si): Likewise for first alternative.  Change second
	alternative from imul to multi.

2002-07-03  Nick Clifton  <nickc@cambridge.redhat.com>

	* final.c: Remove LRS support code.

2002-06-24  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/t-vr5000 (CONFIG2_H): Remove elfl64.h dependency.

2002-06-19  DJ Delorie  <dj@redhat.com>

	* doc/invoke.texi: Use @itemize @bullet for bulleted lists, not
	@table.

2002-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/elfbvr4111.h (MIPS_CPU_STRING_DEFAULT): Make lower case.
	* config/mips/elflvr4111.h (MIPS_CPU_STRING_DEFAULT): Likewise.
	* config/mips/elf5000.h (MIPS_CPU_STRING_DEFAULT): Likewise.
	* config/mips/elfl5000.h (MIPS_CPU_STRING_DEFAULT): Likewise.
	* config/mips/elfb5000.h (MIPS_CPU_STRING_DEFAULT): Likewise.
	* config/mips/elf5400.h (MIPS_CPU_STRING_DEFAULT): Likewise.

2002-05-31  Eric Christopher  <echristo@redhat.com>

	* config/mips/elf5000.h: Remove SUBTARGET_CPP_SIZE_SPEC.
	* config/mips/elfb4320.h: Ditto.
	* config/mips/elfb5000.h: Ditto.
	* config/mips/elfb5500.h: Ditto.
	* config/mips/elfbvr4111.h: Ditto.
	* config/mips/elfbvr4xxx.h: Ditto.
	* config/mips/elfl4181.h: Ditto.
	* config/mips/elfl4320.h: Ditto.
	* config/mips/elfl5000.h: Ditto.
	* config/mips/elfl5500.h: Ditto.
	* config/mips/elflvr4111.h: Ditto.
	* config/mips/elflvr4xxx.h: Ditto.
2002-05-25  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.c (mips_issue_rate): Fix merge error.

2002-05-21  Vladimir Makarov  <vmakarov@redhat.com>

	* config/rs6000/rs6000.md (fpu2_fdiv): Remove it.
	(fpu2_iter): Make it belonging to `fpu1_div'.
	(rios2-sdiv, ssqrt, dsqrt, sdiv, ddiv, ssqrt, dsqrt): Make
	reservations of `fpu1_iter' and `fpu2_iter' starting with the 2nd
	cycle.

2002-05-19  Vladimir Makarov  <vmakarov@redhat.com>

	* config/frv/frv.md (i1_div, f4_div): Don't use div units on the
	1st cycle reservations.


2002-05-17  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c : Cleanup comparisons.
	(d10v_expand_branch): New function.
	(d10v_expand_setcc): Same.
	(d10v_expand_movcc): Same.
	(select_cc_mode): Delete.
	(d10v_expand_compare): Renamed from expand_comparison.
	(d10v_emit_comparison): Renamed from emit_comparison.
	* config/d10v/d10v.md : Update.
	* config/d10v/d10v-protos.h : Update.
	* config/d10v/d10v.h (SELECT_CC_MODE): Define with
	d10v_emit_comparison.
	(CANONICALIZE_COMPARISON): Delete.
	(TARGET_DEBUG_MOVE4): Delete.

2002-05-09  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c (d10v_assemble_integer): Mark labels as
	referenced for static inline function pointers.

2002-05-09  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.md: Revert last change.  Fix accum shifts.

2002-05-07  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.md (ashldi3): New expander.
	* config/arm/arm.md (ashidi3): Rename to ashldi3_cirrus.

2002-05-06  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.md: Remove accum logical shift right.

2002-05-03  Tom Rix  <trix@redhat.com>

	* config/d10v/libgcc1.asm: Rename _cmpdi to _cmpdi2 and
	rename _ucmpdi to _ucmpdi2.
	* config/d10v/d10v.c (expand_comparison): Same.
	* config/d10v/t-d10v: Same.

2002-05-03  Catherine Moore  <clm@redhat.com>

	* config/v850/v850.h (CONST_OK_FOR_O): Fix range.

2002-05-02  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h(ASM_OUTPUT_ALIGNED_DECL_COMMON): Revert
	previous patch.

2002-05-02  Richard Sandiford  <rsandifo@redhat.com>

	* regmove.c (regmove_optimize): Remove local SUBREG handling.
	(fixup_match_1): Remove related code here.

2002-05-01  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.md: Limit SI split to GPRs.

2002-04-30  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c (emit_move_2words): Add accum to accum move.
	* config/d10v/d10v.md: (reload_insi): Add & modifier to scratch
	constraint to scratch operand.
	(movsi): Delete reload_in_progress check.
	* config/d10v/d10v-protos.h: Update copyright.

2002-04-26  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.h (HARD_REGNO_RENAME_OK): Do not use
	RETURN_ADDRESS_REGNUM as a dest in register renaming.

2002-04-26  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c (d10v_expand_builtin_va_arg): Do size
	calculations with trees.
	* config/d10v/d10v.c (d10v_assemble_integer): New function to
	handle special word symbols.

2002-04-24  Nick Clifton  <nickc@cambridge.redhat.com>

	* config.gcc: Fix v850e and v850ea targets to use v850.md machine
	description file and v850.c backend source file.

2002-04-23  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.h (REGISTER_PREFIX, LOCAL_LABEL_PREFIX): Define.
	(RETURN_ADDR_RTX): Use NULL_RTX for unsupported count warning.

2002-04-15  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c (emit_move_4words): Remove.
	* config/d10v/d10v-protos.h : Same.
	* config/d10v/d10v.md : Remove DI support.

2002-04-09  Tom Rix  <trix@redhat.com>

	* config/d10v/d10v.c (override_options): Disable profiling.

2002-04-04  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (ASM_SPEC, TARGET_SWITCHES): Add -mpack.

2002-03-26 Alan Matsuoka <alanm@redhat.com>

	* config/d10v/d10v.c (override_options): Change class of F0_REGNUM
	to NO_REGS so that cse can see it.
	* config/d10v/d10v.c (carry_operand, f0_compare_operator,
	compare_operator, equality_operator, signed_compare_operator,
	unsigned_compare_operator, emit_cond_move: Accept operands with
	VOIDmode as well. Cse doesn't like operators that are of MODE_CC.
	* config/d10v/d10v.c (print_operand): Get the mode from the
	operands instead of the operator.
	* config/d10v/d10v.c (d10v_expand_builtin_va_arg): Some cleanups
	and an offset correction into the stack. Also remove the alignment
	correction.
	* config/d10v/d10v.c (d10v_stack_info): Look for stdargs only.
	* config/d10v/d10v.c : Remove prototype expander code.

	* config/d10v/d10v.h (AVOID_CCMODE_COPIES): Define.

	* config/d10v/d10v.md (beq,bne,bgt,blt,blr,bgtu,bgeu,bltu,bleu,
	cond_branch_0): Change to VOIDmode.
	* config/d10v/d10v.md (builtin_setjmp_setup): Generate registers
	properly.
	* config/d10v/d10v.md (longjump_internal_1): New.
	* config/d10v/d10v.md (builtin_longjump): Generate registers properly.
	* config/d10v/d10v-protos.h (d10v_build_va_list): New.
	* config/d10v/d10v-protos.h (d10v_expand_builtin_va_start): New.
	* config/d10v/d10v-protos.h (d10v_expand_builtin_va_arg): New.
	* config/d10v/d10v.c (comparison_mode): New.
	* config/d10v/d10v.c (d10v_build_va_list): New.
	* config/d10v/d10v.c (d10v_expand_builtin_va_start): New.
	* config/d10v/d10v.c (d10v_expand_builtin_va_arg): New.
	* config/d10v/d10v.h (TARGET_SWITCHES): Add switch descriptions for
	* config/d10v/d10v.h (TARGET_SWITCHES): Add switch descriptions for
	help.
	* config/d10v/d10v.h (AVOID_CCMODE_COPIES): Define to prevent copying
	to/from CCmode registers.
	* config/d10v/d10v.h (RETURN_ADDR_RTX): Define for
	__builtin_return_address.
	* config/d10v/d10v.h (BUILD_VA_LIST_TYPE): Define for va_list.
	* config/d10v/d10v.h (EXPAND_BUILTIN_VA_START): Define for va_start.
	* config/d10v/d10v.h (EXPAND_BUILTIN_VA_ARG): Define for va_arg.
	* config/d10v/d10v.h (DONT_USE_BUILTIN_SETJMP): Define.
	* config/d10v/d10v.h (JMP_BUF_SIZE): Define.

	From Jason Eckhardt
        * config/d10v/d10v.h (EXTRA_CONSTRAINT): Add R and S constraints
        for call operands (register and symbol, respectively).

        * config/d10v/d10v.md (call_value_internal1): Merged with...
        (call_value_internal2): Merged with call_value_internal1
        using new R and S contraints.

        * config/d10v/d10v.md (pushr, popr, pushwr, popwr): New.
        * config/d10v/d10v.md (return_internal): New.

	From Graham Stott  <grahams@cygnus.co.uk>
        * config/d10v/d10v.c (emit_cond_move): Handle EQ and NE tests
        for conditional moves.

        * config/d10v/d10v.md (addhi3, iordi3, xordi3, one_cmpldi2): Disable
	callers to d10v_split_logical_op for DImode.

	* Makefile.in (genattrtab): Remove dependency to HOST_GETRUNTIME.
	* config/float-d10v.h (FLT_EVAL_METHOD, DECIMAL_DIG): Add
	definitions.
	* config/d10v/svr4-d10v.h: New file.

2002-03-22  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/elf64.h: Change TARGET_DEFAULT to TARGET_CPU_DEFAULT.
	* config/mips/mips.c (mips_arg_info): Handle 128-bit GPRs.

2002-03-16  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/generic/generic.h: Update definitions to match changes
	introduced with merge from FSF sources.

2002-03-16  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h (ABI_GAS_ASM_SPEC): Remove duplicate default
	initialization.

2002-03-15  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (arm_override_options): Enable -msa1110-fix if
	the user has selected -mcpu=strongarm1110.

2002-03-03  Vladimir Makarov  <vmakarov@redhat.com>

	* sched-rgn.c (add_jump_labels): Keep LABEL_NUSES unchanged.

2002-02-20  Nick Clifton  <nickc@cambridge.redhat.com>

	* emit-rtl.c (gen_rtx_SUBREG): Remove references to
	SUBREG_REGNO_OFFSET since it is no longer used.
        (subreg_hardf_regno): Ditto.
        * rtlanal.c (subreg_lsb): Ditto.

2002-02-19  Andrew Cagney  <ac131313@redhat.com>

	* configure.in (hostxhost_overrides): Initialize to /dev/null.
	* configure: Re-generate.

2002-02-20  Ben Elliston  <bje@redhat.com>

	* genautomata.c (it_is_empty_reserv_sets): Remove unused function.
	(reserv_sets_and): Likewise.

2002-02-19  Graham Stott  <grahams@redhat.com>

	* config/i386/i386.c (print_operand): Fix typos.

	* config/i386/i386.c (ix86_expand_builtin): Set ICODE.

	* config/i386/i386.md ("cvtpd2dq", "cvttpd2dq", "cvtpd2ps",
	"sse2_uavgv16qi3", "sse2_uavgv8hi3", "sse2_movq2dq"): Use const_vector.

2002-02-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/d10v/d10v.md (movsi): Use find_replacement on the
        inner parts of subregs.

2002-02-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (TARGET_CANNOT_MODIFY_JUMPS_P): Define to...
	(sh_cannot_modify_jumps_p): New function.
	* bb-reorder.c (reorder_basic_blocks): Renamed CANNOT_MODIFY_JUMPS
	to target hook.
	* cfgcleanup.c (try_optimize_cfg): Likewise.
	* config/sh/sh64.h (CANNOT_MODIFY_JUMPS): Remove.
	* doc/tm.texi (CANNOT_MODIFY_JUMPS): Likewise.

2002-02-05  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (TARGET_MS_BITFIELD_LAYOUT_P): Define to...
	(sh_ms_bitfield_layout_p): New function.

2002-02-04  Alexandre Oliva  <aoliva@redhat.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* config/sh/sh.h (TRAMPOLINE_ADJUST_ADDRESS): Use
	expand_simple_binop instead of expand_binop.

2002-02-03  Alexandre Oliva  <aoliva@redhat.com>

	* rtl.h (any_cond_computed_jump_p): Removed declaration.

	* config/sh/sh.h (OVERRIDE_OPTIONS) [! TARGET_SH5]: Disable
	use of .quad and .uaquad.
	* config/sh/sh.c (TARGET_ASM_UNALIGNED_DI_OP,
	TARGET_ASM_ALIGNED_DI_OP): Add comment pointing to the above.

2002-01-30  Michael Meissner  <meissner@redhat.com>

	* config/mips/elf5000.h: New file to consolate VR5xxx
	configurations.


2002-01-25  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_output_int): Remove.
	* config/frv/frv.c (TARGET_ASM_INTEGER): Define.
	(frv_override_options): Nullify unaligned SI op when generating PIC.
	(frv_output_int): Replace with...
	(frv_assemble_integer): New function.  Handles .picptr as
	frv_output_int did.  Also handles .4byte when flag_pic.
	* config/frv/frv.h (ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT): Remove.
	(ASM_OUTPUT_CHAR, ASM_OUTPUT_SHORT, ASM_OUTPUT_INT): Remove.
	(ASM_OUTPUT_BYTE, ASM_OUTPUT_DWARF2_ADDR_CONST): Remove.

2002-01-24  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (movdi_const, movdi_const_32bit,
	movdi_const_16bit): Make sure all CONSTs have modes.
	(sym2PIC): Ditto, but by adjusting all callers.

	* config/sh/sh.c (calc_live_regs) [TARGET_SHCOMPACT]: Set pr_live
	if the prologue calls the SHmedia argument decoder or register
	saver.

2002-01-24  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (TARGET_ASM_UNALIGNED_DI_OP): Define.
	(TARGET_ASM_ALIGNED_DI_OP): Likewise.
	(sh_expand_epilogue): Don't emit USE of return target register.
	(prepare_move_operands): Legitimize DImode PIC addresses.
	(sh_media_register_for_return): Skip tr0, used to initialize the
	PIC register.
	(sh_expand_prologue): Remove explicit USE of return register.
	(nonpic_symbol_mentioned_p): PC is non-PIC.  Don't recurse in
	CONST_DOUBLEs.  UNSPEC_GOTPLT is PIC.
	* config/sh/sh.h (ASM_OUTPUT_DOUBLE_INT): Removed, obsolete.
	(OVERRIDE_OPTIONS): Don't disable PIC on SH5.
	(EXTRA_CONSTRAINT_S): Use MOVI_SHORI_BASE_OPERAND_P instead of
	EXTRA_CONSTRAINT_T.
	(GOT_ENTRY_P, GOTPLT_ENTRY_P, GOTOFF_P, PIC_ADDR_P): New.
	(MOVI_SHORI_BASE_OPERAND_P): New.
	(NON_PIC_REFERENCE_P, PIC_REFERENCE_P): New.
	(EXTRA_CONSTRAINT_T): Define in terms of them.
	(OUTPUT_ADDR_CONST_EXTRA): Handle UNSPEC_GOTPLT.
	* config/sh/sh.md (movsi_media, movsi_media_nofpu,
	movdi_media, movdi_media_nofpu): Add SIBCALL_REGS class to
	alternatives supporting TARGET_REGS.
	(UNSPEC_GOTPLT): New constant.
	(movdi split): Move incrementing of LABEL_NUSES...
	(movdi_const, movdi_const_32bit): Here.  Use
	MOVI_SHORI_BASE_OPERAND_P instead of EXTRA_CONSTRAINT_T.
	(movdi_const_16bit): New.
	(call, call_value) [flag_pic]: Use GOTPLT.
	(call_pop, call_value_pop): New expands.
	(call_pop_compact, call_pop_rettramp): New insns.
	(call_value_pop_compact, call_value_pop_rettramp): New insns.
	(sibcall) [flag_pic]: Use GOT.
	(builtint_setjmp_receiver): Remove bogus, unused expand.
	(GOTaddr2picreg): Implement for SHcompact and SHmedia.
	(*pt, *ptb, ptrel): New insns.
	(sym2GOT): Handle DImode GOT.
	(sym2GOTPLT, symGOTPLT2reg): New expands.
	(sym2PIC): New expand.
	(shcompact_return_tramp): Use GOTPLT to return trampoline.
	(shcompact_return_tramp_i): Use return register explicitly.

	* bb-reorder.c (reorder_basic_blocks): Take
	CANNOT_MODIFY_JUMPS into account.
	* cfgcleanup.c (try_optimize_cfg): Likewise.
	* config/sh/sh.h (OVERRIDE_OPTIONS) [TARGET_SHMEDIA]: Don't
	disable flag_reorder_blocks.
	* config/sh/sh64.h (CANNOT_MODIFY_JUMPS): Define.
	* doc/tm.texi (CANNOT_MODIFY_JUMPS): Document it.

2002-01-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (sibcall_compact): Reorder return, uses and
	clobbers, for clarity.
	(sibcall_epilogue) [TARGET_SHCOMPACT]: Mark saving and
	restoring of r0 in macl as MAYBE_DEAD.

2002-01-18  Aldy Hernandez  <aldyh@redhat.com>

        * config/arm/arm.h (TARGET_DEFAULT): Remove CIRRUS_FIX_INVALID_INSNS
        from Cirrus default.

2002-01-18  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (LONG_DOUBLE_TYPE_SIZE): Define.
	* config/sh/sh.md (movv4sf_i, movv16sf_i): Fix uses of
	alter_subreg all over.
	(jump) [TARGET_SHMEDIA]: FAIL to create new jumps after
	reload, instead of emitting instructions that would require
	reloading.
	(casesi_load_media): Add missing modes.

2002-01-12  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.h (CONSTANT_POOL_BEFORE_FUNCTION): Define.
	Return false for THUMB targets.
	(SELECT_RTX_SECTION): Use text section for THUMB targets.

2001-12-19  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (output_move_double): Suppress abort when
	IP is the ource register in a double word move.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* ifcvt.c (find_if_header): Change the NEW_IFCVT_INTERFACE version
	of this function so that it returns the first block of the converted
	condition on success.
	(if_convert): Change the NEW_IFCVT_INTERFACE version accordingly.
	Don't assume the block passed to find_if_header is still valid
	on its return.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_unique_section): Declare.
	* config/frv/frv.h (UNIQUE_SECTION): Define.  Use frv_unique_section.
	* config/frv/frv.c (frv_string_begins_with): New helper function.
	(frv_encode_section_info): Rework.  Don't let articifial decls
	into the small data section, but reallow comdat objects.
	(small_data_register_operand): Don't return false just because
	-G 0 was given on the command-line.  Objects can still be put
	into the small data section using explicit attributes.
	(small_data_symbolic_operand): Likewise.
	(frv_unique_section): New.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (move_source_operand): Use immediate_operand
	to check whether constant operands are OK.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (*internal_movcc): Make the splitter use
	simplify_gen_subreg instead of gen_rtx_SUBREG.
	(*internal_movcc_uns, *movcc_fp_internal, movcc_ccr): Likewise.
	(reload_incc_fp, reload_incc_ccr): Use simplify_gen_subreg.

2001-12-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (frv_load_operand): Declare.
	* config/frv/frv.c (frv_load_operand): New operand predicate.
	* config/frv/frv.h (PREDICATE_CODES): Mention frv_load_operand.
	* config/frv/frv.md (*movqi_load): Use frv_load_operand.
	(*movhi_load, *movsi_load, *movsf_load_has_fprs): Likewise.

2001-12-13  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/linux.h (LINK_SPEC): Rename the dynamic linker
	from ld-linux.so.2 to ld.so.1.

	* config/d10v/d10v.h (PREFERRED_RELOAD_CLASS): Don't use EVEN_REGS
	when we need ACCUM_REGS and we have them.



2001-12-03  Bernd Schmidt  <bernds@redhat.com>

	* config/i386/i386.h (ASM_OUTPUT_LABEL): Delete cygnus local version.

	Re-apply a patch, this time with sanitize markers.
	* config/i386/i386.c (general_no_elim_operand): arg_pointer_rtx is
	eliminable only if ! TARGET_FORCE_STACK_ALIGNMENT.
	(nonmemory_no_elim_operand): Likewise.

2001-11-22  Bernd Schmidt  <bernds@redhat.com>

	* c-common.c (type_for_mode): Add support for V2DFmode.
	* tree.c (build_common_tree_nodes_2): Likewise.
	* tree.h (enum tree_index): Likewise.
	(V2DF_type_node): Define.

	* config/i386/i386.c (bdesc_comi, bdesc_2arg, bdesc_1arg): Add SSE2
	entries.
	(init_mmx_sse_builtins): Initialize SSE2 builtins.
	(ix86_expand_store_builtin): Generate shufpd rather than shufps if
	this is an SSE2 store.
	(ix86_expand_builtin): Add support for SSE2 builtins.
	* config/i386/i386.h (VALID_SSE2_REG_MODE): New macro.
	(VALID_SSE_REG_MODE): Use it.
	(enum ix86_builtins): Add SSE2 builtins.
	* config/i386/i386.md (movv2df_internal, movv2df, movv8hi_internal,
	movv8hi, movv16qi_internal, movv16qi, pushv2df, pushv8hi, pushv16qi,
	addv2df3, vmaddv2df3, subv2df3, vmsubv2df3, mulv2df3, vmmulv2df3,
	divv2df3, vmdivv2df3, smaxv2df3, vmsmaxv2df3, sminv2df3, vmsminv2df3,
	sse2_anddf3, sse2_nanddf3, sse2_iordf3, sse2_xordf3, sqrtv2df2,
	vmsqrtv2df2, maskcmpv2df3, maskncmpv2df3, vmmaskcmpv2df3,
	vmmaskncmpv2df3, sse2_comi, sse2_ucomi, sse2_movmskpd, sse2_pmovmskb,
	sse2_maskmovdqu, sse2_movntv2df, sse2_movntti, sse2_movntsi, cvtdq2ps,
	cvtps2dq, cvttps2dq, cvtdq2pd, cvtpd2dq, cvttpd2dq, cvtpd2pi,
	cvttpd2pi, cvtpi2pd, cvtsd2si, cvttsd2si, cvtsi2sd, cvtsd2ss,
	cvtss2sd, cvtpd2ps, cvtps2pd, addv16qi3, addv8hi3, addv4si3, addv2di3,
	ssaddv16qi3, ssaddv8hi3, usaddv16qi3, usaddv8hi3, subv16qi3, subv8hi3,
	subv4si3, subv2di3, sssubv16qi3, sssubv8hi3, ussubv16qi3, ussubv8hi3,
	mulv8hi3, smulv8hi3_highpart, umulv8hi3_highpart, sse2_umulsidi3,
	sse2_umulv2siv2di3, sse2_pmaddwd, sse2_iorti3, sse2_xorti3,
	sse2_clrti, sse2_andti3, sse2_nandti3, sse2_uavgv16qi3,
	sse2_uavgv8hi3, sse2_psadbw, sse2_pinsrw, sse2_pextrw, sse2_pshufd,
	sse2_pshuflw, sse2_pshufhw, eqv16qi3, eqv8hi3, eqv4si3, gtv16qi3,
	gtv8hi3, gtv4si3, umaxv16qi3, smaxv8hi3, uminv16qi3, sminv8hi3,
	ashrv8hi3, ashrv4si3, lshrv8hi3, lshrv4si3, sse2_lshrv2di3,
	ashlv8hi3, ashlv4si3, sse2_ashlv2di3, sse2_ashlti3, sse2_lshrti3,
	sse2_unpckhpd, sse2_unpcklpd, sse2_packsswb, sse2_packssdw,
	sse2_packuswb, sse2_punpckhbw, sse2_punpckhwd, sse2_punpckhdq,
	sse2_punpcklbw, sse2_punpcklwd, sse2_punpckldq, sse2_movapd,
	sse2_movupd, sse2_movdqa, sse2_movdqu, sse2_movdq2q, sse2_movq2dq,
	sse2_movhpd, sse2_movlpd, sse2_loadsd, sse2_movsd, sse2_storesd,
	sse2_shufpd): New patterns.
	* config/i386/xmmintrin.h: Add support for SSE2 builtins.

2001-11-20  Angela Marie Thomas  <angela@redhat.com>

	* Makefile.in (ALL): Change default target to all.redhat.
	(all.redhat) New target.
	(INSTALL_TARGET) Change default to install-redhat.
	(install-redhat) New target.

2001-11-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/cmovh.c (_cmovh): Add an extra underscore to name.
	* config/frv/cmovw.c (_cmovw): Likewise.
	* config/frv/cmovd.c (_cmovd): Likewise.
	* config/frv/frv-abi.h (CREATE_DOUBLE_SHIFT): New macro.
	(__ashldi3): Use the above to create an ABI-conformant version.
	(__lshrdi3, __ashrdi3): Likewise.
	(__muldi3): Create __umulll() alias.
	* config/frv/frv.h (INIT_OPTAB_HANDLERS): Remove shift entries.
	* config/frv/lib1funcs.asm (_cmpll): Add an extra underscore to name.
	(_cmpf, _cmpd, _addll, _subll): Likewise.
	(_andll, _orll, _xorll, _notll, _cmov): Likewise.
	* config/frv/modi.c: New file.
	* config/frv/umodi.c: New file.
	* config/frv/uitof.c: New file.
	* config/frv/uitod.c: New file.
	* config/frv/ulltof.c: New file.
	* config/frv/ulltod.c: New file.
	* config/frv/t-frv (LIB2FUNCS_EXTRA): Add the new files listed
	above.  Add new makefile rules for them.

2001-11-18  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/linux.h (LINK_SPEC): -lpthread, not -lthread.

	* config/sh/linux.h (LINK_SPEC): Don't handle -Wl,-rpath nor
	-Wl,-rpath-link.
	(LIB_SPEC): Add -rpath-link if !static.
	* config/mn10300/linux.h (LINK_SPEC): Don't handle -Wl,-rpath
	nor -Wl,-rpath-link.
	(LIB_SPEC): Add -rpath-link if !static.
	* gcc.c (process_command): Don't re-feed -Wl,foo to the specs
	engine as foo.  Don't increment n_switches when processing -Wl,*.

2001-11-17  Bernd Schmidt  <bernds@redhat.com>

	* config/i386/i386.c (ix86_expand_prologue): Move call to
	ix86_compute_frame_size down past stack alignment code.
	(ix86_expand_prologue_fsa): Use ix86_compute_frame_size.
	(ix86_expand_epilogue_fsa): Likewise.

2001-11-17  Graham Stott  <grahams@redhat.com>

	* config/i386/xmm_utils.h (CASE1, CASE2, CASE4, CASE8, CASE16,
	CASE32, CASE64, CASE128, CASE256): Fix macro varargs to conform to
	what current preprocessors expect.
	* config/i386/xmmintrin.h (_mm_andnot_ps): Call builtin by its right
	name.
	(_mm_store_ps, _mm_load_ps, _mm_getcsr, _mm_setcsr): Likewise.
	(_mm_cvt_si2ss, _mm_cvt_pi2ps): Call builtin with proper number of
	args.
	(_mm_set_ps, _mm_setr_ps): Likewise.
	(_mm_shuffle_ps): Fix placement of parenthesis.
	(_mm_move_ss): Likewise.
	(_mm_movemask_ps): Cast to right type.
	(_mm_cvtpi16_ps, _mm_cvtpu16_ps): Fix typo.

	* config/i386/beos-elf.h (FSA_STRIP_ENCODING): Delete.
	* config/i386/cygwin.h (FSA_STRIP_ENCODING): Delete.
	(ASM_OUTPUT_LABEL): Delete.
	(STRIP_NAME_ENCODING): Remove cygnus local code.
	* config/i386/i386-aout.h (ASM_DECLARE_FUNCTION_NAME): Delete.
	(ASM_DECLARE_FUNCTION_SIZE): Delete #undef.
	* config/i386/i386-coff.h (ASM_DECLARE_FUNCTION_NAME): Delete.
	(ASM_DECLARE_FUNCTION_SIZE): Delete #undef.
	* config/i386/i386.c: Include "c-tree.h".
	(ix86_same_file_name_p): New function.
	(build_aligned_name): Constify one local variable.
	(ix86_encode_section_info): Delete.
	(output_pic_addr_const, print_operand, print_operand_address): Use
	new method of determining whether a given symbol was defined in the
	same file.
	* config/i386/i386.h (ASM_DECLARE_FUNCTION_NAME): Delete.
	(ASM_DECLARE_FUNCTION_SIZE): Delete.
	(SAME_FILE_CHAR, SAME_FILE_NAME_P, STRIP_NAME_ENCODING): Delete.
	(ENCODE_SECTION_INFO): Delete.
	(DOT_ALIGNED): New macro.
	(BUILD_ALIGNED_NAME): Small optimizations.
	* config/i386/linux-aout.h (ASM_DECLARE_FUNCTION_NAME): Delete.
	(ASM_DECLARE_FUNCTION_SIZE): Delete #undef.
	* config/i386/win32.h (STRIP_NAME_ENCODING): Delete cygnus local code.
	(ENCODE_SECTION_INFO): Likewise.
	* config/i386/winnt.c (i386_pe_encode_section_info): Likewise.
	(i386_pe_declare_function_type): Likewise.

	* config/i386/i386.h (enum processor_type): Adjust order to match
	machine description.

2001-11-17  Bernd Schmidt  <bernds@redhat.com>

	* config/i386/i386.h (MAX_INTEGER_COMPUTATION_OK): Use TARGET_SSE,
	not TARGET_SIMD.
	* config/i386/i386.c (init_cumulative_args): Likewise.
	(function_arg_advance): Likewise.
	(ix86_function_arg_boundary): Likewise.

2001-11-15  Bernd Schmidt  <bernds@redhat.com>
	    Graham Stott  <grahams@redhat.com>

	* config/i386/i386-protos.h (ix86_initial_elimination_offset_fsa,
	ix86_expand_epilogue_fsa): Adjust prototypes.
	* config/i386/i386.c (general_no_elim_operand): arg_pointer_rtx is
	eliminable only if ! TARGET_FORCE_STACK_ALIGNMENT.
	(nonmemory_no_elim_operand): Likewise.
	(ix86_expand_prologue_fsa): Emit a barrier after unconditional jump.
	Fix alignment calculation (bit/byte confusion).
	Create a REG_MAYBE_DEAD note for arg pointer.
	Use hard_frame_pointer_rtx rather than frame_pointer_rtx.
	(ix86_expand_epilogue): Always call fsa variant regardless of STYLE,
	but pass STYLE down to that function.
	(ix86_expand_epilogue_fsa): New argument STYLE.
	Use it as ix86_expand_epilogue does.
	Use hard_frame_pointer_rtx rather than frame_pointer_rtx.
	(ix86_initial_elimination_offset_fsa): Take two args like the normal
	variant.  Return 0 for non fp->sp eliminations.
	(print_reg): Do print the arg pointer if it's %esi and not the dummy
	argp reg.
	* config/i386/i386.h (TARGET_FORCE_STACK_ALIGNMENT): Define to
	TARGET_SSE.
	(INITIAL_ELIMINATION_OFFSET): Update to call fsa variant with
	arguments.


2001-11-14  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/t-xscale-elf (LIB2FUNCS_EXTRA): Define.
	* config/arm/t-arm-elf  (LIB2FUNCS_EXTRA): Define.
	* config/arm/lib1funcs.asm: Remove dummy __bb_init_func
	* config/arm/arm_bb_funcs.c: New file.  Simple implementation
	of __bb_init_func.

2001-11-14  Richard Sandiford  <rsandifo@redhat.com>

	* t-frv (MULTILIB_OPTIONS): Build packed libraries.
	(MULTILIB_DIRNAMES): Update accordingly.
	(MULTILIB_EXCEPTIONS): Don't build unpacked libraries for
	-mcpu=simple and -mcpu=frv.

2001-11-13  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (install-common): Fix location of fixproto source
	script.
	(insn-recog.o): Remove no longer necessary 99r1 hack.

2001-11-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (sh_expand_prologue): Mark the PIC register
	as used if the argument decoder is called.

2001-11-04  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md (builtin_setjmp_receiver): Fix typo in
	pattern name.
	(mn10300_loadPC): Define as insn splittable after reload.

2001-11-02  Jeffrey A Law  (law@cygnus.com)

	* c-format.c (compare_format_types): Fix ISO C portability
	glitch.
	(skip_and_copy): Similarly.

2001-10-26  Jeff Holcomb  <jeffh@redhat.com>

	* range.c (range_update_basic_block): Convert Ansi prototype
	to K&R form.

2001-10-26  Richard Sandiford  <rsandifo@redhat.com>

	* ifcvt.c (if_convert): Change the NEW_IFCVT_INTERFACE version
	of this function to use UPDATE_GLOBAL_RM_NOTES.  Add a comment
	explaining why.

2001-10-09  Eric Christopher  <echristo@redhat.com>

	* config.gcc: Remove mips3264 sanitization.
	* config/mips/isa32-linux.h: Ditto.
	* config/mips/isa3264.h: Ditto.
	* config/mips/mips.c: Ditto.
	* config/mips/mips.h: Ditto.
	* config/mips/mips.md: Ditto.
	* config/mips/t-isa3264: Import changes from net.
	* config/mips/linux.h: Ditto.

2001-10-03  Vladimir Makarov  <vmakarov@toribio.toronto.redhat.com>

	2001-10-02  David S. Miller  <davem@redhat.com>

	* haifa-sched.c (advance_one_cycle): New function.
	(schedule_block): Use it.
	(queue_to_ready): Use it, and also make sure to advance the DFA
	state on all stall cycles, not just those where insn_queue links
	are found.

2001-10-02  Richard Sandiford  <rsandifo@redhat.com>

	* haifa-sched.c (max_issue): Remove last_p argument.  Only return
	non-zero if the highest-priority instruction could be scheduled.
	(choose_ready): Remove last argument from max_issue call.

2001-09-26  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (HAVE_POST_INCREMENT): Undefine.
	(HAVE_POST_DECREMENT): Undefine.
	(HAVE_POST_MODIFY_REG): Undefine.
	(HAVE_PRE_MODIFY_REG): Define to 1.
	* config/frv/frv.md (mbtohe): Reverse order of stores.
	(mdunpacke): Likewise.
	* config/frv/frv.c (frv_index_memory): Rework for pre-modification.
	(frv_split_double_load): Likewise.
	(frv_split_double_store): Likewise.
	(frv_print_operand_memory_reference): Change POST_MODIFY to PRE_MODIFY.
	(frv_print_operand): Likewise.
	(frv_legitimate_address_p): Likewise.
	(frv_registers_update): Change POST_MODIFY to PRE_MODIFY.  Remove
	POST_INC and POST_DEC handling.
	(frv_registers_set_p): Likewise.

2001-09-24  Richard Sandiford  <rsandifo@redhat.com>

	Tweak scheduling after spec change.
	* config/frv/frv.md (i2_gload): Set latency to four cycles.
	(m3, m6): Set latency to two cycles.  Add 1-cycle bypass to m4.
	(fr400_i1_mul): Use WAW latency instead of RAW one.
	(fr400_i1_div, fr400_i2_gload): Likewise.
	(fr400_i2_fload): Add a 3-cycle bypass to media units.
	(fr400_m1*, fr400_m3*): Change to a fixed single-cycle latency.
	(fr400_m4*): Add a 1-cycle bypass to movfg and fstore units.

2001-09-20  Andrew Haley  <aph@cambridge.redhat.com>

        * gcc.c (include_after_prefixes): New.
        (process_command): Use include_after_prefixes for system include
        files.
        (do_spec_1): Add include_after_prefixes to end of system include
        list.

2001-09-18  Nick Clifton  <nickc@cambridge.redhat.com>

	* config.gcc: Import changes from FSF version, missed during
	recent merge.

2001-09-14  Nick Clifton  <nickc@cambridge.redhat.com>

	* cfganal.c (flow_depth_first_order_compute): Oops - patch
	missed from egcs merge.

2001-09-14  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv-protos.h (uint5_operand): Declare.
	(uint4_operand): Declare.
	(uint1_operand): Declare.
	* config/frv/frv.h (PREDICATE_CODES): Add the above.
	* config/frv/media.h (ACC_T, ACCG_T): Change typedef to int.
	(IMM12, IMM6, IMM5): Likewise.
	(UIMM5, UIMM4, UIMM1): New types, also defined to int.
	(__MROTLI, __MROTRI, __MDROTLI, __MCPLI): Take UIMM5 arguments.
	(__MSLLHI, __MSRLHI, __MSRAHI, __MCPLHI): Take UIMM4 arguments.
	(__MEXPDHW, __MEXPDHD): Take UIMM1 arguments.
	* config/frv/frv.md (insn_reservation m1): Add mqaddh.
	(mrotli, mrotri, *mrot, mdrotli): Require uimm5_operand.
	(msllhi, msrlhi, msrahi, *mshift): Require uimm4_operand.
	(mexpdhw, *cond_exec_mexpdhw): Require uimm1_operand.
	(mexpdhd, *cond_exec_mexpdhd): Likewise.
	(UNSPEC_MCPL): Remove constant, split into...
	(UNSPEC_MCPLHI, UNSPEC_MCPLI): New constants.
	(mcplhi, mcpli): Change to define_insns.  Make mcplhi require
	uint4_operand and mcpli require uint5_operand.
	(*mcpl): Remove.
	* config/frv/frv.c (frv_int_to_acc): Change interface so that
	it takes the insn code and operand number of the accumulator.
	Use operand's predicate to choose between ACCs and ACCGs.
	(frv_expand_voidtriop_builtin): Remove register size argument.
	(frv_expand_voidaccop_builtin): Likewise.
	(uint5_operand, uint4_operand, uint1_operand): New.
	(bdesc_void3arg_1acc, bdesc_void3arg_2acc, bdesc_void3arg_4acc):
	Remove, merging contents into...
	(bdesc_void3arg): New array.
	(bdesc_voidacc_2acc, bdesc_voidacc_4acc): Remove, merge into...
	(bdesc_void3arg): New array.
	(frv_init_builtins): Rework to make link with media.h clearer.
	(frv_expand_builtin): Adjust for above changes.

2001-09-14  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c: Minor formatting tweaks.

2001-09-13  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.c: Add optabs.h to includes.

2001-09-13  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.md (consttable_qi, consttable_hi, consttable_si
	consttable_di): Fix merge of assemble_integer.
	(consttable_sf, consttable_df): Ditto for assemble_real.

2001-09-12  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (condexec_sf_unary_operator): Remove.
	(condexec_si_media_operator): Declare.
	(condexec_sf_conv_operator): Declare.
	(condexec_sf_add_operator): Declare.
	* frv.c (condexec_si_binary_operator): Don't check the operands' class.
	(condexec_si_divide_operator): Likewise.
	(condexec_si_unary_operator): Likewise.
	(condexec_sf_binary_operator): Remove.
	(condexec_si_media_operator): New.
	(condexec_sf_conv_operator): New.
	(condexec_sf_add_operator): New.
	(output_condmove_single): Only handle move instructions.
	* frv.md (type fsingle): Split into fsconv and fsadd.
	(type fdouble): Split into fdconv and fdadd.
	(insn_reservation f1): Take type fsconv and fdconv.  Don't use adder.
	(insn_reservation f2): Take type fsadd and fdadd.
	(insn_reservation fr400_m1_1): Take fsconv instead of fsingle.
	(cpu_units par0, par1, dmul, dual): Remove.
	(insn_reservation f5): Use an adder and multiplier instead of par.
	(insn_reservation f6): Use both adders instead of dual.
	(insn_reservation f7): Use both multipliers instead of dmul.
	(*movqi_internal, *cond_exec_movqi): Give FP->FP moves type fsconv.
	(*movhi_internal, *cond_exec_movhi): Likewise.
	(*movsi_internal, *cond_exec_movsi): Likewise.
	(*movsf_internal_has_fprs, *cond_exec_movsf_has_fprs): Likewise.
	(floatsisf2, fix_truncsfsi2, negsf2, abssf2): Change to type fsconv.
	(*cond_exec_cmpsi_cc_fp): Likewise.
	(addsf3, subsf3, *cmpsf_cc_fp): Change to type fsadd.
	(*movdi_double, *movdf_double): Give FP->FP moves type fdconv.
	(floatsidf2, fix_truncdfsi2, negdf2, absdf2): Change to type fdconv.
	(adddf3, subdf3, *cmpdf_cc_fp): Change to type fdadd.
	(*cond_exec_si_binary1): Replace call to output_condmove_single
	with a switch statement.
	(*cond_exec_si_divide): Likewise.
	(*cond_exec_si_unary1): Likewise.
	(*cond_exec_si_binary2): Likewise.  Use condexec_si_media_operator.
	(*cond_exec_si_unary2): Replace (match_operator ...) with (not ...).
	(*cond_exec_sf_unary): Remove.  Split into...
	(*cond_exec_sf_conv, *cond_exec_sf_sqrt): New.
	(*cond_exec_sf_binary): Remove.  Split into...
	(*cond_exec_sf_add, *cond_exec_sf_mul, *cond_exec_sf_div): New.

2001-09-12  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (andsi3_media): Don't disparage FPR alternative.
	(iorsi3_media): Likewise.
	(xorsi3_media): Likewise.
	(one_cmplsi2_media): Likewise.

2001-09-12  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (insn_reservation m2): Move mmulh and mmulxh to...
	(insn_reservation m4): ...here.
	(insn_reservation m6): Move (single) mclracc to...
	(insn_reservation m3): ...here.

2001-09-12  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_final_prescan_insn): Rework.  Fix
	handling of 4-instruction packets.

2001-09-07  Aldy Hernandez  <aldyh@redhat.com>

	* config/mips/mips.h: (GAS_ASM_SPEC): Do not set mips2 on mabi=32 if
        MIPS_CPU_STRING_DEFAULT is defined.

2001-09-07  Aldy Hernandez  <aldyh@redhat.com>

        * elfl5000.h (SUBTARGET_CPP_SIZE_SPEC): Add mgp32 and mgp64.

        * elfb5000.h (SUBTARGET_CPP_SIZE_SPEC): Likewise.

2001-09-04  Andrew MacLeod  <amacleod@redhat.com>

	* flags.h (flag_gcse_libcall): New flag.
	* gcse.c (oprs_anticipatable_p): Only process RETVAL note if
	gcse_flag_libcall is on.
	(insert_expr_in_table): Initialize expressions 'insn' field.
	(insert_set_in_table): Initialize expressions 'insn' field.
	(hash_scan_set): Add missing code to add required extra dependancies
	if a libcall is flagged for possible commoning.
	(compute_hash_table): Treat insns with RETVAL notes as if they are
	still inside the libcall for expressions.
	(process_insert_insn): Honor flag_gcse_libcall.
	(pre_delete): Ignore RETVALs notes if we aren't processing libcalls.
	* toplev.c (flag_gcse_libcall): Initialize.
	(lang_independent_options): Add -fgcse-libcall option.
	* doc/invoke.texi (-fgcse-libcall): Add usage documentation.

2001-08-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (udivsi3, divsi3): Load libcall symbol name in
	Pmode, then extend it to DImode if necessary.

2001-08-28  Stephen Clarke  <Stephen.Clarke@st.com>

	* config/sh/sh.h (LEGITIMATE_CONSTANT_P): Don't accept DFmode
	constants in FPU-enabled SHmedia, let them be loaded from memory.

2001-08-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (cmpeqdi_media, cmpgtdi_media, cmpgtudi_media):
	Adjust whitespace in assembly output templates.

2001-08-28  Stephen Clarke  <Stephen.Clarke@st.com>

	* config/sh/sh.md (movdicc_false, movdicc_true, movdicc): Adjust
	mode of if_then_else.

2001-08-23  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.h (CPP_SPEC): Undefine __FRV_VLIW__ given -mno-pack.

2001-08-22  Dave Brolley  <brolley@redhat.com>

	* config/frv/frv.h (ASM_SPEC): Add mno-pack.

2001-08-22  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (mn10300_protect_label): New
	variable.
	* config/mn10300/linux.h (PRINT_OPERAND,
	PRINT_OPERAND_ADDRESS): Set it during their execution.
	(ASM_OUTPUT_LABELREF): Output `+' before symbol name if
	mn10300_protect_label is set.

	* config/mn10300/linux.h (LINK_SPEC): Recognize -Wl,-rpath and
	-Wl,-rpath-link.
	(LIB_SPEC, STARTFILE_SPEC): Define.

2001-08-20  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h: Fix abi_gas_asm_spec for default configuration.

2001-08-18  Graham Stott  <grahams@redhat.com>

	* config/mips/mips.md (xmulsi3_highpart_mulhi): Make SIGN and ZERO static.
	(xmulsi3_neg_highpart_mulhi) Likewise.

2001-08-18  Graham Stott  <grahams@redhat.com>

	* config/mips/mips.md (define_attr "cpu"): Add r5200.

2001-08-14  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/arm/arm.c (output_move_double): Fix ICE revealed by
	gcc testsuite.

2001-08-12  Richard Henderson  <rth@redhat.com>

	* config/stormy16/stormy16.c (stormy16_encode_section_info): New.
	(stormy16_print_operand): Add 'C'.
	* config/stormy16/stormy16-protos.h: Update.
	* config/stormy16/stormy16.h (ENCODE_SECTION_INFO): New.
	(ASM_OUTPUT_SYMBOL_REF): New.
	* config/stormy16/stormy16.md (call patterns): Use %C for callf.

2001-08-10  Aldy Hernandez  <aldyh@redhat.com>

	* config/mips/mips.md (*muls): Check for TARGET_64BIT.
	(xmulsi3_highpart_mulhi): Likewise.
	(smulsi3_highpart): Likewise.
	(umulsi3_highpart): Likewise.
	(*xmulsi3_neg_highpart_mulhi): Likewise.
	(xmulsi3_highpart_internal): Likewise.
	(*mul_acc_si): Likewise.
	(*msac): Likewise.

2001-08-09  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.md (movsi_internal): Post-increment
	and pre-decrement operands must not conflict with register
	outputs.
	* config/stormy16/stormy16.c (stormy16_split_move):
	Better handle cases where operands overlap.

	* config/stormy16/stormy16.md (udivmodhi4): Operand 2 should
	be a register.

	* config/stormy16/stormy16.h (RETURN_ADDR_RTX): Must return a
	Pmode result, even though that is unhelpful.

	* config/stormy16/stormy16.c (stormy16_output_cbranch_hi):
	Correct the offset of the long jumps.

	* config/stormy16/stormy16.h (FUNCTION_ARG_ADVANCE): Use
	stormy16_function_arg_advance.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_function_arg_advance.
	* config/stormy16/stormy16.c (stormy16_function_arg_advance):
	New function.
	(stormy16_expand_builtin_va_arg): Correct increment
	of offsets for stack operands.

2001-08-10  Aldy Hernandez  <aldyh@redhat.com>

	* config/mips/mips.md (*muls): Check for TARGET_64BIT.
	(xmulsi3_highpart_mulhi): Likewise.
	(smulsi3_highpart): Likewise.
	(umulsi3_highpart): Likewise.
	(*xmulsi3_neg_highpart_mulhi): Likewise.

2001-08-09  Catherine Moore  <clm@redhat.com>

	* config.gcc:  Set up the tm_p.h file for v850e and v850ea.

2001-08-09  Geoffrey Keating  <geoffk@redhat.com>

	* stormy16/stormy16.c (stormy16_ineqsi_operator): New function.
	(equality_operator): New function.
	(inequality_operator): New function.
	(stormy16_emit_cbranch): Handle SImode branches.
	(stormy16_split_cbranch): New function.
	(stormy16_output_cbranch_hi): Renamed from stormy16_output_cbranch;
	correct problem with swapping arguments for EQ/NE comparisons,
	correct problem with branching over jmpf.
	(stormy16_output_cbranch_si): New function.
	(stormy16_expand_arith): Handle compare operations.
	* stormy16/stormy16.h (PREDICATE_CODES): Add stormy16_ineqsi_operator,
	equality_operator, inequality_operator.
	* stormy16/stormy16-protos.h: Rename stormy16_output_cbranch to
	stormy16_output_cbranch_hi; add stormy16_ineqsi_operator,
	equality_operator, inequality_operator, stormy16_split_cbranch,
	stormy16_output_cbranch_si.
	* stormy16/stormy16.md (attr branch_class): Add new values
	bcc8p2, bcc8p4.
	(attr length): Set defaults for new branch classes.
	(cmpsi): New pattern.
	(cbranchhi): Rename from cbranch. Add carry clobber.
	(cbranchhi_neg): Likewise.
	(eqbranchsi): New.
	(ineqbranchsi): New.
	(ineqbranch_1): New.

	* stormy16/stormy16.c (stormy16_initialize_trampoline): Set
	the STATIC_CHAIN_REGNUM.

	* stormy16/stormy16.md (reload_inhi): Set mode of clobber.
	(subchi5): Operand 1 is not commutative.
	(subsi3): Likewise.

2001-08-08  Eric Christopher  <echristo@redhat.com>

	* config.gcc: Remove CPU masks from target_cpu_default.
	* config/mips/mips.c: Bring in sanitized parts of march/mtune patch.
	* config/mips/mips.h: Ditto.
	* config/mips/mips.md: Ditto.

2001-08-08  Nick Clifton  <nickc@cambridge.redhat.com>

	* config/v850/v850.h: Fix compile time warning about use of
	#elif.

2001-08-04  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh64.h (CPP_DEFAULT_CPU_SPEC): Override definition in
	sh.h.

2001-07-31  Stan Cox  <scox@redhat.com>

	* Makefile.in (check-g++-perennial):  New.

2001-07-30  Aldy Hernandez  <aldyh@redhat.com>

	* gcc.c (print_multilib_info): Move last_path
	initialization before multilib_redundant_dirs use.

2001-07-27  Geoffrey Keating  <geoffk@redhat.com>

	* config.gcc (stormy16-*-elf): Use t-stormy16.  Generate
	crtbegin and crtend.
	* stormy16/stormy16-lib2.c: New file.
	* stormy16/t-stormy16: New file.
	* stormy16/stormy16.h (LIB_SPEC): Use paren options, use -lsim
	only when -msim is passed.
	(TARGET_SWITCHES): Document -msim.
	(CTORS_SECTION_ASM_OP): New macro, don't make writable.
	(DTORS_SECTION_ASM_OP): New macro, don't make writable.

2001-07-26  Andrew Haley  <aph@cambridge.redhat.com>
	Joern Rennecke <amylaar@redhat.com>

	* config/sh/sh64.h (CPP_DEFAULT_CPU_SPEC): New.
	(SUBTARGET_CPP_PTR_SPEC): New.
	(SUBTARGET_CPP_SPEC): Remove.

2001-07-25  Andrew Haley  <aph@cambridge.redhat.com>

	* config/sh/linux.h: Add %R to shared lib search paths for
	host-x-host.

2001-07-18  Angela Marie Thomas <angela@cygnus.com>
	Brendan Kehoe <brendan@cygnus.com>
	Nick Clifton <nickc@redhat.com>
	Andrew Haley  <aph@redhat.com>

	* protoize.c (default_include): Conditionalize
	CROSS_INCLUDE_DIR and TOOL_INCLUDE_DIR.

	* gcc.c (system_dir_prefix): new.
	(process_command): Use system_dir_prefix to find system includes.
	(do_spec_1): Process 'R' spec.
	(process_command): Pass linker options as switches for
	spec processing.

	* configure.in (--enable-system-prefix): new.
	Override the SYSTEM_HEADER_DIR being set by cross-make if we are a
	host-x-host
	(hostxhost_overrides): new.

	* configure: Rebuilt.

	* Makefile.in (CROSS_INCLUDE_DIR, SYSTEM_PREFIX_VALUE,
	system_prefix): New.
	(@hostxhost_overrides@): new.
	(DRIVER_DEFINES): add SYSTEM_PREFIX_VALUE.
	(PREPROCESSOR_DEFINES): use CROSS_INCLUDE_DIR.
	Process $(system_prefix).
	Remove processing based on $(SYSTEM_HEADER_DIR).

2001-07-23  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.c (stormy16_expand_move): Copy
	the source to a temporary before copying the temporary to
	the destination.

2001-07-19  Geoffrey Keating  <geoffk@redhat.com>

	* stormy16-protos.h (branch_comparison_operator): Delete.
	* stormy16.c (branch_comparison_operator): Delete.
	* stormy16.h (PREDICATE_CODES): Remove branch_comparison_operator.
	* stormy16.md (cbranch): Use comparison_operator instead of
	branch_comparison_operator.
	(cbranch_neg): Likewise.

	* stormy16.md (mulhi3): New.

	* stormy16-protos.h (stormy16_carry_plus_operand): New prototype.
	(stormy16_split_move): New prototype.
	(stormy16_expand_arith): New prototype.
	(shift_operator): New prototype.
	(stormy16_output_shift): New prototype.
	* stormy16.c (emit_addhi3_postreload): New function.
	(stormy16_expand_prologue): Use it.
	(stormy16_expand_epilogue): Use it.
	(stormy16_secondary_reload_class): Allocate the carry register
	when needed.
	(stormy16_extra_constraint_p): Add comments, 'U' case.
	(stormy16_split_move): New function.
	(stormy16_expand_move): Add comments, call to stormy16_split_move.
	(stormy16_expand_arith): New function.
	(shift_operator): New function.
	(stormy16_output_shift): New function.
	(stormy16_print_operand): Add 'O' case.
	* stormy16.h (FIRST_PSEUDO_REGISTER): Add carry flag as hard register.
	(FIXED_REGISTERS): Likewise.
	(CALL_USED_REGISTERS): Likewise.
	(REG_ALLOC_ORDER): Likewise.
	(HARD_REGNO_MODE_OK): Likewise.
	(MODES_TIEABLE_P): Likewise.
	(enum reg_class): Add a class for the carry register.
	(REG_CLASS_CONTENTS): Likewise.
	(REGNO_REG_CLASS): Likewise.
	(REG_CLASS_FROM_LETTER): 'y' means CARRY_REGS.
	(FRAME_POINTER_REGNUM): Adjust.
	(ARG_POINTER_REGNUM): Adjust.
	(REGISTER_NAMES): Adjust.
	(PREDICATE_CODES): Add shift_operator.
	* stormy16.md (movsi): New.
	(movsi_internal): New.
	(addhi3): Clobber carry flag.  Use 'inc' and 'dec' instructions.
	(reload_inhi): New.
	(addchi4): New.
	(addchi5): New.
	(subhi3): Clobber carry flag.  Use 'inc' and 'dec' instructions.
	(subchi4): New.
	(subchi5): New.
	(neghi2): Generate clobber when generating add instruction
	(ashlhi3): Clobber carry flag.
	(asrlhi3): Clobber carry flag.
	(lshrhi3): Clobber carry flag.
	(addsi3): New.
	(subsi3): New.
	(negsi3): New.
	(ashlsi3): New.
	(asrlsi3): New.
	(lshrsi3): New.

	* stormy16.c (LEGITIMATE_ADDRESS_CONST_INT_P): New macro.
	(stormy16_legitimate_address_p): Use it.
	(stormy16_mode_dependent_address_p): Use it.

	* stormy16.md (define_attr length): Adjust corner cases.

2001-07-06  Chandrakala Chavva  <cchavva@redhat.com>

	* config/sh/sh.md (movsf_media_nofpu+1, movdf_media_nofpu+1):
	Fix typo in previous checkin.

2001-07-12  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.c (stormy16_expand_move): New function.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_expand_move.
	* config/stormy16/stormy16.md (movqi): Use stormy16_expand_move.
	(movhi): Likewise.

	* config/stormy16/stormy16.c (REGNO_NEEDS_SAVE): New macro.
	(stormy16_expand_prologue): Use it.
	(stormy16_expand_epilogue): Use it.
	(stormy16_epilogue_uses): New function.
	* config/stormy16/stormy16.h (EPILOGUE_USES): New macro.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_epilogue_uses.

2001-07-12  J"orn Rennecke <amylaar@redhat.com>

	* recog.c (validate_replace_rtx_1): Don't call simplify_subreg
	with an out-of-range SUBREG_BYTE.

2001-07-12  J"orn Rennecke <amylaar@redhat.com>

	* emit-rtl.c (gen_rtx_SUBREG): Don't do offset congurency check if
	SUBREG_REGNO_OFFSET is defined.
	(subreg_hard_regno): Likewise.
	* rtlanal.c (subreg_regno_offset): Mark possibly unused
	parameters / variables with ATTRIBUTE_UNUSED.  Add semicolon in
	statement using SUBREG_REGNO_OFFSET.

2001-07-11  Chandrakala Chavva  <cchavva@redhat.com>

	* config/sh/sh.h (MODES_TIEABLE_P): Fix redact indentations.

2001-07-11  Aldy Hernandez  <aldyh@redhat.com>

	    * Makefile.in (s-mlib): Fix typo in MULTILIB_DONT_BUILD_DIRS.

2001-07-11  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.c (stormy16_interrupt_function_p):
	New function.
	(TARGET_VALID_TYPE_ATTRIBUTE): Define.
	(stormy16_valid_type_attribute): New function, allow "interrupt"
	attribute.
	(stormy16_compute_stack_layout): Allow for interrupt functions.
	(stormy16_expand_prologue): Likewise.
	(stormy16_expand_epilogue): Likewise.
	(stormy16_expand_builtin_va_start): Don't permit variadic
	interrupt functions.
	* config/stormy16/stormy16.md (return_internal_interrupt): New
	pattern.
	* config/stormy16/stormy16.h (INCOMING_FRAME_SP_OFFSET):
	Offset is different in an interrupt function.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_interrupt_function_p; avoid warnings.

2001-07-10  Chandrakala Chavva  <cchavva@cygnus.com>
	    Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (MODES_TIEABLE_P): Don't tie modes wider than
	what single FP register can hold for SHmedia target.

2001-07-09  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.c (stormy16_function_value): New function.
	* config/stormy16/stormy16.h (FUNCTION_VALUE): Use it.
	* config/stormy16/stormy16-protos.h: Prototype it.

2001-07-08  Aldy Hernandez  <aldyh@redhat.com>

	* gcc.c (print_multilib_info): Move last_path initialization before
	multilib_redundant_dirs use.

2001-07-07  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.md: Change GENERATE_MULT3_SI to
	GENERATE_MULT3_DI for muldi3* patterns.

2001-07-06  Chandrakala Chavva  <cchavva@redhat.com>
	    Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (movsf_media_nofpu+1, movdf_media_nofpu+1):
	Do not split into SUBREG.

2001-07-05  Geoffrey Keating  <geoffk@redhat.com>

	* config/stormy16/stormy16.md (psw_operand): New attribute.
	(movqi_internal): Add Rx variant, psw_operand attribute.
	(movhi_internal): Likewise.
	(addhi3): Add Rx variant.
	(subhi3): Likewise.
	(andhi3): Likewise.
	(iorhi3): Likewise.
	(xorhi3): Likewise.
	(umulhisi3): Add psw_operand attribute.
	(udivmodhi4): Likewise.
	(call_internal): Likewise.
	(call_value_internal): Likewise.
	(return_internal): Likewise.
	(jump): Likewise.
	(indirect_jump): Likewise.
	(tablejump_pcrel): Likewise.
	(nop): Likewise.
	(blockage): Likewise.
	* config/stormy16/stormy16.c (stormy16_extra_constraint_p):
	Add comment, unimplemented 'T' case.
	* config/stormy16/stormy16.h (CONST_OK_FOR_LETTER_P): Add 'N'.

	* config/stormy16/stormy16.md (cbranch): Add case for reversed
	comparison with immediate.
	(cbranch_neg): Likewise.
	* config/stormy16/stormy16.c (stormy16_output_cbranch):
	Allow for reversed comparison with immediate.

	* config/stormy16/stormy16.c (stormy16_expand_prologue): Push
	varargs registers before call-saved registers.
	(stormy16_expand_epilogue): Pop varargs registers before
	call-saved registers.
	(stormy16_build_va_list): Fully implement.
	(stormy16_expand_builtin_va_start): New.
	(stormy16_expand_builtin_va_arg): New.
	* config/stormy16/stormy16.h (EXPAND_BUILTIN_VA_START): Define.
	(EXPAND_BUILTIN_VA_ARG): Define.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_expand_builtin_va_start, stormy16_expand_builtin_va_arg.

	* config/stormy16/stormy16.c (stormy16_initialize_trampoline): New.
	* config/stormy16/stormy16.h (INITIALIZE_TRAMPOLINE): Call it.
	* config/stormy16/stormy16-protos.h: Prototype
	stormy16_initialize_trampoline.

2001-07-04  Richard Sandiford  <rsandifo@redhat.com>

	* haifa-sched.c (priority): Remove cygnus-local priority handling
	(sched_init): Don't initialize the priority to -1.

2001-07-02  Geoffrey Keating  <geoffk@redhat.com>

	* config.gcc: Add stormy16-*-elf.
	* config/stormy16/stormy16-protos.h: New file.
	* config/stormy16/stormy16.c: New file.
	* config/stormy16/stormy16.h: New file.
	* config/stormy16/stormy16.md: New file.

2001-06-29  J"orn Rennecke <amylaar@redhat.com>

	* unwind-pe.h (read_encoded_value_with_base):
	Add casts from integer types to _Unwind_Ptr that c++ requires.

2001-06-29  J"orn Rennecke <amylaar@redhat.com>

	* unwind.h: Document bogosity of _Unwind_Ptr.

2001-06-29  J"orn Rennecke <amylaar@redhat.com>

	* unwind-pe.h (read_encoded_value_with_base): Don't |= or shift
	a pointer.
	Don't add two pointers.
	* unwind-dw2-fde.c (classify_object_over_fdes):
	Don't shift or logical-or a pointer.
	(add_fdes): Likewise.
	(linear_search_fdes): Likewise.
	(binary_search_unencoded_fdes): Don't add two pointers.
	(binary_search_single_encoding_fdes): Likewise.
	(binary_search_mixed_encoding_fdes): Likewise.

2001-06-20  Tom Rix <trix@redhat.com>

	* config/d10v/d10v.md (cond_branch): predicate for operand 2,3
	pc_or_label_operand causing compile warnings. Use label_ref and pc
	rtx instead.

	* config/d10v/d10v.c (d10v_split_logical_op): Use byte or word offsets
	for pseudo or hard registers.
	(d10v_subword) : Same.
	Clean up compiler warnings.

	* config/d10v/d10v.h : Change function declarations to reflect
	changes in d10v.c.

2001-06-21  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (FIXED_REGISTERS): Add cygnus-local registers.
	(CALL_USED_REGISTERS): Ditto.

2001-06-20  Tom Rix <trix@redhat.com>

	* config/d10v/d10v.md (cond_exec_hi_binary, cond_exec_si_binary,
	iorhi3_constant, xorhi3_constant):  Clean up C code.

2001-06-19  Tom Rix <trix@redhat.com>

	* config/d10v/d10v.md (movqi_internal, movhi_internal, movsi_internal
	movsf_internal, movdi_internal, movdf_internal, movcc): Use better
	predicate for operand 0.

2001-06-18  Jason Merrill  <jason_merrill@redhat.com>

	* config/i386/i386.c (build_aligned_name): Use BUILD_ALIGNED_NAME.
	(ix86_expand_prologue_fsa): Add missing "insn = ".

2001-06-18  Tom Rix  <trix@redhat.com>

	* genpeep.c (main): Include toplev.h for d10v.
	* config/d10v/d10v.c (d10v_expand_divmod): Fix subreg.

2001-06-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/ushmedia.h, config/sh/sshmedia.h: Updated signatures
	and added new functions as specified in SH5 ABI r9.

2001-06-14  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (MASK_PACK): New.
	(TARGET_PACK): New.
	(TARGET_SWITCHES): Add -mno-pack.
	(MASK_DEFAULT_FRV): Add MASK_PACK.
	(MASK_DEFAULT_FR500): Likewise.
	(MASK_DEFAULT_FR400): Likewise.
	(ISSUE_RATE): Evaluate to 1 if packing is disable.

2001-06-14  Richard Sandiford  <rsandifo@redhat.com>

	* frv.md (*movsf_load): Rename to *movsf_has_fprs_load.  Only
	use if TARGET_HAS_FPRS.

2001-06-13  Eric Christopher  <echristo@redhat.com>

	* config/mips/elf.h: Remove local DWARF_CIE_DATA_ALIGNMENT
	modification.

2001-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (frv_adjust_field_align): Check for null contexts.

2001-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* frv.md (casesi): Fix inverted condition.

2001-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (frv_preferred_reload_class): Remove.
	* frv.c (frv_preferred_reload_class): Remove.
	(frv_secondary_reload_class): Load constants into FPRs through GPRs.
	* frv.h (PREFERRED_RELOAD_CLASS): Return the class unaltered;
	don't ask for constants to be forced into memory.
	* frv.md (*movqi_load): New, extract load operations from ...
	(*movqi_internal): ... here.
	(*movhi_load, *movhi_internal): Likewise.
	(*movsi_load, *movsi_internal): Likewise.
	(*movsf_load, *movsf_internal): Likewise.  Fix store attrs.

2001-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (FIRST_EH_REGNUM): Don't make value dependent on TARGET_GPR_64
	so that 32-gpr libraries can work with 64-gpr code.
	(LAST_EH_REGNUM): Likewise.

2001-06-13  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (frv_registers_used_p): Don't treat LO_SUM as a special case.
	(frv_pack_insns): Don't check for register conflicts in setlo insns.

2001-06-11  Michael Meissner  <meissner@redhat.com>

	* config/mips/elf5400.h (SUBTARGET_ASM_SPEC): Pass -mcpu=vr5400 to
	the assmebler unless -mcpu=... or -m1900/-mips16 are passed.

2001-06-08  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (STACK_BOUNDARY): Unconditionally set to 64.
	* frv.c (frv_stack_info): Make frame header and register parameter
	areas start on dword-aligned boundaries.

2001-06-06  Richard Sandiford  <rsandifo@redhat.com>

	* sched-rgn.c (check_first_and_last_blocks): New.
	(find_rgns): Only consider pipelining if the above returns true.
	(may_be_pipelined_p): Continue on deleted label notes.  Return
	FALSE for expected-value notes.  Abort on unrecognised notes.
	(unroll): Handle deleted label notes.  Copy label number.
	(emit_notes_list): Copy label number to new note.

2001-06-05  Richard Sandiford  <rsandifo@redhat.com>

	* t-frv (MULTILIB_OPTIONS): Remove tomcat multilibs.  Remove
	fr500 (which is now the default) and add fr400.
	(MULTILIB_DIRNAMES): Update accordingly.
	(MULTILIB_EXCEPTIONS): Don't build -mcpu=fr400 -msoft-float
	(MULTILIB_MATCHES): Remove association between mdouble and mcpu=.

2001-06-04  Jason Eckhardt  <jle@redhat.com>

	* sched-rgn.c (unroll): Also update post-loop liveness information
	when the only exit from loop is an early exit.

2001-06-04  Timothy Wall  <twall@redhat.com>

	* config/ia64/crt[in].asm: Remove extraneous .proc/.endp.
	* config/ia64/aix.h: Remove obsolete #if 0 stuff.
	* config/ia64/unwind-aix.c: Change c++-style to c-style comments.
	* config.gcc: Fix AIX 5.1 configuration for style.

2001-06-04  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (GCC_nested_trampoline): Align to an
	8-byte boundary.

2001-06-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (dump_table): Add const0_rtx in calls of
	gen_consttable_4 and gen_consttable_8.  Emit multiple labels
	and consttable_window_ends.

2001-06-03  Graham Stott  <grahams@redhat,com>

	* config/sh/sh.md (movdi split): Remove unused variable last_insn.

2001-06-02  Timothy Wall  <twall@redhat.com>

	* config.gcc: Add configuration options for AIX 5.1 on IA-64.
	* config/ia64/unwind-aix.c: New. Unwind table entry lookup for AIX
	5.1 on IA-64.
	* config/ia64/aix.h: Configuration for AIX 5.1 on IA-64.  Added C++
	preprocessor defines to make the OS happy.
	* config/ia64/crt[in].asm: New.  Generic static ctor/dtor support
	prefix/suffix code.
	* config/ia64/t-aix: Removed va_list from headers.  Added unwind-aix.c
	to libgcc2 files.
	* config/va_list.h: Removed.  No longer required, since va_list is
	redefined in aix.h to match what the system expects.

2001-05-31  Richard Sandiford  <rsandifo@redhat.com>

	* frv.md (far_jump): New attribute.
	(*branch_signed_true): Support far jumps using a call instruction.
	(*branch_signed_false): Likewise
	(*branch_unsigned_true): Likewise.
	(*branch_unsigned_false): Likewise.
	(*branch_fp_true): Likewise.
	(*branch_fp_false): Likewise.
	(jump): Likewise.
	* frv.h (MACHINE_DEPENDENT_REORG): Undefine.
	* frv.c (frv_function_contains_far_jump): New function.
	(frv_machine_dependent_reorg): Rename to frv_pack_insns.
	(frv_function_prologue): Check for far jumps in functions with
	no frames.  Save the link register to GR3 in such cases, and
	change the return instructions appropriately.  Do packing here
	rather than in MACHINE_DEPENDENT_REORG.

2001-05-30  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (frv_index_memory): Declare.
	(frv_split_double_load): Declare.
	(frv_split_double_store): Declare.
	* frv.c (frv_index_memory): New.
	(frv_split_double_load): New.
	(frv_split_double_store): New.
	* frv.md: Use new split functions.
	(mdunpackh): Reverse order of stores.  Use frv_index_memory.
	(mbtohe): Likewise.

	* frv.md (*movdi_double): Change type of fpr->fpr moves to fdouble.
	(*movdf_double): Likewise.
	(define_attr type): Remove fmove (unused) and fdmove.

	* frv.md: Remove non-DFA scheduler description.

	* frv.c (frv_ifcvt_modify_tests): Do not try to handle the case
	when no paired CCR is available.

2001-05-29  Bernd Schmidt  <bernds@cygnus.co.uk>

	* regmove.c (regmove_optimize): Disable optimize_related_values.

2001-05-24  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (output_condmove_single): Fix "cmnot" case.
	* frv.md (*andsi_media3): Make predicates match constraints.
	(*orsi_media3): Likewise.
	(*xorsi_media3): Likewise.
	(*cond_exec_si_binary2): Change type from "int" to "mlogic".
	(*cond_exec_si_unary2): Likewise.
	(mqcpx): Remove conditional variant added in previous patch.

2001-05-23  Richard Sandiford  <rsandifo@redhat.com>

	* frv.md: Remove double semi-colon from some media insn handlers.
	(mqaddh): Add conditional variant.
	(mqcpx): Likewise.
	(fr400_m1unit): New CPU unit.  Rework fr400 media schedule
	description to use it.

	* frv.h (PREDICATE_CODES): Add int5_operand.
	* frv-protos.h (int5_operand): Declare.
	* frv.c (int5_operand): New.
	(frv_int_to_acc): Print error given [4,7] if TARGET_ACC_4.
	(bdesc_set): New.
	(bdesc_voidacc_2acc): New.
	(bdesc_voidacc_4acc): New.
	(frv_expand_set_builtin): New.
	(frv_expand_voidaccop_builtin): New.
	(frv_expand_builtin): Use the above.  Check whether the selected
	builtin is available on the current target.

	* frv.md: Add new builtins.
	* frv.c: Declare and expand them.
	* media.h: Declare them.

2001-05-23  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (gpr_accg_or_memory_operand): Remove declaration.
	* frv.md (*movqi_internal): Remove ACCG case.
	(*movsi_internal): Remove ACC case.
	(zero_extendqihi): Remove ACCG case.
	(zero_extendqisi): Remove ACCG case.
	(mrdacc, mrdaccg, mwtacc, mwtaccg): New insns.
	* frv.c (gpr_accg_or_memory_operand): Remove.
	(output_move_single): Remove MRDACC, MRDADDG, MWTACC and MWTACCG cases.
	(frv_expand_mrdacc_builtin): New.
	(frv_expand_mwtacc_builtin): New.
	(frv_init_builtin): Add MRDACC, MRDADDG, MWTACC and MWTACCG.
	(frv_expand_builtin): Handle them.
	* media.h: Use functions for MRDACC, MRDADDG, MWTACC and MWTACCG.

	* frv.md (mand, mor, mxor, mnot): New insns.
	* frv.c (bdesc_1arg): Use dedicated insn for MNOT.
	(bdesc_2arg): Likewise for MAND, MOR and MXOR.

2001-05-23  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (frv_read_argument): New.
	(frv_check_constant_argument): New.
	(frv_legitimize_argument): New.
	(frv_legitimize_target): New.
	(frv_expand_*_builtin): Rework to use the above.
	(frv_expand_cut_builtin): New.  Extracted from...
	(frv_expand_binop_builtin): ...here.
	(bdesc_cut): New.  Move MCUT and MCUTSS to here from...
	(bdesc_2arg): ...here.
	(frv_expand_mclracca_builtin): New.
	(frv_expand_noargs_builtin): New.
	(frv_expand_builtin): Rework to use the above.

	* media.h (IMM6): Make signed long.
	(__MCUTSS): Make second argument signed, to match Fujitsu's header.
	* (frv_init_builtins): Standardize variable names.  Change IMM6
	arguments to signed long to reduce number of type signatures.
	Change ACC_T arguments to unsigned long to match media.h definitions.
	Make __MSRAHI and __MCUT signatures match media.h.  Change __MCUTSS
	signature as above.

2001-05-16  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (MODES_TIEABLE_P): Allow identical modes to be tied.
	(EXIT_IGNORE_STACK): Define.

2001-05-16  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (struct machine_function): Remove frv_eh_epilogue_sp and
	frv_eh_epilogue_ra.
	* frv.c (frv_mark_machine_status): Remove.
	(frv_override_options): Don't install a mark_machine_status function.

	* frv-protos.h (frv_frame_insn): Remove declaration.
	* frv.h (OFFSET_REGNO): New.
	(TEMP_REGNO): New.
	(OLD_SP_REGNO): New.
	(STACKADJ_REGNO): New.
	(JUMP_REGNO): New.
	(FIRST_EH_REGNUM, LAST_EH_REGNUM): Redefine to be the range
	available to EH_RETURN_DATA_REGNO.  Use gr32 to gr35 if 64 GPRS,
	or gr14 and gr15 if only 32.
	(EH_RETURN_REG): Remove.
	(EH_STACK_BUMP_REG): Remove.
	(EH_RETURN_DATA_REGNO): Define.
	(EH_RETURN_STACKADJ_RTX): Define.
	(EH_RETURN_HANDLER_RTX): Define.
	(DWARF_FRAME_RETURN_COLUMN): Define.
	* frv.c (enum frv_stack_op): New.
	(frv_frame_accessor_t): New.
	(frv_frame_insn): Also take a dwarf2 version of the insn pattern.
	(frv_frame_offset_rtx): New.
	(frv_frame_mem): New.
	(frv_dwarf_store): New.
	(frv_frame_access): New.
	(frv_frame_access_multi): New.
	(frv_frame_access_standard_regs): New.
	(frv_expand_prologue): Rework to use a fixed register mapping and
	to use the above functions.  Use stack_adjust instruction to adjust
	the stack.
	(frv_expand_epilogue): Likewise.  Add EH_RETURN_STACKADJ_RTX to sp
	if current_function_calls_eh_return.
	(frv_asm_output_mi_thunk): Use fixed register mapping.  Remove .p
	from first add instruction and put it on the following sethi instead.
	(frv_stack_info): Start GPRs at LAST_ARG_REGNUM + 1.  Force
	EH registers to be saved if current_function_calls_eh_return.
	(frv_initial_temp_reg): Remove.
	* frv.md: Use (define_constants) for all unspecs.
	(eh_epilogue): Remove.
	(stack_adjust): New.
	(return): Remove stack pointer USE in favour of stack_adjust.
	(epilogue_return): Likewise.

2001-05-16  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (frv_ifcvt_t): Rename added_insns_bitmap to
	scratch_insns_bitmap to reflect its usage in frv_ifcvt_modify_insn.
	(frv_function_epilogue): Likewise.
	(frv_ifcvt_modify_insn): Likewise.
	(frv_ifcvt_modify_final): Likewise.  Only add scratch insns to the
	bitmap.

2001-05-16  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (frv_dynamic_chain_address): New function.
	* frv.h (DYNAMIC_CHAIN_ADDRESS): Use it.
	(struct machine_function): Add frame_needed field.
	* frv.c (frv_dynamic_chain_address): New function.  Set frame_needed.
	(frv_return_addr_rtx): Set frame_needed.
	(frv_frame_pointer_required): Return true if frame_needed.

2001-05-16  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (CPP_FRV_SPEC): New.
	(CPP_FR500_SPEC): New.
	(CPP_FR400_SPEC): New.
	(CPP_SIMPLE_SPEC): New.
	(CPP_CPU_DEFAULT_SPEC): New.
	(EXTRA_SPECS): Remove old extra specs and use the above.
	(CPP_SPEC): Rework after above changes.
	(CC1_SPEC): Don't add any extra options.
	(ASM_SPEC): Likewise.
	(MULTILIB_DEFAULTS): Remove.
	(TARGET_VERSION): Print (frv).

	* frv.h (MASK_DEFAULT_DOUBLE): Remove.
	(MASK_DEFAULT_GPR): Remove.
	(MASK_DEFAULT_FPR): Remove.
	(MASK_DEFAULT_DWORD): Remove.
	(MASK_DEFAULT): Update accordingly.
	(MASK_DEFAULT_FRV): New.
	(MASK_DEFAULT_FR500): New.
	(MASK_DEFAULT_FR400): New.
	(MASK_DEFAULT_SIMPLE): New.

	* toplev.c (target_flags_set): New variable.
	(set_target_switch): Make it the mask of all bits set or cleared
	in target_flags.
	* frv.c (frv_default_flags_for_cpu): New function.
	(frv_override_options): Use it.

2001-05-17  Jeffrey A Law  (law@cygnus.com)

	* flow.c (set_block_for_new_insns): Update block->end as needed.

2001-05-16  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (print_operand): Handle floating-point pair,
	vector and matrix registers.
	* config/sh/sh.h (REGISTER_MOVE_COST): Take floating-pointer
	vector modes into account.
	* config/sh/sh.md (movv2sf): Split move between registers into
	movdf.
	(movv4sf, movv16sf): Introduce insns that get split only after
	reload.
	* config/sh/shmedia.h: Fix Copyright dates.
	* config/sh/ushmedia.h: Likewise.  Move loop counter
	declarations into conditionals that uses them.
	(sh_media_FVADD_S, sh_media_FVSUB_S): Fix off-by-one error in
	loop boundary.
	* config/sh/sshmedia.h: Fix Copyright dates.
	(sh_media_PUTCFG): Fix constraints.

2001-05-13  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/mn10300.h (JUMP_TABLES_IN_TEXT_SECTION): Let them
	be defined in .rodata even in PIC, now that the assembler
	supports that.

2001-05-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (TARGET_PTRMEMFUNC_VBIT_LOCATION): Define to
	ptrmemfunc_vbit_in_delta for SH5.

2001-05-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/t-linux (dp-bit.c, fp-bit.c): Don't define
	FLOAT_BIT_ORDER_MISMATCH.

2001-05-09  Alexandre Oliva  <aoliva@redhat.com>

	* c-format.c (check_format_types): Avoid multiple warnings
	about the same argument.

2001-05-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.h (GOT_SYMBOL_NAME): Don't let the
	symbol take an underscore prefix.

2001-05-09  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc (am33_2.0-*-linux*): Added.
	* config/mn10300/linux.h: New.
	* config/mn10300/t-linux: New.

2001-05-09  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (ISSUE_RATE): Set to 2 for the FR400.
	* frv.c (frv_machine_dependent_reorg): Add FR400 case.

	* frv-asm.h (P2): New macro.
	* lib1funcs.asm (_cmpf): Select FPU code based on __FRV_HARD_FLOAT__.
	(_andll): Use P2 to pack second instruction.
	(_orll): Likewise.
	(_xorll): Likewise.
	(_notll): Likewise.
	(_cmov): Likewise.  Swap load and compare operations so that they
	can pack on both the FR400 and FR500.

	* frv.h (TARGET_MEDIA_REV1): New macro.
	(TARGET_MEDIA_REV2): New macro.
	* frv.md: (define_attr type): Replace m1 to m6 with a finer-grain
	media classification.
	(define_insn_reservation m1): Include all types that were previously
	classified as m1.
	(define_insn_reservation m2 to m6): Similarly.
	(*movqi_internal): Change type for mrdaccg and mwtaccg alternatives.
	(*movsi_internal): Change type for mrdacc and mwtacc alternatives.
	(zero_extendqihi2): Add alternative for mrdaccg.
	(zero_extendqisi2): Change type for mrdacc alternative.
	(andsi_media): Change type of media insn to mlogic.
	(iorsi_media): Likewise.
	(xorsi_media): Likewise.
	(one_cmplsi2_media): Likewise.
	(*media1): Split into maveh, *msath and *maddh, each with its own type.
	(*cond_exec_media1): Rename to *cond_exec_maddh, type maddh.
	(*media2): Rename to *mqaddh, type mqaddh.
	(mpackh): Set type to mpackh.
	(munpackh): Set type to munpackh.
	(mbtoh, *cond_exec_mbtoh): Set type to mbhconv.
	(mhtob, *cond_exec_mhtob): Likewise.
	(*media3): Split into *mrot and *mshift, with individual types.
	(mexpdhw): Set type to mexpdhw.
	(mexpdhd, *cond_exec_mexpdhd): Set type to mexpdhd.
	(mwcut): Set type to mwcut.
	(*media4): Split into *mmulh and *mmulxh, each with its own type.
	(*cond_exec_media4): Rename to *cond_exec_mmulh, type mmulh.
	(*media5): Split into *mmach and *mmrdh, each with its own type.
	(*cond_exec_media5): Rename to *cond_exec_mmach, type mmach.
	(*media6): Split into *mqmulh and *mqmulxh, each with its own type.
	(*cond_exec_media6): Rename to *cond_exec_mqmulh, type mqmulh.
	(*media7): Rename to *mqmach, type mqmach.
	(*cond_exec_media7): Rename to *cond_exec_mqmach, type mqmach.
	(*media8): Rename to *mcpx, type mcpx.
	(*cond_exec_media8): Rename to *cond_exec_mcpx, type mcpx.
	(*media9): Rename to *mqcpx, type mqcpx.
	(*media10): Rename to *mcut, type mcut.
	(*mclracc_internal): Set type to mclracc.
	(mclracca, *mclracca_internal): Split into 4-accumulator and
	8-accumulator varieties.  Set type to mclracca.
	(mcop1, mcop2): Change condition to TARGET_MEDIA_REV1.
	(mdunpackh, *mdunpackh_internal): Likewise.
	(mbtohe, *mbtohe_internal): Likewise.
	* frv.c (frv_expand_builtin): Choose mclracca4 or mclracca8 based
	on number of available accumulators.

	* frv.md (*movqi_internal): Change type of zero -> FPR move from
	multi to movgf.
	(*movhi_internal): Change type of zero -> FPR move from
	multi to movgf.
	(*movsi_internal): Remove unhandled CR moves from constraints.  Use
	separate alternatives for zero -> FPR and zero -> SPR moves.
	(zero_extendqihi2): Change type of GPR -> GPR extensions from multi
	to int.  Add alternative with constant operand.
	(zero_extendqisi2): Change type of GPR -> GPR extensiosn from multi
	to int.  Add alternative with constant operand.

	* frv.md: Add FR400 schedule description.
	Reformat FR300 (define_insn_reservation) description.
	Use (define_constant) to define unspec codes for media instructions.
	Comment out obselete (define_function_unit) description.

2001-05-08  Richard Sandiford  <rsandifo@redhat.com>

	* frv.h (ZERO_P): New macro.
	* frv.c (condexec_source_operand): Use it.
	(reg_or_0_operand): Use it.
	(output_move_single): Use it.
	(output_move_double): Use it.
	(output_condmove_single): Use it.
	(frv_preferred_reload_class): Use it.

2001-05-08  Richard Sandiford  <rsandifo@redhat.com>

	* frvbegin.c: Don't include "tm.h".
	Include "unwind-dw2-fde.h" rather than "frame.h".
	* frvend.c: Likewise.
	* t-frv: Update dependencies accordingly.

2001-05-08  Richard Sandiford  <rsandifo@redhat.com>

	* frv-protos.h (enum frv_cpu): Add FRV_CPU_FR400
	* frv.md (define_attr cpu): Add "fr400"

	* frv.h (MASK_ACC_4): New target flag.
	(TARGET_ACC_4): New macro.
	(TARGET_ACC_8): New macro.
	(TARGET_HAS_FPRS): New macro.
	(NUM_GPRS): New macro.
	(NUM_FPRS): New macro.
	(NUM_ACCS): New macro.
	(TARGET_SWITCHES): Add -macc-4 and -macc-8.
	* frv.c (frv_override_options): Recognise -mcpu=fr400.
	-msoft-float and -mmedia are no longer incompatible.
	(frv_conditional_register_usage): Use NUM_GPRS, NUM_FPRS and
	NUM_ACCS to determine which registers are available.
	(output_move_single): Use "mor" for FPR moves if TARGET_SOFT_FLOAT.
	(output_condmove_single): Likewise.
	(frv_legitimate_constant_p): Force const_doubles into memory
	if TARGET_HAS_FPRS (previously done if TARGET_HARD_FLOAT).

	* frv.md (*movsf_internal_hardfloat): Depend on TARGET_HAS_FPRS
	rather than TARGET_HARD_FLOAT.  Rename accordingly.
	(*movsf_internal_softfloat): Likewise.
	(*cond_exec_movsf_hardfloat): Likewise.
	(*cond_exec_movsf_softfloat): Likewise.
	(*movsfcc_hardfloat_signed): Likewise.
	(*movsfcc_hardfloat_unsigned) Likewise.
	(*movsfcc_softfloat_signed): Likewise.
	(*movsfcc_softfloat_unsigned): Likewise.
	(*movcc_fp): Depend on TARGET_HAS_FPRS rather than TARGET_HARD_FLOAT.
	(*movcc_fp_internal): Likewise.
	(reload_incc_fp): Likewise.
	(reload_outcc_fp): Likewise.
	(read_fcc): Likewise.
	(update_fcc): Likewise.
	(*fck_float): Likewise.

	* frv.md (movMMcc): Reformat match_operators.

2001-05-08  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (TARGET_SWITCHES): Document -m5-*.
	* invoke.texi: Likewise.

2001-05-04  Richard Sandiford  <rsandifo@redhat.com>

	* frv.md: Formatting change in fr500 schedule description.

2001-05-04  Richard Sandiford  <rsandifo@redhat.com>

	* frv.c (frv_alloc_temp_reg): Check regno against orig_regno
	after modulo correction.  Remove redundant regno check.
	(frv_ifcvt_modify_final): Pass insn rather than pattern to INSN_UID.
	* frv.h (CR_FIRST): Correct comment.

2001-05-01  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md (sqrtsf2): flag_fast_math was renamed
	to flag_unsafe_math_optimizations.

2001-04-26  Tom Rix <trix@redhat.com>

	* config/frv/frv.c (frv_expand_prologue) :  Check for invalid
	memory offsets for stdarg/vararg registers

2001-04-25  Jeffrey A Law  (law@cygnus.com)

	* config/mips/linux.h (DWARF2_DEBUGGING_INFO): Define.
	(DWARF_DEBUGGING_INFO): Define.

2001-04-21  Alexandre Oliva  <aoliva@redhat.com>

	* dwarf2out.c (dwarf2out_line): Re-enable .file numbering.

2001-04-18  Richard Sandiford  <rsandifo@redhat.com>

	* sched-rgn.c (schedule_insns): Fix freeing of uninitialised sbitmaps.

2001-04-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (GCC_push_shmedia_regs,
	GCC_push_shmedia_regs_nofpu, GCC_pop_shmedia_regs,
	GCC_pop_shmedia_regs_nofpu): New global symbols.
	* config/sh/t-sh64 (LIB1ASMFUNCS): Add them.
	* config/sh/sh.h (SHMEDIA_REGS_STACK_ADJUST): New macro.
	* config/sh/sh.c (calc_live_regs): Account for PR's saving in
	compact function with nonlocal labels.
	(sh_expand_prologue) [SHcompact]: Push SHmedia regs if needed.
	(sh_expand_epilogue) [SHcompact]: Pop them when appropriate.
	(initial_elimination_offset): Account for their stack space.
	* config/sh/sh.md (shmedia_save_restore_regs_compact): New insn.

	* config/sh/sh.md (movsi_media, movsi_media_nofpu, movqi_media,
	movhi_media, movdi_media, movdi_media_nofpu, movdf_media,
	movdf_media_nofpu, movsf_media, movsf_media_nofpu): Require at
	least one of the operands to be a register.
	(movv2sf): Likewise.  Renamed to movv2sf_i.
	(movdi, movdf, movv2sf, movv4sf, movv16sf, movsf):
	prepare_move_operands() before emitting SHmedia insns.

2001-04-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300-protos.h (legitimate_pic_operand_p,
	legitimize_pic_address): Declare.
	* config/mn10300/mn10300.h (CONDITIONAL_REGISTER_USAGE): Mark
	the PIC register as fixed.
	(EXTRA_CONSTRAINT): Match UNSPEC_PLT and UNSPEC_PIC for 'S'.
	(GO_IF_LEGITIMATE_ADDRESS): Require legitimate_pic_operand for
	PIC.
	(LEGITIMATE_PIC_OPERAND_P): Define.
	(PIC_OFFSET_TABLE_REGNUM): Define.
	(GOT_SYMBOL_NAME): Define.
	(SYMBOLIC_CONST_P): Define.
	(ENCODE_SECTION_INFO): Use SYMBOL_REF_FLAG to mark local
	symbols.
	(MN10300_GLOBAL_P): Test it.
	(OUTPUT_ADDR_CONST_EXTRA): Handle PIC-related unspecs.
	(JUMP_TABLES_IN_TEXT_SECTION): Enable for PIC.
	* config/mn10300/mn10300.c (print_operand): Handle unspec.
	(expand_prologue): Set PIC register.
	(call_address_operand): Don't match SYMBOL_REFs in PIC.
	(legitimize_address): Call legitimize_pic_address.
	(legitimize_pic_address): New fn.
	(legitimate_pic_operand_p): New fn.
	* config/mn10300/mn10300.md (PIC_REG, SP_REG): New constants.
	(UNSPEC_INT_LABEL, UNSPEC_PIC, UNSPEC_GOT, UNSPEC_GOTOFF,
	UNSPEC_PLT): New constants.
	(pop_pic_reg): New insn.
	(movsi): Adjust non-PIC addresses.
	(builtin_setjmp_receiver): Restore the PIC register.
	(casesi): New insn.
	(call): Adjust non-PIC addresses.
	(int_label, GOTaddr2picreg): New expands.
	(am33_loadPC): New insn.
	(mn10300_loadPC): New expand.
	(call_next_insn): New insn.
	(add_GOT_to_pic_reg): New expand.
	(symGOT2reg, symGOT2reg_i): New expands.
	(symGOTOFF2reg, symGOTOFF2reg_i): New expands.
	(sym2PIC, sym2PLT): New expands.

2001-04-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (expand_prologue): Mark
	FP-register-saving insns as frame-related.

2001-04-12  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.c (frv_init_builtins): End argument lists with
	void_list_node.

2001-04-11  J"orn Rennecke <amylaar@redhat.com>

	* reload1.c (emit_input_reload_insns, emit_output_reload_insns):
	When changing the mode of reloadreg, do big-endian correction.

2001-04-11  J"orn Rennecke <amylaar@redhat.com>
	From Alan Lehotsky  <lehotsky@tiac.net> :

	* c-lex.c (lex_charconst): compute max_chars in terms of
	the port's defined WCHAR_TYPE_SIZE.

2001-04-11  Richard Sandiford  <rsandifo@redhat.com>

	* config/frv/frv.md (movhi_lo_sum): Mark operand 0 as read-write.
	(movsi_lo_sum): Likewise.
	(movsi_lo_sum_pic): Likewise.
	(movsf_lo_sum): Likewise.

2001-04-11  Richard Sandiford  <rsandifo@redhat.com>

	* ifcvt.c: Brought in modifications from frv branch, only selected
	if NEW_IFCVT_INTERFACE is defined.
	* basic-block.h: Likewise.
	* config/frv: Merge from frv branch.

2001-04-11  J"orn Rennecke <amylaar@redhat.com>

	* reload.c (operands_match_p): Use HARD_REGNO_NREGS for big-endian
	correction.
	(subst_reloads): Likewise.

2001-04-10  Richard Sandiford  <rsandifo@redhat.com>

	* haifa-sched.c (ready_remove): Fix shuffle loop.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	(process_insert_insn): Change bb parameter from int to basic_block,
	pass basic_blocks instead of ints as parameters.
	(pre_delete): Pass basic_blocks instead of ints as parameters.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	* gcse.c (process_insert_insn): Use set_block_for_new_insns.
	(pre_delete): Use set_block_for_new_insns.

2001-04-09  Andrew MacLeod  <amacleod@redhat.com>

	* gcse.c: Remove sanitize markers for amacleod-gcse-lm-sm and
	law-alias since the code is not contributed to net gcc.


2001-04-07  Andrew MacLeod  <amacleod@redhat.com>

	* config/d10v/d10v.c (d10v_split_logical_op): Use SUBREG_BYTE.
	(print_operand_memory_reference, d10v_subword): Use SUBREG_BYTE.
	* config/d10v/d10v.md (movsi): Use SUBREG_BYTE not SUBREG_WORD.
	* config/i386/i386.md (HImode zero extend split): Use
	SUBREG_BYTE.
	* config/pyr/pyr.c (subreg_overlap_mentioned_p, consecutive_operands):
	Use subreg_regno_offset function.
	* config/pyr/pyr.md (extendsidi2): Fixup explicit subregs in rtl
	to use byte offsets.
	* config/rs6000/rs6000.md (DImode const splits): Generate SUBREGs
	with byte offsets.
	* config/spur/spur.md (movqi, zero_extendhisi2, extendhisi2,
	extendqihi2, extendqisi2): Generate SUBREGs with byte offsets.

2001-04-07  Andrew MacLeod  <amacleod@redhat.com>

	* config/frv/frv.c (frv_print_operand_memory_reference): Use
	subreg_regno_offset instead of SUBREG_WORD.
	(frv_registers_update, frv_registers_used_p): Use subreg_regno_offset.
	(frv_registers_set_p): Use subreg_regno_offset.
	* config/frv/frv.md (reload_incc_fp): Subregs are byte offsets.

2001-04-07  Andrew MacLeod  <amacleod@redhat.com>

	* config/m32r/m32r.md (extendqihi2, extendqisi2, extendhisi2):
	Generate SUBREGs with byte offset.

2001-04-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/crti.asm (init, fini) [__SH5__ && ! __SHMEDIA__]:
	Don't save nor initialize r12.  Don't mis-align the stack.
	Pad the code with a nop.
	* config/sh/crti.asm: Don't restore r12.  Don't mis-align the
	stack.

2001-03-21  Michael Meissner  <meissner@redhat.com>

	* mips.h (GENERATE_MULT3_SI): New macro, specify all
	targets here that can do the 3 operand SI multiply.
	(GENERATE_MULT3_DI): New macro to specify targets that can do the
	3 operand DI multiply.
	(GENERATE_MULT3): Delete, no longer used.
	(ISA_HAS_MUL): Delete, folded into GENERATE_MULT3_SI.
	(ISA_HAS_MULHI): New macro to determine if machine has mulhi.
	(ISA_HAS_MULS): New macro to determine if machine has muls.
	(ISA_HAS_MSAC): New macro to determine if machine has msac.
	(ISA_HAS_MACC): New macro to determine if machine has macc.
	(ISA_HAS_ROTR_SI): New macro to determine if machine has ror.
	(ISA_HAS_ROTR_DI): New macro to determine if machine has dror.

	* mips.md (multiply insns): Use GENERATE_MULT3_SI and
	GENERATE_MULT3_DI.  Do not use ISA_HAS_MUL.
	(muls): Rename from muls_5400.  Use ISA_HAS_MULS instead of
	TARGET_5400.
	(msac): Rename from msac_5400.  Use ISA_HAS_MSAC instead of
	TARGET_5400.
	(muls_di): Rename from muls_5400_di.  Use ISA_HAS_MULS instead of
	TARGET_5400.
	(msac_di): Rename from msac_5400_di.  Use ISA_HAS_MSAC instead of
	TARGET_5400.
	(xmulsi3_highpart_mulhi): Rename from xmulsi3_highpart_5400.  Use
	ISA_HAS_MULHI instead of TARGET_5400.
	(xmulsi3_neg_highpart_mulhi): Rename from xmulsi3_neg_highpart_5400.
	Use ISA_HAS_MULHI instead of TARGET_5400.
	(rotrsi3): Split into define_expand/define_insn.  Use
	ISA_HAS_ROTR_SI instead of TARGET_5400.
	(rotrdi3): Split into define_expand/define_insn.  Use
	ISA_HAS_ROTR_DI instead of TARGET_5400.


2001-03-20  Michael Meissner  <meissner@redhat.com>

	* mips-protos.h (mips_move_vector): Move so the declaration does
	not depend on TREE_CODE being defined.
	(mips_valid_decl_attribute_p): Add declaration.

	* mips.c (choose_base_reg): Properly predeclare function.
	(enum nflex_ext_name): Add a trailing enumeration to avoid
	non-standard code.

	* mips.h (TARGET_*): Compact all cpu bits and make it an integer
	within the target flags bitfield to allow for more cpus.

2001-03-16  Michael Meissner  <meissner@redhat.com>

	* mips.c (choose_base_reg): Provide forward declaration.
	(enum nflex_ext_name): Add extra enumeration at end to eliminate
	trailing comma warning.
	(enum nflex_builtin): Ditto.
	(override_options, 'M' case): Add missing break.
	(save_restore_insns): Make reg_expr type correct.
	(nflex_init_builtins): Make args, ext type correct.  Add explicit
	casts to silence warnings.

	* mips.md (mul_acc_si_r5900): Make madd type correct.
	(xmulsi3_highpart_5400): Make sign, zero type correct.
	(xmulsi3_neg_highpart_5400): Ditto.
	(movv2i_internal): Properly split insns in define_insn_and_split.
	(call_value): Delete unused variable.
	(sibcall_value): Ditto.

2001-03-21  Michael Meissner  <meissner@redhat.com>

	* range.c: Include tm_p.h.

2001-03-20  Jeff Knaggs <jknaggs@redhat.com>

	* alpha.c (alpha_expand_unaligned_load_words): fixed arg to
	MEM_UNALIGNED_P.
	(alpha_expand_unaligned_store_words): Ditto.

2001-03-16  Michael Meissner  <meissner@redhat.com>

	* mips.c (choose_base_reg): Provide forward declaration.
	(enum nflex_ext_name): Add extra enumeration at end to eliminate
	trailing comma warning.
	(enum nflex_builtin): Ditto.
	(override_options, 'M' case): Add missing break.
	(save_restore_insns): Make reg_expr type correct.
	(nflex_init_builtins): Make args, ext type correct.  Add explicit
	casts to silence warnings.

	* mips.md (mul_acc_si_r5900): Make madd type correct.
	(xmulsi3_highpart_5400): Make sign, zero type correct.
	(xmulsi3_neg_highpart_5400): Ditto.
	(movv2i_internal): Properly split insns in define_insn_and_split.
	(call_value): Delete unused variable.
	(sibcall_value): Ditto.

2001-03-13  Alexandre Oliva  <aoliva@redhat.com>

	* gcc/longlong.h (__umulsidi3, count_leading_zeros)
	[__SHMEDIA__]: Implement.

2001-03-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md: Set latency of `pt' closer to reality.
	(movsi_media, movsi_media_nofpu, movdi_media, movdi_media_nofpu,
	movdf_media, movdf_media_nofpu, movsf_media, movsf_media_nofpu):
	Set move, load and store type attributes.

	* config/sh/sh.c (sh_loop_align) [TARGET_SH5]: Set to 3.

	* config/sh/sh.h (OVERRIDE_OPTIONS) [TARGET_SH5]: Disable
	profiling.

	* config/sh/sh.h (PROMOTE_MODE): Sign-extend SImode to DImode.

	* config/sh/sh-protos.h (sh_media_register_for_return): Declare.
	* config/sh/sh.c (sh_media_register_for_return): New function.
	(sh_expand_prologue) [TARGET_SHMEDIA]: Copy r18 to an available
	branch-target register.
	(sh_expand_epilogue) [TARGET_SHMEDIA]: Explicitly USE it.
	* config/sh/sh.md (return_media_i): Use any call-clobbered
	branch-target register.
	(return_media): If r18 wasn't copied in the prologue, copy it
	here.

	* config/sh/sh.h (CONDITIONAL_REGISTER_USAGE) [TARGET_SHMEDIA]:
	Clear class FP0_REGS.

	* config/sh/sh64.h (LINK_SPEC): Removed incorrect default copied
	from elf.h.

2001-03-09  Michael Meissner  <meissner@redhat.com>

	* mips.md (cpu attribute): Make cpu attribute match the
	processor_type enumeration in mips.h.

2001-02-28  Aldy Hernandez  <aldyh@redhat.com>

	* gcc/config/arm/arm.h (TARGET_DEFAULT): Add CIRRUS_FIX_INVALID_INSNS.

	* gcc/config/arm/arm.c (arm_reorg): Only run cirrus_reorg if
	TARGET_CIRRUS_FIX_INVALID_INSNS.

	* gcc/config/arm/arm.h (CIRRUS_FIX_INVALID_INSNS): New macro.
	(TARGET_CIRRUS_FIX_INVALID_INSNS): New macro.
	(cirrus-fix-invalid-insns): New option.
	(no-cirrus-fix-invalid-insns): New option.

	* gcc/invoke.texi: Add documentation for -mcirrus-fix-invalid-insns
	and -mno-cirrus-fix-invalid-insns.

2001-03-08  DJ Delorie  <dj@redhat.com>

	* config/sh/sh.h (OVERRIDE_OPTIONS): Disable relaxing for SHMEDIA.

2001-02-27  Michael Meissner  <meissner@redhat.com>

	* Makefile.in: (host version of varray.o): Add build rule.

2001-02-26  Michael Meissner  <meissner@redhat.com>

	* genmultilib (multilib_redundant_dirs): Emit declaration as const
	char *const, instead of char *.
	(multilib_dont_build_dirs): Ditto.

2001-02-13  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c
	(mn10300_get_live_callee_saved_regs): Don't search past
	LAST_EXTENDED_REGNUM.
	(mn10300_gen_multiple_store, store_multiple_operation): Likewise.

	* config/mn10300/mn10300.md: Remove excessive line breaks from
	`@' output patterns that were accounted as additional
	alternatives.

	* config/mn10300/mn10300.md, config/mn10300/mn10300.c:
	Re-introduce changes accidentally removed in Richard Sandiford's
	2000-12-05's patch.

	* config/mn10300/t-mn10300 (MULTILIB_OPTIONS, MULTILIB_DIRNAMES):
	Re-instate am33-2 lost in merge from net GCC.

2001-02-13  Alexandre Oliva  <aoliva@redhat.com>

	* jump.c (any_cond_computed_jump_p): Removed.
	* bb-reorder.c (fixup_reorder_chain): Don't call it.

2001-02-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (sibcall_compact): Set fp_mode to single.

2001-02-07  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (INT_ASM_OP) [SHMEDIA64]: Use `.quad'.

2001-02-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (INIT_CUMULATIVE_ARGS): Compute size of BLKmode
	return value correctly for call_cookie.

2001-02-01  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/crt1.asm (start): Modified so as to call
	___setup_argv_and_call_main.

2001-01-31  Ben Elliston  <bje@redhat.com>

	* config/m32r/t-m32r (m32rx): New target.
	(m32rx/crtinit.o): Depend on m32rx.
	(m32rx/crtfini.o): Likewise.

2001-01-26  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (FUNCTION_ARG_ADVANCE): Don't count stack_regs in
	SHmedia mode.

2001-01-20  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (STRIP_DATALABEL_ENCODING): New macro.
	(STRIP_NAME_ENCODING): Use it.
	(ASM_OUTPUT_LABELREF): Likewise.  Don't call assemble_name().

2001-01-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (sgeu) [! SHMEDIA]: Fix invocation of
	prepare_scc_operands().

	* config/sh/sh.h (SH_DATALABEL_ENCODING): Change to "#"...
	(DATALABEL_SYMNAME_P): ... so that we don't need memcmp here.

2001-01-17  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (STRIP_NAME_ENCODING): Strip leading `*'.

2001-01-12  Aldy Hernandez  <aldyh@redhat.com>

	* devo/gcc/sched-rgn.c (schedule_insns): Only estimate branch
	probability if flag set.

2001-01-15  Vladimir Makarov  <vmakarov@toke.toronto.redhat.com>

	* genattr.c (main): Make generation of prototypes of `dfa_start'
	and `dfa_finish' independently from CPU_UNITS_QUERY.

	* haifa-sched.c (ready_remove, max_issue): Make correct
	definition prototypes.

2001-01-15  Alexandre Oliva  <aoliva@redhat.com>

	* regmove.c (optimize_related_values): Don't add a NOTE after a
	CALL_INSN at the end of a basic block.

2001-01-13  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (shcompact_incoming_args): Use R0_REG.

	* config/sh/sh.md (R7_REG, R8_REG, R9_REG): Define as constants,
	used in shcompact_incoming_args.

	* config/sh/sh.c (sh_expand_epilogue): Fix thinko in previous
	change.

	* config/sh/crt1.asm (start) [SH5]: Switch to single-precision
	mode.
	* config/sh/lib1funcs.asm (sdivsi3_i4, udivsi3_i4, set_fpscr):
	Adjust accordingly.
	* config/sh/sh.c (sh_expand_prologue, sh_expand_epilogue):
	Simplify.  Adjust.  Add sanity check.
	* config/sh/sh.h (TARGET_SWITCHES) [5-compact]: Set
	FPU_SINGLE_BIT.
	* config/sh/sh.md (udivsi3_i4_single, divsi3_i4_single): Match
	TARGET_SHCOMPACT.
	(udivsi3, divsi3): Use them.
	(force_mode_for_call): New insn.
	(call, call_value, sibcall_value): Emit it before SHcompact
	calls.

2001-01-12  DJ Delorie  <dj@redhat.com>

	* Makefile.in (gcov.1): protect against texi2pod failing.

2001-01-12  Alexandre Oliva  <aoliva@redhat.com>

	* regmove.c (find_related_toplev): Find uses in function usage.

2001-01-11  Alexandre Oliva  <aoliva@redhat.com>

	* regmove.c (find_related_toplev): Call find_related() for USE or
	CLOBBER or non-REG.

2001-01-11  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (call, call_value, sibcall): Make sure the
	call cookie is non-NULL before taking its value.

	* config.gcc: Changed all occurrences of [[ and ]] to test or [
	and ], as appropriate.

2001-01-10  Alexandre Oliva  <aoliva@redhat.com>

	* config.gcc (sh64): Set target_requires_64bit_host_wide_int.

2001-01-09  Jim Wilson  <wilson@redhat.com>

	* Makefile.in (insn-recog.o): Change sed pattern 1-9 to 0-9.

2001-01-09  Vladimir Makarov  <vmakarov@toke.toronto.redhat.com>

	* sched-int.h: Add cygnus local code lost after merging.

	* sched-rgn.c: Ditto.

	* sched-vis.c: Ditto.

	* haifa-sched.c: Use public code on merging moment.  Add cygnus
	local code.

2001-01-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (shcompact_incoming_args): Set argument memory
	block.

	* config/sh/sh.h (STATIC_CHAIN_REGNUM) [SH5]: Use r1.
	* config/sh/sh.c (sh_expand_prologue) [SH5]: Use r0 as
	temporary for stack adjusts.  Use MACL and MACH to pass
	arguments to shcompact_incoming_args.
	* config/sh/sh.md (shcompact_incoming_args): Adjust.  Don't
	clobber r1.
	* config/sh/lib1funcs.asm (shcompact_incoming_args): Likewise.
	(nested_trampoline): Load static chain address into r1.

	* config/sh/sh.md (movdi_media splits): Fix sign-extension.

2001-01-08  Bernd Schmidt  <bernds@cygnus.co.uk>

	* regmove.c (optimize_related_values_1): When linking two chains,
	update end_luid of the head chain.  Consistently use end_luid
	instead of end->luid.

2001-01-07  Alexandre Oliva  <aoliva@redhat.com

	* config/sh/sh.c (fpul_operand) [SHMEDIA]: Just call
	fp_arith_reg_operand().

	Merged from net GCC:
	Mon Nov 27 17:29:44 2000  kaz Kojima <kkojima@rr.iij4u.or.jp>
	* gcc/config/sh/sh.md (udivsi3_i4, udivsi3_i4_single): Clobber
	T register.
	Tue Oct 31 15:33:27 2000  J"orn Rennecke <amylaar@redhat.com>
	* sh.md (mulsf3, mulsf3_i4): Use fp_arith_reg_operand for "f" operands.
	(mulsf3_ie, macsf3, cmpgtsf_t, cmpeqsf_t, ieee_ccmpeqsf_t): Likewise.
	(cmpgtsf_t_i4, cmpeqsf_t_i4, ieee_ccmpeqsf_t_4, negsf2): Likewise.
	(negsf2_i, sqrtsf2, sqrtsf2_i, abssf2, abssf2_i, adddf3): Likewise.
	(adddf3_i, subdf3, subdf3_i, muldf3, muldf3_i, divdf3): Likewise.
	(divdf3_i): Likewise.
	(floatsisf2): Likewise.  Use fpul_operand for 'y' operand.
	(floatsisf2_i4, floatsisf2_ie, fix_truncsfsi2): Likewise.
	(fix_truncsfsi2_i4, fixsfsi, floatsidf2, floatsidf2_i): Likewise.
	(fix_truncdfsi2, fix_truncdfsi2_i, extendsfdf2): Likewise.
	(extendsfdf2_i4, truncdfsf2, truncdfsf2_i4): Likewise.

2001-01-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (casesi): Sign-extend the first two operands,
	and use signed compares for them.

	* config/sh/sh.c (dump_table): Don't emit 8-byte constants after
	4-byte ones.  Instead, inter-leave them, maintaining the 8-byte
	ones properly aligned.
	(find_barrier): Account for extra alignment needed for 8-byte wide
	constants.
	(machine_dependent_reorg): Require a label for the second 4-byte
	constant after an 8-byte one.

	* config/sh/lib1funcs.asm (sdivsi3): Fix typo in yesterday's
	change.

2001-01-05  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (machine_dependent_reorg) [SHCOMPACT]: Reset
	last_float when switching float modes.

	* config/sh/sh.md (movdf) [SH5]: Don't use stack-pointer
	auto-increment for general-purpose registers.

	* config/sh/lib1funcs.asm (sdivsi3) [SHMEDIA]: Sign-extend the
	result.

	* config/sh/sh.c (sh_expand_prologue) [SH5]: Use r1 as temporary
	for stack adjust.

	* config/sh/sh.c (sh_builtin_saveregs): Support using all
	registers for varargs.
	* config/sh/sh.h (FUNCTION_ARG_ADVANCE): Simplify.

	* config/sh/sh.h (CALL_COOKIE_STACKSEQ,
	CALL_COOKIE_STACKSEQ_SHIFT, CALL_COOKIE_STACKSEQ_GET): New macros.
	(CALL_COOKIE_INT_REG_SHIFT): Adjust.
	(FUNCTION_ARG_ADVANCE): Use SHCOMPACT_FORCE_ON_STACK.  Adjust
	call_cookie accordingly.
	(FUNCTION_ARG): Test SHCOMPACT_FORCE_ON_STACK.
	(SHCOMPACT_BYREF): Likewise.
	(SHCOMPACT_FORCE_ON_STACK): New macro.
	* config/sh/sh.c (sh_expand_prologue): Use new call_cookie format.
	(sh_builtin_saveregs): Likewise.
	* config/sh/lib1funcs.asm (shcompact_call_trampoline,
	shcompact_incoming_args): Use new shift values.  Support
	sequences of consecutive and non-consecutive pushes/pops.

	* config/sh/sh.md (return): Don't explicitly use PR_REG.

2001-01-05  Hans-Peter Nilsson  <hpn@cygnus.com>

	* config/sh/sh.h (TEXT_SECTION): Define.
	* config/sh/elf.h (ASM_FILE_START): Output TEXT_SECTION_ASM_OP.

2001-01-05  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (INIT_CUMULATIVE_LIBCALL_ARGS): New macro.

	* config/sh/sh.h (BASE_RETURN_VALUE_REG): Use FP regs for
	return values on FPU-enabled SHmedia.
	(FUNCTION_VALUE_REGNO_P): Mark FIRST_FP_RET_REG as used on
	FPU-enabled SHmedia.
	(INIT_CUMULATIVE_ARGS): Set up return trampoline only if
	value is returned in a non-FP reg and is not returned by
	reference.

	* config/sh/sh.md (shcompact_return_tramp_i): Change type to
	jump_ind.

2000-01-04  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (SH_MIN_ALIGN_FOR_CALLEE_COPY): New.
	(FUNCTION_ARG_CALLEE_COPIES): Require argument to be
	quad-aligned to be passed by callee-copy reference.

2001-01-03  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/elf.h (MAX_WCHAR_TYPE_SIZE): Define.
	* config/sh/sh64.h (MAX_WCHAR_TYPE_SIZE): Undefine.

2001-01-02  Nick Clifton  <nickc@redhat.com>

	* GCC-HACK-RULES: Update comments about CYGNUS LOCAL markers.
	  Add note about using sanitize-cygnus.

2001-01-02  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (shcompact_call_trampoline): Fix error in
	copying low-numbered FP regs to r7 and r8.

	* config/sh/sh.h (FUNCTION_ARG_ADVANCE): Don't request copying of
	FP regs to general-purpose regs only if the copy was passed on the
	stack.
	* config/sh/lib1funcs.asm (shcompact_call_trampoline): Fix typo in
	copying FP reg to r9.

2001-01-01  Alexandre Oliva  <aoliva@redhat.com>

	* config/d10v/d10v.h (REGISTER_MOVE_COST): Adjust.
	* config/frv/frv.h (REGISTER_MOVE_COST): Adjust.
	* config/generic/generic.h (REGISTER_MOVE_COST): Adjust.

	Merge from net GCC:
	2000-10-01  Mark Mitchell  <mark@codesourcery.com>
	* config/fx80: Remove all filee in directory.
	* config/pyr: Likewise.
	* config/tahoe: Likewise.
	* config/gmicro: Likewise.
	* config/spur: Likewise.

	* config/sh/sh.h (FUNCTION_ARG_ADVANCE): Use trampoline to
	copy FP regs to general-purpose regs only in outgoing calls.

	* config/sh/sh.md (movdf_media, movsf_media): Revert incorrect
	change from 2000-10-30.  Adjust for 64-bit (or 32-bit)
	HOST_WIDE_INT.

	* config/sh/sh.h (struct sh_args): Document all fields.
	(FUNCTION_OK_FOR_SIBCALL): Functions that receive arguments
	passed partially on the stack should not consider making
	sibcalls.

	* config/sh/sh.h (FUNCTION_ARG_ADVANCE): Add byref regs to
	stack_regs only for incoming calls.  When passing FP args,
	make sure there are FP regs available before modifying
	call_cookie.
	(SHCOMPACT_BYREF): Pass double args in general-purpose
	registers by reference.

2000-12-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (FUNCTION_OK_FOR_SIBCALL) [SHCOMPACT]: Don't
	attempt to generate sibcalls if the caller got any arguments
	by reference.

	* config/sh/lib1funcs.asm (set_fpscr) [SH5]: Default to double.

	* config/sh/sh.c (dump_table) [SHCOMPACT]: Align DImode and DFmode
	to 8-byte boundaries.

	* config/sh/sh.md (shcompact_preserve_incoming_args): New insn.
	* config/sh/sh.h (CALL_COOKIE_INT_REG_GET): New macro.
	* config/sh/sh.c (sh_expand_prologue): Preserve args that will be
	stored in the stack.

	* config/sh/lib1funcs.asm (ct_main_table, ia_main_table): Arrange
	for the offsets to have the ISA bit set.
	(shcompact_call_trampoline): Document.  Swap r0 and r1, to match
	invocation.  Use beq instead of bgt to mark end of sequence of
	loads.
	(shcompact_incoming_args): Fix store of r2.  Use beq instead of
	bgt to mark end of sequence of stores.

	* config/sh/sh.c (arith_operand): Don't check whether
	CONST_OK_FOR_J for now.

	* config/sh/sh.md (movdf_media, movsf_media): Use HOST_WIDE_INT
	instead of long for conversion.

2000-12-29  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (print_operand_address): Convert INTVAL to int
	before passing it to fprintf.

2000-12-28  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/crt1.asm (start): Reset SR.FD, to enable the FP unit.
	Call set_fpscr before reading/writing SR.

	* config/sh/crt1.asm (start): Set SR.SZ and SR.PR, but not SR.FR.
	Call set_fpscr.
	* config/sh/lib1funcs.asm: Add `.align 2' directives before
	SHmedia code.
	(FMOVD_WORKS): Define on SH5 with FPU.
	(set_fpscr): Define on SH5.  Remove separate _fpscr_values
	setting.
	* config/sh/t-sh64 (LIB1ASMFUNCS): Add _set_fpscr instead of
	_fpscr_values.

2000-12-28  Hans-Peter Nilsson  <hpn@cygnus.com>

	* config/sh/lib1funcs.asm (ct_main_table): Align contents to even
	address.
	(ia_main_table): Ditto.

2000-12-27  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (MAX_WCHAR_TYPE_SIZE): Don't define.
	* config/sh/sh64.h (WCHAR_TYPE, WCHAR_TYPE_SIZE): Reinstate
	the definitions from sh.h.

	* config/sh/sh.h (PTRDIFF_TYPE): Define as conditional on
	TARGET_SH5.
	(SUBTARGET_CPP_SPEC): Arrange for __PTRDIFF_TYPE__ to be defined.
	* config/sh/elf.h (PTRDIFF_TYPE): Likewise.
	* config/sh/sh64.h (SUBTARGET_CPP_SPEC): Likewise.

2000-12-26  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (movdi_media split): Don't add REG_LABEL notes.
	Increment LABEL_NUSES.

	* config/sh/sh.h (SIZE_TYPE): Define as conditional on
	TARGET_SH5.
	(SUBTARGET_CPP_SPEC): Arrange for __SIZE_TYPE__ to be always
	defined.
	* config/sh/elf.h (SIZE_TYPE): Likewise.
	* config/sh/sh64.h (SUBTARGET_CPP_SPEC): Likewise.

	* config/sh/lib1funcs.asm (shcompact_call_trampoline,
	shcompact_incoming_args): Load switch table addresses using
	datalabel.

	* config/sh/sh.h (SUBTARGET_CPP_SPEC): Define __SIZE_TYPE__.
	(NO_BUILTIN_SIZE_TYPE): Define.
	(SIZE_TYPE): Don't define.
	* config/sh/sh64.h (SUBTARGET_CPP_SPEC): Define __SIZE_TYPE__.

	* config/sh/sh.h (CPP_SPEC): Fixed typo that prevented the
	definition of __SH5__=32 for -m5-compact-nofpu.

	* config/sh/sh.c (barrier_align): Ensure 32-bit alignment after
	ADDR_DIFF_VEC.

2000-12-24  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (FUNCTION_ARG_PADDING): Removed.

2000-12-23  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (TARGET_CACHE32): Enable on SH5.
	(FUNCTION_BOUNDARY): Ensure 32-bit alignment for SHmedia.
	(INSN_LENGTH_ALIGNMENT): Likewise.

2000-12-22  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (call, call_value, sibcall): Simplify
	copying of non-branch-target register.

2000-12-22  Alexandre Oliva  <aoliva@redhat.com>

	* glimits.h (__LONG_MAX__): Revert 2000-12-13's patch.
	* config/sh/sh.h (CPP_SPEC): Define it here for 64-bit SHmedia.

2000-12-22  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (GET_SH_ARG_CLASS): Handle complex
	floating-point values as structs.
	(FUNCTION_ARG): Use SH5_PROTOTYPED_FLOAT_ARG.
	(SH5_PROTOTYPELESS_FLOAT_ARG): List FP registers before
	general-purpose register.
	(SH5_PROTOTYPED_FLOAT_ARG): New macro.

2000-12-20  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (addsi3): Force operand1 to reg for SHmedia.

	* config/sh/sh.md (movsi_media): Split CONST_DOUBLE loads too.

	* config/sh/sh.h (DATALABEL_REF_P): Don't require the CONST.
	(ENCODE_SECTION_INFO): Enclose variables and constants in
	DATALABEL unspecs.
	(SH_DATALABEL_ENCODING, DATALABEL_SYMNAME_P): Define.
	(STRIP_NAME_ENCODING): Strip SH_DATALABEL_ENCODING off.
	(ASM_OUTPUT_LABELREF, AMS_OUTPUT_SYMBOL_REF): Define.
	* config/sh/sh.c (gen_datalabel_ref): Use UNSPEC_DATALABEL
	only for LABEL_REFs.  For SYMBOL_REFs, prepend
	SH_DATALABEL_ENCODING to the symbol name.

	* config/sh/sh.md (indirect_jump): Use SUBREG instead of
	convert_mode().

2000-12-20  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (casesi): Enclose ADDR_DIFF_VEC address in
	UNSPEC_DATALABEL.
	* config/sh/sh.c (gen_datalabel_ref): Accept LABEL_REFs.
	* config/sh/sh.h (DATALABEL_REF_NO_CONST_P): Likewise.
	(DATALABEL_REF_P): Don't require CONST.
	(ASM_OUTPUT_ADDR_DIFF_ELT): On SH5, output datalabel before
	REL label.

2000-12-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (extendhidi2, extendqidi2): Use arithmetic shift
	right.

2000-12-18  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (movsi_media, call, call_value, sibcall):
	Use shallow_copy_rtx and PUT_MODE to change the mode of
	SYMBOL_REFs, LABEL_REFs, CONSTs, etc.

	* config/sh/sh.h (PREFERRED_RELOAD_CLASS): Reload SYMBOL_REFs
	on SHmedia using GENERAL_REGs.

	* config/sh/sh.md (ble_media_i, blt_media_i, bleu_media_i,
	bltu_media_i): Fix reversion of conditions.

2000-12-18  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (zero_extendhidi2): Use logical shift right.

	* config/sh/sh.c (output_far_jump): Save r13 in macl.

2000-12-17  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (gen_datalabel_ref): Fix mode of the UNSPEC.

2000-12-16  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (ic_invalidate): Define for SH5.
	(GCC_nested_trampoline): Likewise.
	* config/sh/sh-protos.h (gen_datalabel_ref): Declare.
	* config/sh/sh.c (gen_datalabel_ref): Define.
	* config/sh/sh.h (TRAMPOLINE_SIZE): Adjust for SH5.
	(INITIALIZE_TRAMPOLINE): Likewise.
	(TRAMPOLINE_ADJUST_ADDRESS): Define.
	(DATALABEL_REF_NO_CONST_P, DATALABEL_REF_P): Define.
	(EXTRA_CONSTRAINT_T): Match DATALABEL unspecs.
	(OUTPUT_ADDR_CONST_EXTRA): Handle DATALABEL unspecs.
	* config/sh/sh.md (UNSPEC_DATALABEL): New constant.
	(ic_invalidate): Adjust for SH5.
	(ic_invalidate_line_media, ic_invalidate_line_compact): New insns.
	* config/sh/t-sh64 (LIB1ASMFUNCS): Added _ic_invalidate and
	_nested_trampoline.

2000-12-15  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (MOVE_MAX): Set to 8 for SHmedia, 4 elsewhere.
	(MOVE_MAX_PIECES): Set to 8 on SHmedia too.

Thu Dec 14 16:05:21 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (DBX_REGISTER_NUMBER): Adjust for sh64-elf-gdb.
	* config/sh/elf.h (DBX_REGISTER_NUMBER): Likewise.

Thu Dec 14 15:12:16 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (target_reg_operand): Match only target-branch
	registers and pseudos that aren't virtual registers.
	* config/sh/sh.md (call, call_value, sibcall) [TARGET_SHMEDIA]:
	Copy operands that don't match target_reg_operand to pseudos.
	(call_media, call_value_media, sibcall_media): Use
	target_reg_operand instead of target_operand.

2000-12-13  Alexandre Oliva  <aoliva@redhat.com>

	* glimits.h (__LONG_MAX__) [SH5 == 64]: Adjust for 64 bits.

	* config/sh/sh.c (target_reg_operand): Match hardware registers
	other than branch-target registers.

	* config/sh/sh.md (zero_extendqidi2): Input operand is %1.

	* config/sh/lib1funcs.asm (sdivsi3) [SH5]: Make it global.
	(fpscr_values) [SH5 == 32]: Define.
	* config/sh/t-sh64 (LIB1ASMFUNCS): Add fpscr_values.

	* config/sh/sh.md (call, call_value, sibcall) [TARGET_SHMEDIA]:
	Handle function addresses coming in SUBREGs.

2000-12-13  DJ Delorie  <dj@redhat.com>

	* config/i386/win32.h (ENCODE_SECTION_INFO): Fix ggc calls.
	* config/i386/winnt.c (i386_pe_encode_section_info): Ditto.

Tue Dec 12 22:32:26 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm (shcompact_call_trampoline,
	shcompact_return_trampoline): Use datalabel where appropriate.

2000-12-11  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h: Fix warning.

Sat Dec  9 02:19:28 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (SECONDARY_OUTPUT_RELOAD_CLASS): Use a
	general-purpose register to copy one branch-target register to
	another.

2000-12-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (target_operand): Accept LABEL_REFs and
	SYMBOL_REFs with VOIDmode.
	* config/sh/sh.md (ble_media_i, blt_media_i, bleu_media_i,
	bltu_media_i): New insns.

2000-12-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (RETURN_IN_MEMORY): Adjust for SH5 ABI.
	(INIT_CUMULATIVE_ARGS): Likewise.

2000-12-01  Alexandre Oliva  <aoliva@redhat.com>

	* regmove.c (chain_ends_later): Extract the register from an auto
	inc/dec rtx.

	* rtl.h (any_cond_computed_jump_p): Declare.
	* jump.c (any_cond_computed_jump_p): Define.
	* bb-reorder.c (fixup_reorder_chain): Don't crash on computed
	jumps.
	* machmode.def (V16SFmode): New mode.
	* c-common.c (type_for_mode): Support V2SF and V16SF.
	* tree.c (build_common_tree_nodes_2): Likewise.
	* tree.h (tree_index): Likewise.
	* calls.c (emit_call_1): Take args_so_far.  Adjust all
	callers.  Introduce CALL_POPS_ARGS.
	* tm.texi (CALL_POPS_ARGS): Document.
	* config/sh/crt1.asm: Implement in SHmedia mode.
	* config/sh/crti.asm, config/sh/crtn.asm: Likewise
	* config/sh/elf.h (ASM_SPEC, LINK_SPEC): Support SH5 flags.
	(DBX_REGISTER_NUMBER): Renumber registers for SH5.
	* config/sh/lib1funcs.asm: Disable functions unused in SH5.
	Implement divsi and udivsi in SHmedia mode.  Introduce
	SHcompact trampolines.
	* config/sh/sh.c (GEN_MOV, GEN_ADD3, GEN_SUB3): Use DImode
	only in SHmedia64.
	(regno_reg_class): Rewrite.
	(fp_reg_names): Remove.
	(sh_register_names, sh_additional_register_names): New.
	(print_operand): Added `u'.  Support SUBREGs in addresses.
	Add parentheses around shifted CONSTs.
	(output_file_start): Output .mode and .abi directives.
	(shiftcosts, addsubcosts, multcosts): Adjust.
	(output_stack_adjust): Compute alignment.  Sanity-check SIZE.
	(push_regs): Take array of HOST_WIDE_INTs.  Adjust callers.
	(calc_live_regs): Output to array of HOST_WIDE_INTs.  Count
	bytes, not registers.  Take into account the need for the
	SHcompact incoming args trampoline.  Adjust all callers.
	(sh_expand_prologue): Take stack_regs into account.  Call
	incoming args trampoline.  Keep stack aligned as per SH5 ABI.
	(sh_expand_epilogue): Take stack_regs into accoutn.  Keep
	stack aligned as per SH5 ABI.
	(sh_builtin_saveregs): Support SH5 ABI.
	(sh_build_va_list, sh_va_start): Likewise.
	(initial_elimination_offset): Take alignment into account.
	Compute location of PR according to the SH5 stack frame.
	(arith_reg_operand): Reject branch-target registers.
	(shmedia_6bit_operand): New.
	(logical_operand): Use CONST_OK_FOR_P on SHmedia.
	(target_reg_operand): Match DImode only.  Accept SUBREGs.
	(target_operand): New.
	* config/sh/sh.h (CPP_SPEC, SUBTARGET_CPP_SPEC): Support SH5 flags.
	(CONDITIONAL_REGISTER_USAGE): Implement SH5 ABI.  Initialize
	SIBCALL_REGS for SHmedia.
	(TARGET_SH3E, TARGET_SH4): Only if SH1_BIT is set too.
	(TARGET_FPU_DOUBLE, TARGET_FPU_ANY): New.
	(TARGET_SHMEDIA32, TARGET_SHMEDIA64): New.
	(TARGET_SWITCHES): New SH5 flags.
	(OVERRIDE_OPTIONS): Set SH5-specific options.  Use
	VALID_REGISTER_P to disable unsupported registers.
	(LONG_TYPE_SIZE, LONG_LONG_TYPE_SIZE): Set.
	(POINTER_SIZE, PARM_BOUNDARY): Adjust.
	(FUNCTION_ARG_PADDING): Define.
	(FASTEST_ALIGNMENT): Adjust.
	(SH_REGISTER_NAMES_INITIALIZER): New.
	(sh_register_names): Declare.
	(DEBUG_REGISTER_NAMES): Define.
	(REGISTER_NAMES): Define based on sh_register_names.
	(SH_ADDITIONAL_REGISTER_NAMES_INITIALIZER): New.
	(sh_additional_register_names): Declare.
	(LAST_GENERAL_REG, LAST_FP_REG, LAST_XD_REG): Adjust for SHmedia.
	(FIRST_TARGET_REG, LAST_TARGET_REG): Define.
	(TARGET_REGISTER_P, SHMEDIA_REGISTER_P, VALID_REGISTER_P): Define.
	(REGISTER_NATURAL_MODE): Define.
	(FIRST_PSEUDO_REGISTER): Adjust.
	(FIXED_REGISTERS, CALL_USED_REGISTERS): Adjust.
	(HARD_REGNO_CALL_PART_CLOBBERED): Define.
	(HARD_REGNO_NREGS, HARD_REGNO_MODE_OK): Adjust.
	(VECTOR_MODE_SUPPORTED_P): Define.
	(REG_CLASS_CONTENTS): Adjust.
	(SMALL_REGISTER_CLASSES): Adjust.
	(REG_ALLOC_ORDER): Adjust.
	(INDEX_REG_CLASS): Adjust.
	(CONST_OK_FOR_O, CONST_OK_FOR_P): New.
	(CONST_OK_FOR_LETTER_P): Adjust.
	(PREFERRED_RELOAD_CLASS): Adjust.
	(SECONDARY_OUTPUT_RELOAD_CLASS): Adjust.
	(SECONDARY_INPUT_RELOAD_CLASS): Adjust.
	(NPARM_REGS, FIRST_PARM_REG, FIRST_RET_REG): Adjust.
	(FIRST_FP_PARM_REG): Adjust.
	(CALL_POPS_ARGS): Define.
	(FUNCTION_ARG_REGNO_P): Adjust.
	(struct sh_args): New fields.
	(GET_SH_ARG_CLASS): Adjust.
	(INIT_CUMULATIVE_ARGS): Adjust.
	(INIT_CUMULATIVE_INCOMING_ARGS): Define.
	(FUNCTION_ARG_ADVANCE): Adjust.
	(FUNCTION_ARG): Adjust.
	(FUNCTION_ARG_PASS_BY_REFERENCE, SHCOMPACT_BYREF): Define.
	(FUNCTION_ARG_CALLEE_COPIES): Define.
	(SH5_PROTOTYPELESS_FLOAT_ARG): Define.
	(STRICT_ARGUMENT_NAMING): Define.
	(PRETEND_OUTGOING_VARARGS_NAMED): Adjust.
	(FUNCTION_ARG_PARTIAL_NREGS): Adjust.
	(SH5_WOULD_BE_PARTIAL_NREGS): Define.
	(SETUP_INCOMING_VARARGS): Adjust.
	(HAVE_POST_INCREMENT, HAVE_PRE_DECREMENT): Adjust.
	(USE_LOAD_POST_INCREMENT, USE_STORE_PRE_DECREMENT): Adjust.
	(REGNO_OK_FOR_INDEX_P, REG_OK_FOR_INDEX_P): Adjust.
	(SUBREG_OK_FOR_INDEX_P): Adjust.
	(EXTRA_CONSTRAINT_S): Update.
	(EXTRA_CONSTRAINT_T): New.
	(EXTRA_CONSTRAINT): Adjust.
	(GO_IF_LEGITIMATE_INDEX): Adjust.
	(GO_IF_LEGITIMATE_ADDRESS): Adjust.
	(LEGITIMIZE_ADDRESS, LEGITIMIZE_RELOAD_ADDRESS): Adjust.
	(MOVE_MAX): Adjust.
	(MAX_MOVE_MAX): Define.
	(Pmode): Adjust.
	(CONST_COSTS): Adjust.
	(REGISTER_MOVE_COST): Adjust.
	(BRANCH_COST): Adjust.
	(TEXT_SECTION_ASM_OP): Adjust.
	(DBX_REGISTER_NUMBER): Adjust.
	(ASM_OUTPUT_DOUBLE_INT): New.
	(UNALIGNED_DOUBLE_INT_ASM_OP): New.
	(PREDICATE_CODES): Adjust.
	(PROMOTE_MODE): Adjust.
	(CRT_CALL_STATIC_FUNCTION): Do not define for SHmedia.
	* config/sh/sh.md (AP_REG, PR_REG, T_REG, GBR_REG): Renumber.
	(MACH_REG, MACL_REG, FPUL_REG, RAP_REG, FPSCR_REG): Renumber.
	(PR_MEDIA_REG, T_MEDIA_REG, R10_REG): New.
	(DR0_REG, DR2_REG, DR4_REG): Renumber.
	(TR0_REG, TR1_REG, TR2_REG): New.
	(XD0_REG): Renumber.
	(UNSPEC_COMPACT_ARGS): New.
	(type): Added pt and ptabs.
	(length): Default to 4 on SHmedia.  Default pt length to 12
	and 20 on SHmedia32 and SHmedia64, respectively.
	(pt): New function unit.
	(movdi, movsi): Add types pt and ptabs.  Don't increment LABEL_NUSES.
	Add whitespace between operands of SHmedia instructions.
	(movdicc): Fix.
	(adddi3_media, addsi3_media): Adjust constraints.
	(subsi3) [SHmedia]: Force operand 1 into a register.
	(udivsi3_i1_media, udivsi3_i4_media): New.
	(udivsi3): Support SHmedia.
	(divsi3_i1_media, divsi3_i4_media): New.
	(divsi3): Support SHmedia.
	(anddi3, iordi3, xordi3): Adjust constraints.
	(zero_extendhidi2, zero_extendqidi2): New.
	(extendsidi2, extendhidi2, extendqidi2): New.
	(push, pop, push_e, push_fpul, push_4): Disable on SH5.
	(pop_e, pop_fpul, pop_4): Likewise.
	(movsi_media): Support FP and BT registers.
	(movsi_media_nofpu): New.  Adjust splits to DImode.
	(lduw, ldub): Renamed to zero_extend* above.
	(movqi_media): Fix typo.
	(movdi_media): Support FP and BT registers.
	(movdi_media_nofpu): New.  Adjust splits for SHmedia32.
	(movdi_const_32bit): New.
	(shori_media): Require immediate operand.  Use `u' for output.
	(movdf_media, movsf_media): Simplified.
	(movdf_media_nofpu, movsf_media_nofpu): New.
	(movdf, movsf): Adjust
	(movv2sf, movv2sf, movv16sf): New.
	(beq_media, beq_media_i): Adjust constraints.  Don't use
	scratch BT register.
	(bne_media, bne_media_i): Likewise.
	(bgt_media, bgt_media_i): Likewise.
	(bge_media, bge_media_i): Likewise.
	(bgtu_media, bgtu_media_i): Likewise.
	(bgeu_media, bgeu_media_i): Likewise.
	(beq, bne, bgt, blt, ble, bge, bgtu, bltu, bgeu, bleu,
	bunordered): Emit jump insn.  Force operands to registers when
	needed.
	(jump_media, jump): Simplify.
	(call_compact, call_compact_rettramp): New.
	(call_value_compact, call_value_compact_rettramp): New.
	(call_media, call_value_media): Simplify.
	(sibcall_compact, sibcall_media): New.
	(call, call_value): Adjust for SHmedia and SHcompact.
	(sibcall, sibcall_value, untyped_call): Likewise.
	(sibcall_epilogue): Preserve r0 across epilogue for SHcompact.
	(indirect_jump): Adjust for SHmedia.
	(casesi_jump_media): New.
	(nop): Re-enable for SHmedia.
	(call_site): Restrict to SH1.
	(casesi): Adjust for SHmedia.
	(casesi_shift_media, casesi_load_media): New.
	(return): Explicitly use PR register.  Call return trampoline
	on SHcompact.
	(return_i): Explicitly use PR register.
	(shcompact_return_tramp, shcompact_return_tramp_i): New.
	(return_media): Adjust.
	(shcompact_incoming_args): New.
	(epilogue): Adjust.
	(seq, slt, sle, sgt, sge, sgtu, sltu, sleu, sgeu, sne): Adjust.
	(movstrsi): Disable on SH5.
	(fpu_switch0, fpu_switch1, movpsi): Enable on SH4.
	(addsf3, addsf3_media): Test TARGET_SHMEDIA_FPU.
	(subsf3, subsf3_media): Likewise.
	(mulsf3, mulsf3_media, mac_media): Likewise.
	(divsf3, divsf3_media): Likewise.
	(floatdisf2, floatsisf2_media): Likewise.  Adjust constraints.
	(floatsisf2, fux_truncsfsi2): Likewise.
	(fix_truncsfdi2, fix_truncsfsi2_media): Likewise.  Adjust
	constraints.
	(cmpeqsf_media, cmpgtsf_media, cmpgesf_media): Likewise.
	(cmpunsf_media, cmpsf): Likewise.
	(negsf2, negsf2_media, sqrtsf2, sqrtsf2_media): Likewise.
	(abssf2, abssf2_media): Likewise.
	(adddf3, adddf3_media, subdf3, subdf3_media): Likewise.
	(muldf3, muldf3_media, divdf3, divdf3_media): Likewise.
	(floatdidf2, floatsidf2_media): Likewise.  Adjust constraints.
	(floatsidf2, fix_truncdfsi2): Likewise.
	(fix_truncdfdi2, fix_truncdfsi2_media): Likewise.  Adjust
	constraints.
	(cmpeqdf_media, cmpgtdf_media): Likewise.
	(cmpgedf_media, cmpundf_media, cmpdf): Likewise.
	(negdf2, negdf2_media, sqrtdf2, sqrtdf2_media): Likewise.
	(absdf2, absdf2_media): Likewise.
	(extendsfdf2, extendsfdf2_media): Likewise.
	(truncsfdf2, truncsfdf2_media): Likewise.
	* config/sh/sh64.h: New file.
	* config/sh/t-sh64: New file.
	* config/sh/shmedia.h: New file.
	* config/sh/ushmedia.h: New file.
	* config/sh/sshmedia.h: New file.
	* configure.in: Added sh64-*-elf.
	* configure: Rebuilt.

2000-11-27  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.md: Fixup CYGNUS LOCAL markers.

2000-11-16  Bernd Schmidt  <bernds@cygnus.co.uk>

	* gcse.c (insert_insn_start_bb): Correctly determine position to
	insert new insn.  Call set_block_num for each new emitted insn.
	Update BLOCK_END, not BLOCK_HEAD, if appropriate.

2000-11-15  Bernd Schmidt  <bernds@cygnus.co.uk>

	* invoke.texi: Add missing "@end table" in a CYGNUS LOCAL block.

2000-11-14  Bernd Schmidt  <bernds@cygnus.co.uk>

	* regmove.c (regmove_optimize): Update old_max_uid after calling
	optimize_related_values.

2000-11-13  Geoffrey Keating  <geoffk@redhat.com>

	* config/i960/i960.h (TARGET_MOVE_COALESCENCE): Correctly spell
	TARGET_FLAG_MOVE_COALESCENCE.

2000-11-09  Alan Lehotsky  <alehotsky@cygnus.com>

	* dbxout.c (dbxout_type_fields): Ignore ERROR_MARK as type.

Fri Nov  3 16:26:46 2000  Vladimir Makarov  <vmakarov@redhat.com>

	* haifa-sched.c (RCSP_EXPANSION_LOOP_FACTOR): New macro.
	(scheduled_ops_number): New variable.
	(op_delete): Decrease value of scheduled_ops_number.
	(op_become_scheduled): Increase value of scheduled_ops_number.
	(start_ops): Initialize scheduled_ops_number.
	(get_best_candidate_avail_op): Ignore branches being moved into
	non dominator only for non-exit packets.
	(pipeline): Check value of RCSP_EXPANSION_LOOP_FACTOR.  Finish
	loop pipelining when loop being pipleined became big.

2000-10-30  Andrew Haley  <aph@redhat.com>

	* config/frv/frv.md (reload_incc_ccr): Generate the comparison of
	Operand 2 by using a gen_cmpsi_cc rather than a gen_movcc.

2000-11-01  Chandrakala Chavva  <cchavva@redhat.com>

	* libgcc2.h: Use Wtype for SItype and DWtype for DItype in prototypes.
	* libgcc2.c (__absvsi2): Use Wtype and DWtype.
	(__absvdi2, __addvsi3, __addvdi3, __subvsi3): Likewise.
	(__subvdi3, __mulvsi3, __mulvdi3, __negvsi2, __negvdi2): Likewise.

2000-10-30  Geoffrey Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.h: Add cygnus local markers to software
	pipelining stuff.
	* config/rs6000/rs6000.md: Likewise.
	* config/rs6000/rs6000.c: Tidy up certain merge inconsistencies.

Mon Oct 30 11:23 2000  Nick Clifton

	* configure.in: Tidy up cygnus local markers.
	* configure: Regenerate.
	* extend.texi: Tidy up cygnus local markers.
	* gcc.c: Tidy up cygnus local markers.
	* invoke.texi: Tidy up cygnus local markers.
	* libgcc1-test.c: Tidy up cygnus local markers.
	* stor-layout.c: Tidy up cygnus local markers.
	* toplev.c: Tidy up cygnus local markers.
	* config/arm/arm.h: Tidy up cygnus local markers.
	* config/arm/semi.h: Tidy up cygnus local markers.
	* config/arm/semiaof.h: Tidy up cygnus local markers.
	* config/arm/t-wince-pe: Tidy up cygnus local markers.
	* config/m32r/m32r.md: Tidy up cygnus local markers.
	* config/m32r/t-m32r: Tidy up cygnus local markers.
	* config/v850/lib1funcs.asm: Tidy up cygnus local markers.
	* config/v850/t-v850: Tidy up cygnus local markers.
	* config/v850/v850-protos.h: Tidy up cygnus local markers.
	* config/v850/v850.c: Tidy up cygnus local markers.
	* config/v850/v850.h: Tidy up cygnus local markers.
	* config/v850/v850.md: Tidy up cygnus local markers.

2000-10-26  Andrew Haley  <aph@redhat.com>

	* config/frv/frv.md (cond_exec_ck): This insn's condition is in
	operand 3.

2000-10-27  Nick Clifton  <nickc@redhat.com>

	* arm.c (is_load_address): Make static.
	(is_cirrus_insn): Make static.
	(cirrus_reorg): Make static.
	Fix typo.

2000-10-26  Angela Marie Thomas <angela@cygnus.com>

	* config/arm/t-cirrus-elf: Configure to install multilibbed libgcc.

2000-10-26  Eric Christopher  <echristo@cygnus.com>

	* config/frv/frv.c (frv_secondary_reload_class): Remove
	ATTRIBUTE_UNUSED from reg_class enum.

2000-10-24  Eric Christopher  <echristo@cygnus.com>

	* config/frv/frv.md (movcc_fp): Change to define_expand.
	(*internal_movcc_fp): New pattern.

2000-10-24  Richard Henderson <rth@cygnus.com>, Aldy <aldyh@cygnus.com>

	* config/mn10300/mn10300.h (PREFERRED_RELOAD_CLASS): Treat
	pseudos just like memory.

2000-10-20  Eric Christopher  <echristo@cygnus.com>

	* Brought over from frv branch.

	Thu Oct 12 23:07:38 2000  Michael Meissner  <meissner@redhat.com>

	* frv.h (FUNCTION_BOUNDARY): Set to 128 to get 16 byte alignment.

	* lib1funcs.asm (all functions): Align all functions to a 16 byte
	alignment.

	2000-10-18  Eric Christopher  <echristo@cygnus.com>

		* config/frv/frv.md (movcc_fp): Add cc to cc move to
		constraints.

	Mon Sep 18 17:04:23 2000  Michael Meissner  <meissner@redhat.com>

		* frv.c (frv_tmp_reg_t): Undo 9/13 changes.
		(frv_ifcvt_modify_tests): Ditto.
		(frv_referenced_dead_p): Delete, no longer used.

	        * frv.md (cond_exec_si_smul): Comment out for now, to work
		around problem where flow gets confused when this creates a
		DI register, and then only uses the bottom register.

	Thu Sep 21 09:58:58 2000  Michael Meissner  <meissner@redhat.com>

		* frv.md (minmax_si_signed): Don't allow op2 to be the same
		as op0 if op3 is a constant.
	        (minmax_si_unsigned): Ditto.

	Wed Sep 13 05:04:57 2000  Michael Meissner  <meissner@redhat.com>

		* frv.c (frv_tmp_reg_t): Add a live register field.
		(frv_referenced_dead_p): New function to determine if a basic
		block refers to a dead register.
		(frv_ifcvt_modify_tests): Work around bug where dead code
		is not entirely eliminated, and causes reference to dead
		register in a dead section.
		(frv_ifcvt_modify_insn): Add ATTRIBUTE_UNUSED to unused
		argument.

	Tue Sep 12 00:13:11 2000  Michael Meissner  <meissner@redhat.com>

		* frv.md (movcc): Add a match_scratch and fold movcc_gpr
		processing into movcc.
		(reload_incc): Ditto.
		(reload_outcc): Ditto.
		(movcc_gpr): Delete, no longer used.
		(movcc_uns): Add a match_scratch and fold movcc_uns_gpr
		processing into movcc_uns.
		(reload_incc_uns): Ditto.
		(reload_outcc_uns): Ditto.
		(movcc_uns_gpr): Ditto.

	Tue Sep  5 02:27:50 2000  Michael Meissner  <meissner@redhat.com>

		* frv.c (REGSTATE_*): New macros to represent the register
		state.
		(frv_registers_set): Delete, no longer used.
		(frv_registers_update): New function to determine what
		registers are updated in each insn.
		(frv_registers_used_p): Rewrite to better track the register
		state.
		(frv_machine_dependent_reorg): Better track register usage and
		dependencies in repacking the VLIW instructions to allow insns
		that are used in THEN and ELSE conditional codes to be used in
		the same VLIW instruction.

	Fri Sep  1 14:42:42 2000  Michael Meissner  <meissner@redhat.com>

		* t-frv (MULTILIB_DIRNAMES): Remove g0.
		(MULTILIB_MATCHES): Don't equate -G0 with pic.

		* frv.c (frv_machine_dependent_reorg): Do not allow a check
		instruction to be packed in the same VLIW instruction as an
		earlier conditional branch.

	Fri Sep  1 09:51:41 2000  Catherine Moore  <clm@redhat.com>

		* config/frv/frv.c (frv_conditional_register_usage):  pic
		and sda	registers are always fixed.


	Fri Sep  1 03:59:46 2000  Michael Meissner  <meissner@redhat.com>

		* frv-protos.h (frv_ifcvt_modify_tests): Take a ce_if_block
		structure pointer instead of separate arguments for test, then,
		else, or join blocks.  Add support for folding && or || tests
		into conditional execution code.
		(frv_ifcvt_modify_multiple_tests): Ditto.
		(frv_ifcvt_modify_insn): Ditto.
		(frv_ifcvt_modify_final): Ditto.
		(frv_ifcvt_modify_cancel): Ditto.

		* frv.h (TARGET_SWITCHES): Add -m{,no-}multi-cond-exec switch
		to control whether && and || are handled in conditional
		execution code.
		(IFCVT_MODIFY_*): Take a ce_if_block structure pointer instead
		of separate arguments for test, then,  else, or join blocks.

		* frv.c (frv_ifcvt_check_insns): Rename from
		frv_ifcvt_check_insn and hold multiple insns to insert and
		where to insert them.
		(frv_initial_temp_reg): Avoid -Wshadow warnings.
		(frv_expand_prologue): Remove unused variable.
		(frv_registers_set): Ditto.
		(frv_machine_dependent_reorg): Ditto.
		(output_condmove_single): Replace 0 with gr0.
		(frv_ifcvt_modify_tests): Take a ce_if_block structure pointer
		instead of separate arguments for test, then, else, or join
		blocks.  Add support for folding && or || tests into
		conditional execution code.
		(frv_ifcvt_modify_multiple_tests): Ditto.
		(frv_ifcvt_modify_insn): Ditto.
		(frv_ifcvt_modify_final): Ditto.
		(frv_ifcvt_modify_cancel): Ditto.
		(frv_add_gc_roots): Rename frv_ifcvt_check_insns.

		* frv.md (cond_exec_ck): Conditionally execute check insn.
		(minmax_si_signed): Split minmax insn into signed and
		unsigned to eliminate a warning.
		(minmax_si_unsigned): Ditto.

	2000-08-31 Jason Eckhardt  <jle@redhat.com>

	        * config/frv/frv.c (frv_expand_prologue): Don't allow large
		constants for 12-bit memory operations.

	        * config/frv/frv.h: Need dtof name instead of truncdfsf2.
2000-10-19  Chandrakala  Chavva  <cchavva@redhat.com>

	* Makefile.in: Remove CYGNUS LOCAL.
	* expr.c: Remove CYGNUS LOCAL.
	* expr.h: Remove CYGNUS LOCAL.
	* optabs.c: Remove CYGNUS LOCAL.
	* genopinit.c: Remove CYGNUS LOCAL.
	* flags.h: Remove CYGNUS LOCAL.
	* tree.h: Remove CYGNUS LOCAL.
	* toplev.c: Remove CYGNUS LOCAL.
	* invoke.texi: Remove CYGNUS LOCAL.
	* libgcc2.c: Remove CYGNUS LOCAL.
	* expmed.c: Remove CYGNUS LOCAL.

2000-10-18  Eric Christopher  <echristo@cygnus.com>

	* config/frv/frv.md: Fix formatting.
	 (movcc_fp): Add cc to cc move to constraints.
2000-10-18  Geoffrey Keating  <geoffk@cygnus.com>

	* config/i386/t-netware: Remove CYGNUS LOCAL.
	* config/i386/netware.h: Remove CYGNUS LOCAL, update
	#include filenames.
	* config/netware.h: Remove CYGNUS LOCAL.
	* config/rs6000/netware.h: Delete.
	* configure.in: Remove CYGNUS LOCAL from i[34567]86-*-netware.
	* configure: Hand-edit to match configure.in change.

	* invoke.texi (Option Summary): Don't document -msched-prolog
	flags.  Don't document -mvxworks twice.

Tue Oct 17 14:04:56 2000  Chandrakala Chavva  <cchavva@redhat.com>

	* cppinit.c (new_pending_directive): Removed CYGNUS LOCAL markers.
	* gcc.c (target_help_flag, display_help, process_command): Likewise.
	* invoke.texi: Likewise.
	* toplev.c (target_help_flag, display_help, process_command,
	main): Likewise.

2000-10-17  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000/rs6000.c (rs6000_hash_constant): Use X0INT to access a
	LABEL_REF.

2000-10-17  Bernd Schmidt  <bernds@cygnus.co.uk>

	* rtl.def (UNORD): Remove.
	* rtl.texi (UNORD): Remove documentation.
	(toplevel menu): Remove unnecessary CYGNUS LOCAL comment.
	* tree.c (build_common_tree_nodes_2): Make sure CYGNUS_LOCAL markers
	cover only CYGNUS LOCAL code.
	* tree.h: Likewise.
	* i386.h (PREDICATE_CODES): Remove duplicate of
	sse_comparison_operator.

2000-10-13  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.c (arm_final_prescan_insn): Do not conditionalize
	Cirrus instructions.

	* config/arm/arm.md (cirrus): New attribute.
	("cirrus_adddi3"): Use it.
	("*cirrus_addsi3"): Use it.
	("*cirrus_addsf3"): Use it.
	(*cirrus_addf3): Use it.
	(cirrus_subdi3): Use it.
	("*cirrus_subsi3_insn"): Use it.
	("*cirrus_subsf3"): Use it.
	("*cirrus_subdf3"): Use it.
	("*cirrus_mulsi3"): Use it.
	("muldi3"): Use it.
	("*cirrus_mulsi3addsi"): Use it.
	("*cirrus_mulsi3subsi"): Use it.
	("*cirrus_mulsf3"): Use it.
	("*cirrus_muldf3"): Use it.
	("cirrus_ashl_const"): Use it.
	("cirrus_ashiftrt_const"): Use it.
	("cirrus_ashlsi3"): Use it.
	("ashldi3"): Use it.
	("cirrus_ashldi_const"): Use it.
	("cirrus_ashiftrtdi_const"): Use it.
	("*cirrus_absdi2"): Use it.
	("*cirrus_negdi2"): Use it.
	("*cirrus_negsi2"): Use it.
	("*cirrus_negsf2"): Use it.
	("*cirrus_negdf2"): Use it.
	("*cirrus_abssi2"): Use it.
	("*cirrus_abssf2"): Use it.
	("*cirrus_absdf2"): Use it.
	("cirrus_floatsisf2"): Use it.
	("cirrus_floatsidf2"): Use it.
	("floatdisf2"): Use it.
	("floatdidf2"): Use it.
	("cirrus_truncsfsi2"): Use it.
	("cirrus_truncdfsi2"): Use it.
	("*cirrus_truncdfsf2"): Use it.
	("*cirrus_extendsfdf2"): Use it.
	("*cirrus_arm_movdi"): Use it.
	("*cirrus_arm_movsi_insn"): Use it.
	("*cirrus_movsf_hard_insn"): Use it.
	("*cirrus_movdf_hard_insn"): Use it.
	("*cirrus_cmpsf"): Use it.
	("*cirrus_cmpdf"): Use it.
	("*cirrus_cmpdi"): use it.
	("*cirrus_cmpsi_1"): Use it.

	* config/arm/arm.c (arm_reorg): Call cirrus_reorg.
	(cirrus_reorg): New.
	(is_cirrus_insn): New.
	(is_load_address): New.

Wed Oct 11 21:47:06 2000  Michael Meissner  <meissner@redhat.com>

	* mips.h (MASK_MIPS_TFILE): Delete second definition.

2000-10-11  Timothy Wall  <twall@cygnus.com>

	* config/ia64/aix.h ([CD]TOR_LIST_[BEGIN|END]): Define.  Clean
	up for proper C++ functionality.  Remove NO_IMPLICIT_EXTERN_C
	so we get the right wrappers around C headers.
	* config/ia64/t-aix: Use standard crtstuff.c instead of
	ia64-specific files.
	* config/ia64/crt[in].asm: New for monterey.
	* configure.in: No longer use t-ia64 fragment.
	* configure: Regenrate.

Wed Oct 11 23:00:55 2000  J"orn Rennecke <amylaar@redhat.co.uk>

	* genopinit.c (optabs): Change add/sub/smul/neg/abs to
	accept partial integers again.
	(gen_insn): Interpret '$P' as requiring an integer mode,
	including partial integer modes.

2000-10-10  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (GEN_MOV, GEN_ADD3, GEN_SUB3): New macros.
	(reg_class_from_letter): Use `b' for TARGET_REGS.
	(print_operand): Support `%M', `%m', `AND' and
	`ASHIFTRT'.  Do not precede constants with `#' on SHmedia.
	(andcosts): Adjust for SHmedia.
	(output_stack_adjust, sh_expand_prologue, sh_expand_epilogue):
	Likewise.
	(target_reg_operand): New function.
	* config/sh/sh-protos.h (target_reg_operand): Declare.
	* config/sh/sh.h (CONDITIONAL_REGISTER_USAGE): Don't disable
	FP registers on SH5.
	(HARD_REGNO_MODE_OK): Accept them whenever they're acceptable
	on SH4.
	(TARGET_REGISTER_P): New macro.
	(reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS): Added TARGET_REGS.
	(FUNCTION_VALUE): Use DImode for promoted types on SHmedia.
	(EXTRA_CONSTRAINT_S): New macro.
	(EXTRA_CONSTRAINT): Adjust.
	(FLOAT_TYPE_SIZE): Define to 32.
	(Pmode): DImode on SHmedia.
	(CONST_COSTS): Adjust for SHmedia literals.
	(PREDICATE_CODES): Added target_reg_operand.
	(PROMOTE_MODE): Promote signed types to DImode on SHmedia.
	* config/sh/sh.md: Remove all attrs from SHmedia insns.
	(cmpeqdi_media, cmpgtdi_media, cmpgtudi_media): New insns.
	(cmpdi): Accept SHmedia.
	(movdicc_false, movdicc_true): New insns.
	(movdicc): New expand.
	(adddi3): Accept arith_operand for op2, but FAIL on SH1 if
	no_new_pseudos.
	(addsi3_media): Match `S' constraint.
	(anddi3, andcdi3, iordi3, xordi3, negdi_media): New insns.
	(negdi2): Expand for SHmedia.
	(one_cmpldi2): New expand.
	(zero_extendsidi2): Change from expand to insn.
	(extendsidi2): Add constraints.
	(movdi_media, movsi_media): Change `%x' to `%M'.  Use `%m' for
	LD/ST address.  Fix SI immediate loading split.
	(movhi_media, movqi_media, lduw, ldub): New insns.
	(movhi, movqi): Accept SHmedia.
	(shori_media, movdi_media): Relax input constraints.  Split
	symbolic constants.
	(movdf_media, movsf_media): New insn.  New split to movdi.
	(movdf, movsf): Match on SHmedia.
	(beq_media, bne_media, bgt_media, bge_media, bgtu_media,
	bgeu_media): New insns and splits.  New insns with `_i' suffix.
	(beq, bne, bgt, blt, ble, bge, bgtu, bltu, bgeu, bleu): Adjust.
	(bunordered): New expand.
	(jump_compact): Renamed from `jump'.
	(jump_media): New insn.
	(jump): New expand.
	(call_media, call_value_media): New insns.
	(call, call_value): Adjust.
	(indirect_jump_compact): Renamed from `indirect_jump'.
	(indirect_jump_media): New insn.
	(indirect_jump): New expand.
	(untyped_call, return): Accept SHmedia.
	(return_media): New insn.
	(prologue, epilogue, blockage): Accept SHmedia.
	(seq, slt, sle, sgt, sge, sgtu, sltu, sleu, sgeu, sne): Adjust.
	(sunordered): New expand.
	(addsf3, subsf3, mulsf3, divsf3, floatsisf2, fix_truncsfsi2,
	cmpsf, negsf2, sqrtsf2, abssf2): Adjust for SHmedia.
	(addsf3_media, subsf3_media, mulsf3_media, mac_media,
	divsf3_media, floatdisf2, floatsisf2_media, fix_truncsfdi2,
	fix_truncsfsi2_media, cmpeqsf_media, cmpgtsf_media,
	cmpgesf_media, cmpunsf_media, negsf2_media, sqrtsf2_media,
	abssf2_media): New insns.
	(adddf3, subdf3, muldf3, divdf3, floatsidf2, fix_truncdfsi2,
	cmpdf, negdf2, sqrtdf2, absdf2): Adjust for SHmedia.
	(adddf3_media, subdf3_media, muldf3_media, divdf3_media,
	floatdidf2, floatsidf2_media, fix_truncdfdi2,
	fix_truncdfsi2_media, cmpeqdf_media, cmpgtdf_media,
	cmpgedf_media, cmpundf_media, negdf2_media, sqrtdf2_media,
	absdf2_media): New insns.
	(extendsfdf2, truncdfsf2): Adjust for SHmedia.
	(extendsfdf2_media, truncdfsf2_media): New insns.

2000-10-06  DJ Delorie  <dj@redhat.com>

	* gcc.c (main): Don't warn about unused -B prefixes
	(unused_prefix_warnings): remove

2000-10-03  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (schedule_insns): Call dfa_start and dfa_finish.

	* genautomata.c (make_dfa_insn_code_attr): Rename it onto
	internal_make_dfa_insn_code_attr.
	(output_dfa_insn_code_func, output_dfa_start_func,
	output_dfa_finish_func): New functions.
	(DFA_INSN_CODES_VARIABLE_NAME, DFA_START_FUNC_NAME,
	DFA_FINISH_FUNC_NAME, I_VARIABLE_NAME,
	INTERNAL_DFA_INSN_CODE_FUNC_NAME): New macros.
	(write_automata): Output definition of dfa_insn_codes and call
	output_dfa_insn_code_func, output_dfa_start_func, and
	output_dfa_finish_func.

	* genattr.c (main): Output external declarations of dfa_start and
	dfa_finish.

2000-10-02  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (schedule_insn): Use delay in cycles as insn mark
	only when macro ANNOTATE_INSNS_BY_DELAY_IN_CYCLES is defined.

2000-09-26  Graham Stott  <grahams@redhat.com>

	* i386.md (define_attr "cpu"): Add missing pentiumiii.

	* i386.h (processor_type): Move pentiumiii to the end.

	* i386.c (override_options): Reorder processor_target_table to
	reflect reordered processor_type enumeration.

2000-09-21  Richard Henderson  <rth@cygnus.com>

	* unroll.c (copy_loop_body): Update LABEL_NUSES before
	calling invert_jump.

2000-09-20  Angela Marie Thomas <angela@cygnus.com>

	* Makefile.in: CYGNUS LOCAL: binary installation, install fixincl
	with the other fixincludes programs.

2000-09-19  Bernd Schmidt  <bernds@redhat.co.uk>

	(floatsisf2, floatsidf2, extendsfdf2): Also use reg_no_subreg_operand
	predicate for the expanders.

2000-09-18  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (*cirrus_cmpsf): compare directly to PSR.  Get
	rid of splitter and lots of extra code.
	(*cirrus_cmpdf): same.
	(cmpdi): same.
	(*cirrus_cmpsi_1): same.

	* config/arm/arm.c (arm_gen_compare_reg): do comparisons directly
	instead of copying result into an Arm register.
	(arm_select_cc_mode): return CCFP mode for LT, LE, GT, and GE as
	well.

2000-09-18  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (insert_schedule_bubbles_p): New global variable.
	(only_evaluate_block_p): Rename it onto
	only_evaluate_scheduled_block_p.
	(dfa_state_size): New variable.
	(rank_for_schedule): Use name only_evaluate_scheduled_block_p.
	(queue_to_ready): Change DFA state by DFA_SCHEDULER_PRE_CYCLE_INSN
	and DFA_SCHEDULER_POST_CYCLE_INSN.
	(max_issue): Use dfa_state_size.  Don't call recog_memoized.
	Check that insn can be issued after bubble.
	(schedule_block): Use dfa_state_size.  Change DFA state by
	DFA_SCHEDULER_PRE_CYCLE_INSN and DFA_SCHEDULER_POST_CYCLE_INSN.
	Use name only_evaluate_scheduled_block_p.
	(schedule_insns): Set up and use dfa_state_size.  Initiate pre-
	and post-cycle insns.
	(cpu_state_issue): Try to insert bubble to issue insn.
	(cpu_state_advance_cycle): Change DFA state by
	DFA_SCHEDULER_PRE_CYCLE_INSN and DFA_SCHEDULER_POST_CYCLE_INSN.

2000-09-18  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (cirrus_lshiftrt_const): change name to
	cirrus_ashiftrt_const and make it an arithmetic shift.
	(cirrus_lshiftrtdi_const): change name to cirrus_ashiftrt_const
	and make it an arithmetic shift.
	(lshrdi3): remove.

2000-09-15  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md ("*cirrus_si2cc"): make move conditional.

Thu Sep 14 02:36:11 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.c (machine_dependent_reorg): On shmedia, skip for now.
	* config/sh/sh.h (CONST_OK_FOR_J): Document.
	(LEGITIMATE_CONSTANT_P): Accept CONST_DOUBLEs on shmedia.
	* config/sh/sh.md (adddi3): New expand.
	(adddi3_media, adddi3z_media): New insns.
	(adddi3_compact): Renamed from adddi3.
	(addsi3_media): Use add.l r63 to add constant zero.
	(subdi3): New expand.
	(subdi3_media): New insn.
	(subdi3_compact): Renamed from subdi3.
	(mulsidi3): New expand.
	(mulsidi3_media): New insn.
	(mulsidi3_compact): Renamed from mulsidi3.
	(umulsidi3): New expand.
	(umulsidi3_media): New insn.
	(umulsidi3_compact): Renamed from umulsidi3.
	(ashlsi3_media, ashrsi3_media, lshrsi3_media): New insns.
	(ashlsi3, ashrsi3, lshrsi3): Use them.
	(ashldi3_media, ashrdi3_media, lshrdi3_media): New insns.
	(ashldi3, ashrdi3, lshrdi3): Use them.
	(zero_extendsidi2): New expand.
	(extendsidi2): New insn.
	(movsi_media): New insn.  Split to movdi to load constants.
	(movsi): Enable for shmedia.
	(movdi_media): New insn.  Use shori_media to load wide constants.
	(short_media): New insn.
	(movdi): Enable for shmedia.

Mon Sep 11 12:57:49 2000  Donald Lindsay  <dlindsay@cygnus.com>

	* gcse.c (gcse_main,alloc_gcse_mem,free_gcse_mem,compute_hash_table
	reset_opr_set_tables,compute_transp): Init, free and use of new array
	canon_modify_mem_list[].
	Added new routine canon_list_insert, called from
	record_last_mem_set_info, to set canon_modify_mem_list[].
	* alias.c: Added canon_true_dependence, a variant of true_dependence.
	* rtl.h (get_addr,canon_true_dependence): Add signatures of
	get_addr and canon_true_dependence to support the above.
	Collectively these maintain an array which parallels modify_mem_list,
	but which is already canonicalized. This greatly reduces memory
	consumption during a pathological GCSE case.

2000-09-13  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (*cirrus_arm_movdi): use Q and R modifiers to
	take endianness into account.
	(*cirrus_movdf_hard_insn): same.

2000-09-11  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/t-cirrus-elf: remove definitions for
	FLOAT_[WORD/BIT]_ORDER_MISMATCH in cirrus mode.

	* config/arm/arm.md ("*cirrus_movdf_hard_insn"): moves from cirrus
	to arm should agree with DI patterns.

	* config/arm/arm.h (FLOAT_WORDS_BIG_ENDIAN): float word endianness
	can vary in cirrus.

	* config/arm/arm.md ("*cirrus_movdf_hard_insn"): move lower half
	first.  Cosmetic.

2000-09-12  Andrew Haley  <aph@redhat.com>

	* regmove.c (optimize_related_values): Stop scanning when
	GEN_FCN fails.

2000-09-12  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* genautomata.c (output_internal_insn_code_evaluation): Add
	parameter for returning default value when the insn has not
	been mentioned in automata.
	(output_trans_func, output_state_alts_func,
	output_min_insn_conflict_delay_func, output_insn_latency_func):
	Use the new parameter.

2000-09-11  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* rtl.def (DEFINE_QUERY_CPU_UNIT): Define.
	(DEFINE_BYPASS): Add the new optional field.

	* genautomata.c (W_OPTION): New macro.
	(w_flag): New variable.
	(unit_decl): Add new member query_p.
	(bypass_decl): Add new member bypass_guard_name.
	(description): Add new member query_units_num.
	(state): Add new members pass_number, min_insn_issue_delay.
	(arc): Remove member pass_number.
	(ainsn): Add new members arc_exists_p, max_min_delay, and
	min_issue_delay_table_compression_factor.  Remove member
	min_issue_delay_table.
	(gen_cpu_unit): Set up new member query_p.
	(gen_query_cpu_unit): New function.
	(gen_bypass): Set up new member bypass_guard_name.
	(gen_automata_option): Use macro W_OPTION and set up new variable
	w_flag.
	(add_presence_absence): Generate error or warning which is
	depended on w_flag.
	(process_decls): Ditto.
	(check_automaton_usage, check_usage): Ditto.
	(reserv_sets_are_intersected): Process presence set correctly.
	(add_arc): Set up arc_exists_p.
	(output_min_issue_delay_comb_vect_name,
	output_min_issue_delay_check_vect_name,
	output_min_issue_delay_base_vect_name): Remove the functions.
	(output_min_issue_delay_full_vect_name): Rename the function onto
	output_min_issue_delay_vect_name.
	(current_min_insn_issue_delay, current_arc_pass_number): Remove
	the variables.
	(current_state_pass_number): New variable.
	(min_issue_delay_pass_states): Remove the 3rd parameter and
	rewrite the function.
	(min_issue_delay): Don't check min_insn_issue_delay on negative
	value.
	(initiate_min_issue_delay_pass_states): Use
	current_state_pass_number instead of current_arc_pass_number.
	(output_min_issue_delay_table): Output the table only as vector
	possibly compressed.
	(output_reserved_units_table): Use bit instead of byte to
	represent a table value.
	(output_internal_min_issue_delay_func): Generate the function
	which uses compressed full vector.
	(output_internal_trans_func): Generate function which returns -1
	instead of zero for state which really permits to issue the insn.
	(output_min_insn_conflict_delay_func): Take the previous into
	account.
	(output_internal_insn_latency_func): Generate the function which
	uses two more parameters (the insns themself) besides their codes
	and calls function bypass_guard_name if it is defined.
	(output_insn_latency_func): Add generation of more two parameters
	in the call.  Fix typo in generation of the second parameter.
	(output_get_cpu_unit_code_func, output_cpu_unit_reservation_p):
	Make them working only for query units.
	(output_state_arcs): Add output of equivalence class of insn.
	(output_statistics): Calculate and output statistics for new
	representation of table min_issue_delay.
	(initiate_automaton_gen): Use new macro W_OPTION and variable
	w_flag.
	(check_automata): New function.
	(expand_automata): Add call of check_automata.

	* genattrtab.c (gen_query_cpu_unit): Add the new function
	prototype.
	(main): Add processing query_cpu_unit.

	* genattr.c (main): Generate zero default value for macro
	AUTOMATON_STATE_ALTS.

	* haifa-sched.c (original_max_uid): The new variable.
	(insn_cost): Don't set up zero cost for unrecognized insn.  Make
	minimal output dependency cost equal to 1.  Use new macro
	ADJUST_DFA_DEPENDENCY_COST.
	(schedule_insn): Don't place new cycle marks on USE and CLOBBER
	insns.  Use TImode instead of DImode as the mark before reload and
	cycle delay after reload.
	(restore_line_notes): Ignore insns with uid greater or equal to
	original_max_uid.
	(max_issue): Take into account that state_transition may return
	negative value.  Try to insert scheduler bubble to get better
	schedule.
	(schedule_block): Ditto.  Reset cpu units state after scheduling
	asm insn.
	(remove_new_cpu_cycle_marks): Use TImode instead of DImode.
	(schedule_insns): Set up original_max_uid and initialize work with
	scheduler bubbles.
	(cpu_state_issue): Take into account that state_transition may
	return negative value.

Fri Sep  8 17:42:22 2000  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.h (CPP_SPEC): Added `m5'.
	(SUBTARGET_CPP_SPEC): Added `!m5'.
	(SH5_BIT, TARGET_SH5, TARGET_SHMEDIA, TARGET_SHCOMPACT): New macros.
	(TARGET_SWITCHES): Added `5' and `5-compact'.  Added SH1_BIT
	to all other SH variants.
	(TARGET_DEFAULT): Set to SH1_BIT.
	(OVERRIDE_OPTIONS): Recognize sh5 CPU.
	(BITS_PER_WORD): Raise to 64 on shmedia.
	(MAX_BITS_PER_WORD): Change to 64.
	(MAX_LONG_TYPE_SIZE, MAX_WCHAR_TYPE_SIZE): Set to MAX_BITS_PER_WORD.
	(INT_TYPE_SIZE): Keep as 32.
	(UNITS_PER_WORD): Raise to 8 on shmedia.
	(MIN_UNITS_PER_WORD): Keep as 4.
	(POINTER_SIZE): Raise to 64 on shmedia.
	(CONST_OK_FOR_J): New macro.
	(CONST_OK_FOR_LETTER_P): Use it.
	(processor_type): Add PROCESSOR_SH5.
	* config/sh/sh.md: Conditionalize all expands, insns and
	splits to TARGET_SH1.
	(cpu): Added sh5.
	(addsi3_compact): Renamed from...
	(addsi3): Now an expand.
	(addsi3_media, subsi3_media): New insns.
	(subsi3): Don't negate constants with SHmedia.

2000-09-08  Andrew Haley  <aph@redhat.com>

	* cppinit.c (new_pending_directive): Add CYGNUS LOCAL markers.
	* gcc.c (target_help_flag, display_help, process_command): Likewise.
	* invoke.texi: Likewise.
	* toplev.c (target_help_flag, display_help, process_command,
	main): Likewise.

2000-09-08  J"orn Rennecke <amylaar@cygnus.co.uk>

	* expmed.c (expand_mult): Don't do synth_mult optimization for -ftrapv.
	Use smulv_optab for -ftrapv.
	(expand_mult_highpart): Use unsigned multiply.
	(expand_divmod): Special-case division by -1.
	For EXACT_DIV_EXPR, do right shift first, then the multiply.
	For complex divide, use abs with unsigned result.
	* expr.c (force_operand): Use unsigned multiply.
	(expand_expr): Use overflow-trapping optabs for signed types if
	flag_trapv.
	If flag_trapv, don't generate a recursive call with EXPAND_SUM
	if the type is signed and the original call wasn't EXPAND_SUM or
	EXPAND_INITIALIZER.
	* expr.h (addv_optab, subv_optab, smulv_optab, sdivv_optab): Declare.
	(negv_optab, absv_optab): Declare.
	* flags.h (flag_trapv): Declare.
	* genopinit.c (optabs): Add entries for addv_optab, subv_optab,
	smulv_optab, sdivv_optab, negv_optab and absv_optab.
	* loop.c (emit_iv_add_mult): Use unsigned expand_mult_add.
	(product_cheap_p): Use unsigned expand_mult.
	* optabs.c (addv_optab, subv_optab, smulv_optab, sdivv_optab): Define.
	(negv_optab, absv_optab): Define.
	(expand_binop): Use overflow-trapping optabs for signed types if
	flag_trapv.
	Handle negv_optab libe neg_optab.
	(expand_abs): Take result_unsignedp argument instead of unsignedp one.
	Use overflow-trapping optabs for signed result if flag_trapv.
	(expand_complex_abs): Use overflow-trapping optabs for signed types if
	flag_trapv.
	Don't open-code complex absolute-value operation for flag_trapv.
	(init_optabs): Initialize addv_optab, subv_optab, smulv_optab,
	sdivv_optab, negv_optab and absv_optab.
	* toplev.c (flag_trapv): Define.
	(lang_independent_options f_options): Include flag_trapv.
	* tree.h (TYPE_TRAP_SIGNED): Define.

2000-09-07  Andrew Haley  <aph@redhat.com>

	* libgcc2.c (__addvsi3, __addvdi3, __subvsi3,__subvsi3, __subvdi3,
	__mulvsi3, __negvsi2, __negvdi2, __absvsi2, __absvdi2, __mulvdi3):
	New functions.
	* Makefile.in: add _absvsi2 _absvdi2 _addvsi3 _addvdi3 _subvsi3
	_subvdi3 _mulvsi3 _mulvdi3 _negvsi2 _negvdi2.

Fri Sep  8 07:08:06 2000  J"orn Rennecke <amylaar@redhat.co.uk>

	* expr.c (convert_move): Use zero_extendpsisi2 to do an unsigned
	extension from PSImode to SImode.

2000-09-06  Nick Clifton  <nickc@redhat.com>

	* tree.c (make_node): Revert experimental patch accidentally
	checked in with recent EGCS merge.

2000-09-02  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/lib1funcs.asm: Add blank to `defined(__linux__)'.
	* config/sh/sh.h (SMALLPOOLS_BIT): Remove.
	(target_flags): Remove -msmallpools.
	* config/sh/sh.c (barrier_align): Likewise.
	* invoke.texi (SH Options): Likewise.

2000-09-01  Chandrakala Chavva <cchavva@redhat.com>

	* toplev.c (display_target_options): New function to print all target
	specific options.
	* gcc.c (main): New option --target-help.
	(process_command): Create a dummy file when invoked with this option.
	* cppinit.c (cpp_handle_option): OPT_target__help new. Use it.
	* invoke.texi: Added notes on --target-help option.

Thu Aug 31 23:23:05 2000  Jeffrey A Law  (law@cygnus.com)

	* regmove.c (find_related_toplev): Don't die if the target has
	a hole in its operands.

Thu Aug 31 21:46:57 2000  Jeffrey A Law  (law@cygnus.com)

	* arm.md: Fix lengths on Cirrus insns which generate more
	than one instruction.

	* arm.md (Cirrus movdf): Correct length computations.
	(Cirrus specific defines_insns that will be split): Similarly.

	* arm.md (ashrsi3): Remove Cirrus specific code.

	* arm.md (ashrsi3): Do not clobber operands[2] when generating
	a Cirrus right shift.
	(ashrdi3): Similarly.

2000-08-31  Bernd Schmidt  <bernds@cygnus.co.uk>

	* regmove.c (new_reg_use, create_rel_use, recognize_related_for_insn,
	record_reg_use): New functions, mostly broken out from find_related.
	(struct related): Lose union U, new field BASE.  All users changed
	to find the base correctly, and to use INVALIDATE_LUID instead of
	U.LAST_LUID.
	(struct rel_mod): New function.
	(lookup_related): New arg LUID.  All callers changed.  Don't return
	a match in the same insn if it's an autoinc.
	(rel_build_chain): Change BASE arg to be a struct related.  All callers
	changed.
	(rel_record_mem): Avoid generating autoincs if the same reg is used
	multiple times in this insn.
	Lose the do { } while (0) goto-avoidance construct.
	(invalidate_related): New arg INSN.  All callers changed.
	(find_related): Stripped down to handle only REGs and MEMs.
	(find_related_toplev): New function that inherits the old function of
	find_related.  USE insns are handled by introducing a new rel_use for
	them and terminating the corresponding chain.  The same is true for
	in-out operands.
	(mod_before): New function.
	(remove_setting_insns, perform_addition, modify_address): New
	functions, mostly broken out of	optimize_related_values_1.
	(optimize_related_values_1): Use several of the new functions instead
	of doing the work in-line.
	Don't recognize final uses by a null INSN, use NO_LINK_PRED.
	Avoid the optimization if any chains start after the base register's
	point of invalidation.
	Re-do the way the optimization is performed to create a table of
	modifications to be performed and sorting it by luid.
	(optimize_related_values): Use find_related_toplev instead of
	find_related.  Use INSN_P where appropriate.
	(regmove_optimize): Always call optimize_related_values if flag_regmove
	and flag_expensive_optimizations.

2000-08-30  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.h (CLASS_CANNOT_CHANGE_MODE): add macro.
	(CLASS_CANNOT_CHANGE_MODE_P): add macro.

2000-08-30  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/sh.md (GOTaddr2picreg): Don't use `use'; set
	current_function_uses_pic_offset_table instead.
	(symPLT_label2reg): Don't set
	current_function_uses_pic_offset_table.
	* config/sh/sh.c (sh_expand_prologue): Add sanity test of
	live_regs_mask regarding the PIC register.
	(sh_expand_epilogue, initial_elimination_offset): Test
	flag_pic and current_function_uses_pic_offset_table only.

	* config/sh/t-elf, config/sh/crt1.asm, config/sh/crti.asm,
	config/sh/crtn.asm: New files.
	* config/sh/t-sh (EXTRA_MULTILIB_PARTS): Set.
	(crt1.o, crti.o, crtn.o): New targets.
	* config/sh/t-linux (CRTSTUFF_T_CFLAGS_S): Remove.
	* configure.in [sh-*-elf*, sh-*-rtemself*] (tmake_file): Added
	sh/t-elf.
	[sh-*-linux*] (tmake_file): Likewise.
	* configure: Rebuilt.
	* config/sh/sh.h (INIT_SECTION_ASM_OP, FINI_SECTION_ASM_OP,
	STARTFILE_SPEC, ENDFILE_SPEC, CRT_CALL_STATIC_FUNCTION): Define.
	* config/sh/elf.h (INIT_SECTION_ASM_OP, FINI_SECTION_ASM_OP):
	Undefine for config/elfos.h to redefine.
	(STARTFILE_SPEC, ENDFILE_SPEC): Redefine after config/elfos.h.
	* config/sh/linux.h (ENDFILE_SPEC, INIT_SECTION_ASM_OP,
	FINI_SECTION_ASM_OP, CRT_CALL_STATIC_FUNCTION): Removed.

2000-08-28  Nick Clifton  <nickc@redhat.com>

	* c-common.c (name_of_actual_type): Handle the case where
	'formal' is NULL.
	(compare_format_types): Handle the cases where 'formal' is
	NULL or void.

2000-08-28  Aldy Hernandez  <aldyh@redhat.com>

	* devo/gcc/config/arm/arm.md ("*cirrus_addsi3"): disallow.
	("*cirrus_subsi3_insn"): same.
	("*cirrus_mulsi3"): same.
	("*cirrus_mulsi3addsi"): same.
	("*cirrus_mulsi3subsi"): same.
	("cirrus_ashl_const"): same.
	("cirrus_lshiftrt_const"): same.
	("cirrus_ashlsi3"): same.
	("*cirrus_negsi2"): same.
	("*cirrus_abssi2"): same.
	("*cirrus_arm_movsi_insn"): same.
	("*arm_movsi_insn"): remove Cirrus restrictions.
	("*cirrus_cmpsi"): disallow.
	("*cirrus_floatsisf2"): add clobber.  Use scratch register.
	Operand 1 is now an Arm register.  Remove '*' from name.
	("floatsisf2"): emit cirrus_floatsisf2 directly if cirrus.
	("floatsidf2"): emit cirrus_floatsidf2 directly if cirrus.
	("cirrus_floatsidf2"): remove '*' from name.  Operand 1 is now Arm
	register.  Add clobber.  Use scratch register.
	("fix_truncsfsi2"): emit cirrus_truncsfsi2.
	("cirrus_truncsfsi2"): operand 0 is Arm register.  Use scratch.
	Remove '*' from name.
	("fix_truncdfsi2"): emit cirrus_truncdfsi2.
	("cirrus_truncdfsi2"): remove '*' from name.  Operand 0 is Arm
	register.  Use scratch.

	* devo/gcc/config/arm/arm.h (HARD_REGNO_MODE_OK): disallow SI
	values in Cirrus registers.
	(GO_IF_LEGITIMATE_INDEX): same.

2000-08-29  Graham Stott  <grahams@cygnus.co.uk>

	* gcc.c (check_flag_for_restamp): Fix off-by-one error.

Mon Aug 28 22:40:43 2000  Michael Meissner  <meissner@redhat.com>

	* frv-protos.h (frv_split_minmax): New function.
	(frv_split_abs): Ditto.
	(minmax_operator): Ditto.
	(frv_machine_dependent_reorg): Ditto.

	* frv.c (minmax_operator): New predicate to recognize SMIN, SMAX,
	UMIN, and UMAX.
	(frv_split_minmax): Split min/max insns into constituent insns.
	(frv_split_abs): Split integer abs into constituent insns.
	(frv_clear_registers_used): Rename from frv_mark_register.  Clear
	bits for all real registers used for multi-reg values.
	(frv_ifcvt_modify_tests): Use frv_clear_registers_used instead of
	frv_mark_register.
	(frv_registers_set): Record which hard registers are modified in
	an insn.
	(frv_registers_used_p): Determine if an insn uses a group of hard
	registers.
	(frv_machine_dependent_reorg): New pass, recreate the VLIW
	instruction grouping to allow two conditional branches to be
	packed in the same VLIW instruction.

	* frv.h (TARGET_SWITCHES): Add -m{,no-}vliw-branch to control
	whether we redo the VLIW instruction packing to include
	conditional branches.
	(DEFAULT_BRANCH_COST): Set to 1 instead of 2 so that the tree->rtl
	phase won't use SCC instructions to implement && and ||.
	(PREDICATE_CODES): Add minmax_operator.
	(MACHINE_DEPENDENT_REORG): Define, call the function
	frv_machine_dependent_reorg.
	(CLEAR_VLIW_START): Clear the start of VLIW insn grouping.
	(SET_VLIW_START): Mark insn as start of VLIW insn grouping.

	* frv.md (type attribute): Delete unused cc member.
	(cpu attribute): Move before type.
	(control function unit): Delete test for unused cc type.
	(unknown function unit): Ditto.
	(abssi2): New insn that will later be split into real insns.
	(sminsi3,smaxsi3): Ditto.
	(uminsi3,umaxsi3): Ditto.
	(sminsf3,smaxsf3): Ditto.
	(smindf3,smaxdf3): Ditto.
	(movsi_pic): Rewrite to use define_insn_and_split.
	(movcc_gpr): Ditto.
	(movcc_uns_gpr): Ditto.
	(adddi3_internal): Ditto.
	(subdi3_internal): Ditto.
	(scc_float): Ditto.

2000-08-28  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md ("lshrsi3"): change range to include 64.
	("lshrdi3"): same.

2000-08-26  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.h (DBX_REGISTER_NUMBER): Added
	floating-point registers.

2000-08-25  Alexandre Oliva  <aoliva@redhat.com>

	* config/sh/linux.h (CRT_CALL_STATIC_FUNCTION): Override it.
	(INIT_SECTION_ASM_OP, FINI_SECTION_ASM_OP): Define.

2000-08-22  Bernd Schmidt  <bernds@cygnus.co.uk>

	* config/i386/i386.c (ix86_expand_sse_comi, ix86_expand_sse_compare,
	ix86_expand_unop1_builtin, ix86_expand_unop_builtin,
	ix86_expand_binop_builtin, ix86_expand_store_builtin,
	safe_vector_operand): Provide prototypes.
	(ix86_expand_builtin): Fix call to ix86_expand_sse_comi.

2000-08-22  Catherine Moore  <clm@redhat.com>

	* config/frv/frv.c (frv_print_operand_memory_reference):
	Print #gprel12.
	* config/frv/frv.md: Use # instead of % as prefix for hi, lo
	and gprel.

2000-08-22  Nick Clifton  <nickc@redhat.com>

	* config/arm/lib1funcs.asm (__umodsi3, __modsi3): Fix bug
	introduced in previous delta, when condition code CC was
	incorrectly translated into LS instead of LO.

2000-08-22  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.c (cirrus_shift_const): added comment.  Fixed
	range.

2000-08-22  Bernd Schmidt  <bernds@cygnus.co.uk>

	(struct rel_use_chain): Rename member CHAIN to USES.  All users
	changed.

	(optimize_related_values_1): Return void.  All callers changed.
	Move final processing from the end of this function to...
	(optimize_related_values_0): ...here.

	(find_related): Make FMT a const char *.

	(rel_record_mem): If we're seeing a register for the first time,
	record it properly as an unrelated use.

	From Joern Rennecke:
	* regmove.c (invalidate_related): New Argument call_tally.
	Set rel->reg_orig_calls_crossed when setting rel->invalidate_luid.
	Changed all callers.
	(optimize_related_values_1): Don't set rel->reg_orig_calls_crossed
	if rel->invalidate_luid is set.
	(optimize_related_values): Bump CALL_TALLY *after* inputs have
	been processed.
	(find_related): When recursively processing a SET_DEST of a
	CALL_INSN, pass an incremented value for CALL_TALLY.

	(optimize_related_values_1): Return early if no chains found.

	(struct rel_use): set_in_parallel is now unsigned.
	New member no_link_pred.
	(chain_ends_later): Take no_link_pred into account.
	(optimize_related_values_1): Don't link two chains if the predecessor
	has no_link_pred set.
	(lookup_related): Add a comment.

	(optimize_related_values_1): Don't assign base reg
	to chain that clobbers its register at the end if other chains
	need to be started later.

	(optimize_related_values_1): Don't include
	rel_base->reg in num_av_regs count.
	Check rel_base->invalidate_luid before setting rel_base_reg_user.

	(new_base): New function.
	(find_related): Use it.

2000-08-22  Niibe Yutaka  <gniibe@m17n.org>, Kaz Kojima  <kkojima@rr.iij4u.or.jp>, Alexandre Oliva  <aoliva@redhat.com>

	* configure.in (sh-*-linux*): Added.
	* configure: Rebuilt.
	* config/sh/t-linux: New file.
	* config/sh/sh.h (USERMODE_BIT, SMALLPOOLS_BIT): Define.
	(TARGET_USERMODE, TARGET_SMALLPOOLS): Likewise.
	(TARGET_SWITCHES): New switches for the bits above.
	(INITIALIZE_TRAMPOLINE): Call __ic_invalidate in USERMODE.
	* config/sh/sh.c (barrier_align): Handle TARGET_SMALLPOOLS.
	* config/sh/linux.h: New file.
	* config/sh/lib1funcs.asm (GLOBAL): Don't prefix symbols with
	underscore on linux.
	(L_sdivsi3, L_udivsi3): Define for linux.
	(L_ic_invalidate): Define.
	* invoke.texi (SH Options): Document -msmallpools, -musermode.

2000-08-22  Alexandre Oliva  <aoliva@redhat.com>, Niibe Yutaka  <gniibe@m17n.org>, Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* config/sh/sh-protos.h (nonpic_symbol_mentioned_p,
	legitimize_pic_address, output_pic_addr_const): Declare.
	* config/sh/sh.h (CONDITIONAL_REGISTER_USAGE): Fix PIC register.
	(PREFERGOT_BIT, TARGET_PREFERGOT): Likewise.
	(TARGET_SWITCHES): New switch -mprefergot.
	(OVERRIDE_OPTIONS): Set flag_no_function_cse unless -mprefergot.
	(PIC_OFFSET_TABLE_REGNUM): Define.
	(GOT_SYMBOL_TABLE): Likewise.
	(LEGITIMIZE_ADDRESS): Use legitimize_pic_address.
	(ENCODE_SECTION_INFO): Define.
	(FINALIZE_PIC): New macros.
	(LEGITIMATE_PIC_OPERAND_P, SYMBOLIC_CONST_P): New macro.
	(ASM_OUTPUT_INT, ASM_OUTPUT_SHORT): Use output_pic_addr_const.
	* sh.c (print_operand_address): Use output_pic_addr_const.
	(prepare_move_operands): Call emit_pic_move or
	emit_pic_const_move if appropriate.
	(output_far_jump): For PIC, use braf and output long offset.
	(machine_dependent_reorg):
	(sh_expand_prologue): Save and initialize the PIC register.
	(sh_expand_epilogue): Restore it.
	(initial_elimination_offset): Account for it.
	(nonpic_symbol_mentioned_p): New function.
	(legitimize_pic_address): Likewise.
	(output_pic_addr_const): Likewise.
	* sh.md (calli_pcrel, call_valuei_pcrel): New insns.
	(call, call_value): Use them.
	(GOTaddr2picreg, sym_label2reg, symGOT2reg, symGOTOFF2reg,
	symPLT_label2reg): New expands.
	* invoke.texi (SH Options): Document -mprefergot.

2000-08-21  Aldy Hernandez  <aldyh@redhat.com>

	* arm.h (PREDICATE_CODES): add cirrus_shift_const.

	* arm.md ("cirrus_ashldi_const"): use it.
	("cirrus_lshiftrtdi_const"): use it.
	("cirrus_ashl_const"): use it.
	("cirrus_lshiftrt_const"): use it.
	("lshrdi3"): force shift operands that are out of range into a
	register.
	("lshrsi3"): force shift operands that are out of range into a
	register.

	* arm.c (cirrus_shift_const): new function.

2000-08-21  Nick Clifton  <nickc@redhat.com>

	* config/arm/lib1funcs.asm (ARM_DIV_MOD_BODY): New macro.
	Common code for ARM divide and modulus functions.  Includes
	bug fix for modulos of very large numbers by very small
	divisors -  Before performing any restorative additions, test
	for bottom bits of IP being set, rather than relying upon the
	RORs not matching.
	(THUMB_DIV_MOD_BODY): New macro. Thumb equivalent of
	ARM_DIV_MOD_BODY.
	(__divsi3, __udivsi3, __modsi3, __umodsi3): Use new macros.

2000-08-21  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md ("subdf3"): allow this pattern in cirrus mode.

2000-08-18  Timothy Wall  <twall@redhat.com>

	* config/ia64/t-aix: Renamed from t-monterey.
	* config/ia64/aix.h: Renamed from monterey.h.
	* configure.in: Propagate name changes.
	* configure: Regenerated.

2000-08-18  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (start_ops, unroll): Unrolling loop for pipelining
	one more iteration.

Fri Aug 18 01:25:21 2000  Michael Meissner  <meissner@redhat.com>

	* frv.h (TRANSFER_FROM_TRAMPOLINE): Deal with leading underscores
	or not.

	* frv.c (output_move_single): If we are loading up a small data
	address without the small data pointer being part of the address,
	silently use the small data pointer.
	(frv_legitimize_address): Do not try to legitimize addresses
	unless optimizing.

	* frv.md (define_splits): Remove all constraints.
	(movsi_internal): Taking the address of a small data item without
	the small data pointer, is still a one word operation.
	(movsi_lda_sdata): Add a space in the output.

Thu Aug 17 20:05:35 2000  Michael Meissner  <meissner@redhat.com>

	* frv-asm.h: New file for assembly support.

	* frv-abi.h (whole file): Make no leading underscores default, but
	add support for -fleading-underscore.

	* frv.h (CPP_SPEC): If -fleading-underscore, define the macro
	__FRV_UNDERSCORE__.
	(USER_LABEL_PREFIX): Make default -fno-leading-underscore.

	* frvbegin.c (section setup): Make all external symbols created
	deal with underscores or no underscores in identifiers.
	* frvend.c (section setup): Ditto.
	* lib1funcs.asm (whole file): Ditto.

	* t-frv (EXTRA_HEADERS): Install frv-asm.h into the compiler
	include directory.

2000-08-17  Aldy Hernandez  <aldyh@redhat.com>

	* arm.md ("cirrus_lshiftrt_const"): new pattern.
	(lshrsi3): don't negate the constant value; we now have the
	pattern above.
	("cirrus_lshiftrtdi_const"): new pattern.
	("lshrdi3"): don't negate the constant value; we now have the
	pattern above.
	(cirrus_lshiftrtdi_const): prepend "#" to constant shift amount.
	("cirrus_lshiftrt_const"): same.
	("cirrus_ashl_const"): same.
	("cirrus_ashldi_const"): same.

2000-08-15  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* config/frv/frv.md (mdunpackh, mbtohe): Add constraint to place
	memory address on register.

2000-08-15  Jeffrey A Law  (law@cygnus.com)

	* config/arm/arm.h (ARM_LEGITIMIZE_RELOAD_ADDRESS): limit offsets
	to less than 256 for Cirrus.

	* config/arm/arm.c (arm_print_operand): add 's' output template to
	truncate cirrus shift counts.

	* config/arm/arm.md (cirrus_ashl_const): use template.
	(cirrus_ashlsi3): use template.
	(ashldi3): use template.
	(cirrus_ashldi_const): use template.

2000-08-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/generic/generic.h (DWARF2_ASM_LINE_DEBUG_INFO):
	Document.

2000-08-13  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md ("fix_truncsfsi2"): define_insn replaced by
	define_expand and define_insn.
	("fix_truncdfsi2"): define_insn replace by define_expand and
	define_insn.

	* config/arm/arm.c (arm_gen_compare_reg): do not fix up Cirrus SI
	compares.

	* config/arm/arm.md ("*cirrus_mulsi3"): put pattern after
	corresponding Arm pattern.
	("*cirrus_negsi2"): same.
	("*cirrus_subsi3_insn"): same.
	("*cirrus_mulsi3subsi"): same.
	(*cirrus_mulsi3addsi): same.

2000-08-12  Alexandre Oliva  <aoliva@redhat.com>

	* gcse.c (insert_insn_start_bb): Don't insert it before NOTEs.

Fri Aug 11 16:52:30 2000  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c: Change loc_t on location_t.
	(packet_copy): Don't copy stop packets.  Set up exit packet flag
	for copy as in original packet.

Fri Aug 11 15:39:28 2000  Michael Meissner  <meissner@redhat.com>

	* frv-protos.h (frv_legitimize_address): Fix up declaration of
	previously unimplemented function to match new function.
	(frv_expand_block_move): Add declaration.
	(frv_expand_block_clear): Ditto.
	(frv_emit_movsi): Ditto.
	(pic_register_operand): Ditto.
	(small_data_register_operand): Ditto.
	(small_data_symbolic_operand): Ditto.

	* frv.c (FRV_INLINE): Define as 'inline' if not already defined.
	(symbol_ref_small_data_p): Determine if a SYMBOL_REF references
	small data.
	(const_small_data_p): Determine if a CONST references small data.
	(plus_small_data_p): Determine if a PLUS references small data.
	(frv_stack_info): Change current_function_... into cfun->... where
	possible.
	(frv_frame_pointer_required): Ditto.
	(frv_stack_info): Only create the pic pointer if there were pic
	references.
	(frv_expand_prologue): Ditto.
	(frv_expand_epilogue): Ditto.
	(frv_frame_pointer_required): Ditto.
	(frv_expand_epilogue): If a function saved the LR register, don't
	bother loading the register back into the LR, just issue a jump
	via the register it was loaded into.
	(frv_expand_block_move): New function to expand small constant
	memcpy's inline.
	(frv_expand_block_clear): New function to expand small constant
	memset's of 0 inline.
	(frv_print_operand_memory_reference): Change PIC and small data
	references into explicitly including the pic/small data pointer.
	Use the *_small_data_p functions instead of open code.
	(frv_legitimate_address_p): Ditto.
	(frv_legitimize_address): Ditto (new function).
	(int_2word_operand): Ditto.
	(frv_print_operand): Ditto.
	(pic_symbolic_oeprand): Ditto.
	(dbl_memory_one_insn_operand): Ditto.
	(frv_emit_movsi): Ditto (new function).
	(output_move_single): Ditto.
	(frv_ifcvt_modify_insn): Ditto.
	(frv_regno_ok_for_base_p): Use inline function to replace macro.
	(frv_legitimate_address_p): Ditto.
	(pic_register_opreand): New predicate function.
	(small_data_register_operand): Ditto.
	(small_data_symbolic_operand): Ditto.
	(frv_ifcvt_rewrite_mem): New function to handle removing constants
	from MEM's.  Add code to deal with small data reformat.
	(frv_ifcvt_modify_insn): Call frv_ifcvt_rewrite_mem to handle load
	and stores, instead of duplicating code.

	* frv.h (SDA_BASE_REG): Add cast to unsigned.
	(EXTRA_CONTRAINT_FOR_Q): Handle small data SYMBOL_REF/CONST.
	(LEGITIMIZE_ADDRESS): Define to call frv_legitimize_address.
	(LEGITIMATE_PIC_OPERAND): Define to excluse SYMBOL_REF/CONST/etc.
	(PREDICATE_CODES): Add pic_register_operand,
	small_data_register_operand, and small_data_symbolic_operand.

	* frv.md (i1_sethi reservation): Add generic support.
	(i1_setlo reservation): Ditto.
	(movsi): Call frv_emit_movsi to handle expansion.
	(movsi_lda_data): Support new format small data.
	(movsi_pic): Support new format PIC data.
	(movsi_pic define_split): Ditto.
	(movsi_hi_pic): Ditto.
	(movsi_lo_sum_pic): Ditto.
	(movstrsi): Call frv_expand_block_move for block move.
	(clrstrsi): Call frv_expand_block_clear for block clear.
	(epilogue_return): Take return address and stack pointer as
	arguments.
	(return_internal): If register return address is in is a gpr
	register, use a jmp instead of ret.

	* t-frv (MULTILIB_OPTIONS): Delete -mdword/-mno-dword multilibs.
	Add pic multilib that also handles -G0.
	(MULTILIB_DIRNAMES): Ditto.
	(MULTILIB_MATCHES): Ditto.
	(MULTILIB_EXTRA_OPTS): Delete, no longer used.

	* frv.md (return_internal): Correct type attribute for return via
	gpr instead of lr.

Thu Aug 10 17:01:43 2000  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* config/frv/frv-protos.h (frv_sched_lookahead_str,
	frv_sched_lookahead): Add external definitions of the variables.

	* config/frv/frv.h (TARGET_OPTIONS): Add option
	`-msched-lookahead='.
	(FIRST_CYCLE_MULTIPASS_SCHEDULING_LOOKAHEAD): Define the macro
	value as frv_sched_lookahead.

	* config/frv/frv.c (frv_sched_lookahead_str, frv_sched_lookahead):
	Define the new variables.
	(frv_override_options): Process option `-msched-lookahead='.
	(frv_final_prescan_insn): Process correctly case of achieving non
	insn.

Thu Aug 10 16:42:07 2000  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (insn_cost): Modify cost for insn pair always not
	only when there is bypass between the insns.

2000-08-09  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (*cirrus_arm_movdi): endian fixes.

	* config/arm/arm.md (*cirrus_movdf_hard_insn): endian fixes.
	(*cirrus_arm_movdi): Remove restriction that one of the registers
	have to be a Cirrus register.

2000-08-09  Andrew MacLeod  <amacleod@cygnus.com>

	* invoke.texi: add -fgcse-sm and -fgcse-lm options.
	* flags.h (flag_gcse_lm, flag_gcse_sm): New flags.
	* toplev.c (flag_edge_lm, flag_edge_sm): Initialize.
	(lang_independant_options): Specify new options.
	* gcse.c (struct ls_expr): Add load/store expressions structure.
	(gcse_main): Use enhanced load motion and store motion if requested.
	(mems_conflict_for_gcse_p): Don't kill loads with stores to themselves
	if its in the load/store expression list.
	(pre_edge_insert): Update stores for a load motion expression.
	(one_pre_gcse_pass): Check loads/stores for extra load motion.
	(pre_delete): Update stores for a load motion expression.
	(ldst_entry): Find or create a ldst_expr structure.
	(free_ldst_entry): Free memory for an individual item.
	(free_ldst_mems): Free entire load/store expression list.
	(print_ldst_list): Print debug info.
	(find_rtx_in_ldst): Try to find an rtx expression in the ldst list.
	(enumerate_ldsts): Assign integer values to each entry in list.
	(first_ls_expr): First expression in the list.
	(next_ls_expr): Next expression in the list.
	(simple_mem): Check if expression qualifies for ld/st expression list.
	(invalidate_any_buried_refs): Remove from expression list if its
	used in some other way we dont understand.
	(compute_ld_motion_mems): Find all potential enhanced load motion
	expression.
	(trim_ld_motion_mems): Remove any expressions which are invalid.
	(update_ld_motion_stores): Copy store values to registers for loads
	which have been moved.
	(regvec, st_antloc, num_store): New global statics.
	(reg_set_info): Marks registers as set.
	(store_ops_ok): Verfies registers expressions are valid in a block.
	(find_moveable_store): Look for moveable stores in a pattern.
	(compute_store_table): Find stores in a function worth moving, maybe.
	(load_kills_store): Check dependance of a load and store.
	(find_loads): Find any loads in a pattern.
	(store_killed_in_insn): Check if a store is killed in an insn.
	(store_killed_after): Check is store killed after an insn in a block.
	(store_killed_before): Check is store killed before an insn in a block.
	(build_store_vectors): Generate the antic and avail vectors.
	(insert_insn_start_bb): Insert at the start of a BB, update BLOCK_HEAD.
	(insert_store): Add a store to an edge.
	(replace_store_insn): Replace a store with a SET insn.
	(delete_store): Delete a store insn.
	(free_store_memory): Free memory.
	(store_motion): Perform store motion.

2000-08-09  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* config/frv/frv.md (trap): Change condition in insn reservation
	definition.

2000-08-09  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* config/frv/frv.md (i1_mul, i1_div, i2_gload, i2_fload,
	i4_move_fg, m4):  Change latency time.
	(f1, f2, f3, f4_div, f4_root, f5, m1, m2, m4, m5, m7): Change
	bypass times.
	(media): Split the type value onto m1, m2, m3,
	m4, m5, m6, m7.
	(m1, m2, m3, m4, m5, m6, m7): Change condition in the insn
	reservations definitions.
	(mand, mor, mxor, mnot, maveh, msaths, msathu, maddhss, maddhus,
	msubhss, msubhus, mqaddhss, mqaddhus, mqsubhss, mqsubhus, mpackh,
	munpackh, mdpackh, mbtoh, mhtob, mrotli, mrotri, mwcut, mwcuti,
	msllhi, msrlhi, msrahi, mexpdhw, mexpdhd, mmulhs, mmulhu, mmulxhs,
	mmulxhu, mmachs, mmachu, mmrdhs, mmrdhu, mqmulhs, mqmulhu,
	mqmulxhs, mqmulxhu, mqmachs, mqmachu, mcpxrs, mcpxru, mcpxis,
	mcpxiu, mqcpxrs, mqcpxru, mqcpxis, mqcpxiu, mcut, mcuti, mcutss,
	mcutssi, mwtacc, mwtaccg, mrdacc, mrdaccg, mtrap, mdunpackh,
	mbtohe, mclracc, mclracca, mcop1, mcop2): Change value of
	attribute `type'.

2000-08-08  Nick Clifton  <nickc@cygnus.com>

	* config/mips/mips.c (mips_asm_file_start): Create a
	.mdebug.XXX section where XXX is the ABI in use.

Tue Aug  8  Graham Stott  <grahams@cygnus.co.uk>

	* frv.c (frv_print_operand_memory_reference): Use assemble_name and not
	ASM_OUTPUT_LABELREF.

2000-08-08  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (*cirrus_arm_movdi): cfmv64lr,
	cfmv64hr, cfmvr64l, cfmvr64h-- endian fixes.
	(*cirrus_movdf_hard_insn): endian fixes.

	* config/arm/arm.md ("*cirrus_movdf_hard_insn"): cfmvdhr
	and cfmvrdl-- use %Q and %R for correct endianness.

	* config/arm/arm.md (adddi3): force operands into a
	register if Cirrus mode.
	(*arm_adddi3): disable pattern in Cirrus mode.
	(*adddi_sesidi_di): same
	(*adddi_zesidi_di): same

	Do not split DI addition instructions in Cirrus mode.  We have a
	native 64bit addition instruction.

Mon Aug  7 16:08:52 2000  Michael Meissner  <meissner@redhat.com>

	* frv-protos.h (frv_asm_output_opcode): Add declaration.
	(frv_final_prescan_insn): Ditto.
	(gpr_or_int12_operand): Ditto.
	(fpr_or_int12_operand): Ditto.
	(int6_operand): Ditto.

	* frv.c (frv_tmp_reg_t): Move declaration.
	(frv_ifcvt_max_temp_regs): Delete, no longer used.
	(frv_ifcvt_tmp_reg): New static to hold information about unused
	registers that can be allocated during if conversion.
	(frv_select_rtx_section): Silence int/unsigned compare warnings.
	(frv_conditional_register_usage): Don't reserve FCR_TEMP or the
	GPR_TEMP_FIRST..GPR_TEMP_LAST registers.
	(frv_alloc_temp_reg): Add no abort argument.  Start next
	allocation at next register, even if mark_as_used was false.
	(frv_expand_prologue): Update calls to frv_alloc_temp_reg.
	(frv_expand_epilogue): Ditto.
	(frv_asm_output_mi_thunk): Ditto.
	(frv_asm_output_opcode): Use const char *, not char *.
	(frv_print_operand): Remove '!' case.
	(frv_legitimate_address_p): Add declaration for int argument.
	(frv_mark_register): Inner function to record which registers were
	referenced in an insn.
	(frv_ifcvt_modify_tests): Allocate unused registers rather than
	using reserved registers.  Add ATTRIBUTE_UNUSED as appropriate.
	(frv_ifcvt_load_constant): Ditto.
	(frv_ifcvt_modify_final): Ditto.
	(frv_ifcvt_modify_cancel): Ditto.
	(frv_expand_builtin): Clean up warnings.

	* frv.h (GPR_TEMP_FIRST): Delete, now unused.
	(GPR_TEMP_LAST): Ditto.
	(frv_asm_output_opcode): Move declaration to frv-protos.h.
	(PRINT_OPERAND_PUNCT_VALID_P): Remove '!' case.

2000-08-04  Syd Polk  <spolk@redhat.com>

	* genautomata.c: Use PARAMS so this compiles on a non-ANSI
	compiler.

2000-08-07  Jason Eckhardt  <jle@cygnus.com>

	* config/frv/frv.c (output_condmove_single): Generate conditional
	stores based on the type of MEM when the source is constant.

2000-08-07  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (*arm_movdi): disable pattern when in
	cirrus mode.
	(*thumb_movdi_insn): same

2000-08-07  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.md (movdf): Revert some am33-specific
	pessimizations that had gone in on 2000-05-08.

Fri Aug  4 16:11:42 2000  Michael Meissner  <meissner@redhat.com>

	* d10v.h (LIB_SPEC): Remove -lnosys, which isn't installed or
	built.

Fri Aug  3  Graham Stott <grahams@cygnus.co.uk>

	* frv.h (CONST_OK_FOR_O): Add parenthesis.
	(BSS_SECTION_ASM_OP): Add .section directive and attributes.
	(STRIP_NAME_ENCODING): Add parenthesis and use SDATA_FLAG_CHAR.
	(ASM_OUTPUT_LOCAL): Remove definition.
	(ASM_OUTPUT_ALIGNED_DECL_LOCAL): Define.
	(ASM_OUTPUT_LABELREF): Add parenthesis and use SDATA_FLAG_CHAR.
	(PRINT_OPERAND_PUNCT_VALID_P): Use SDATA_FLAG_CHAR.
	(IFCVT_MODIFY_INSN): Add parenthesis.

	* frv.c (frv_encode_section): Use SDATA_FLAG_CHAR.
	(frv_print_operand): Use SDATA_FLAG_CHAR.

Thu Aug  3 18:28:32 2000  Michael Meissner  <meissner@redhat.com>

	* frv.c (frv_tmp_reg_t): New type to manage allocating temporary
	registers directly.
	(frv_initial_temp_reg): New function to set up the temporary
	register support for prologues and epilogues.
	(frv_alloc_temp_reg): Allocate a new temporary regsiter.
	(frv_next_temp_register): Delete, no longer used.
	(frv_expand_prologue): Use frv_initial_temp_reg and
	frv_alloc_temp_reg to allocate temporary registers needed.
	(frv_expand_epilogue): Ditto.
	(frv_asm_output_mi_thunk): Ditto.

	* frv.h (FIRST_TMP_REGNUM): Delete, no longer used.
	(FIRST_EH_REGNUM): Move so EH registers don't interfere with other
	registers used in the prologue/epilogue.
	(LAST_EH_REGNUM): Ditto.
	(STACK_POINTER_REGNUM): Add in GPR_FIRST.
	(FRAME_POINTER_REGNUM): Ditto.
	(RETURN_VALUE_REGNUM): Ditto.
	(STRUCT_VALUE_REGNUM): Ditto.

2000-08-03  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* config/frv/frv.h (FIRST_CYCLE_MULTIPASS_SCHEDULING,
	FIRST_CYCLE_MULTIPASS_SCHEDULING_LOOKAHEAD): Add macro
	definitions.

2000-08-03  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (max_issue): Set up original state and last_p on
	each iteration.  Use ready_try to determine that the highest rank
	insn is in the sample.
	(schedule_block): Print ready list after the ready list sorting
	for automaton pipeline interface.

2000-08-02  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (add_locref): Fix typo.

2000-08-01  Angela Marie Thomas <angela@cygnus.com>

	* loop.c (load_mems): Correct mysterious 1U.

2000-07-31  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.h (FUNCTION_VALUE_REGNO_P): added
	comment on return result register.

	* config/arm/arm.md (*cirrus_arm_movdi): removed '*'
	modifier for 'v' constraint.
	(*cirrus_movdf_hard_insn): same
	(*call_value_symbol): same
	(*sibcall_value_insn): same
	(*call_value_reg): added "v" constraint.
	(*call_value_mem): same

Mon Jul 31 18:35:34 2000  Vladimir Makarov  <vmakarov@tofu.to.cygnus.com>

	* haifa-sched.c (op): New member use_def_p.
	(op_create): Clear use_def_p.
	(op_copy): Copy value of use_def_p.
	(add_locref): Set up use_def_p if it is necessary.
	(move_cost): Don't move operation if it requires making CFG move
 	consistent and the operation modifies a location.
	(create_avail_list_el): Make abort only for available operation.
	(update_ready_avail_ops): Add modification of existing available
 	operation list.
	(schedule_packet): Update available operation list only after
 	scheduling op which required making CFG move consistent.

Sun Jul 30 13:12:35 2000  Michael Meissner  <meissner@redhat.com>

	* frv.c (frv_asm_output_mi_thunk): Remove debug printf.
	(frv_print_operand_memory_reference): Remove support for POST_DEC
	and POST_INC in #if 0 code.  Add support for POST_MODIFY.
	(frv_legitimate_address_p): Ditto.
	(frv_print_operand): Add support for POST_MODIFY.

	* frv.h (HAVE_POST_INCREMENT): Define so compiler will turn on
	auto increment processing, including POST_MODIFY.
	(HAVE_POST_DECREMENT): Ditto.
	(HAVE_POST_MODIFY_REG): Define as 1.

	* frv.md (extendqihi2): Add %U to support POST_MODIFY.
	(extendqisi2): Ditto.
	(extendhisi2): Ditto.
	(zero_extendqihi2): Ditto.
	(zero_extendqisi2): Ditto.
	(zero_extendhisi2): Ditto.

Fri Jul 28 20:05:37 2000  Michael Meissner  <meissner@redhat.com>

	* frv.c (frv_asm_output_mi_thunk): New function to output code for
	vtable thunks.
	(frv_asm_output_opcode): Use PACKING_FLAG_USED_P to determine if
	the machine supports .p to clear the packing flag.
	(frv_final_prescan_insn): Ditto.

	* frv.h (PACKING_FLAG_USED_P): New macro to determine if the
	machine supports multi-instruction VLIW bundles.
	(ASM_OUTPUT_MI_THUNK): Define, call frv_asm_output_mi_thunk.

	* frv-protos.h (frv_asm_output_mi_thunk): Add declaration.

	* lib1funcs.asm (_cmpll): Use cc<x> instead of cr<x>.
	(_cmpf): Ditto.

Fri Jul 28 13:46:54 2000  Vladimir Makarov  <vmakarov@tofu.to.cygnus.com>

	* toplev.c (rest_of_compilation): Make jump optimization and life
	analysis before software pipelining.

	* haifa-sched.c (dest_insn_require_jump_p): Rename it on
 	dest_packet_requires_jump_p and make it working on packet.
	(start_avail_lists, finish_avail_lists, start_packets,
 	finish_packets, get_packet_name): Add the function prototypes.
	(needs_jump_p): New function.
	(add_the_rest_jumps): Ditto.
	(add_consistent_jumps): Use function needs_jump_p.
	(add_jumps): Add call of add_the_rest_jumps.

2000-07-27  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.h (REG_CLASS_CONTENTS): remove
	CIRRUS_OR_GENERAL_REGS.
	(reg_class): same.

Thu Jul 27 13:55:56 2000  Vladimir Makarov  <vmakarov@tofu.to.cygnus.com>

	* haifa-sched.c (insn_copy): Set up live_reg_set_p as in the
	copied insn.

Thu Jul 27 22:48:34 2000  Michael Meissner  <meissner@redhat.com>

	* frv-protos.h (frv_sched_init): Delete obsolete function.
	(frv_sched_reorder): Ditto.
	(frv_sched_variable_issue): Ditto.

	* frv.c (frv_sched_init): Delete obsolete function.
	(frv_sched_reorder): Ditto.
	(frv_sched_variable_issue): Ditto.

	* frv.h (MD_SCHED_INIT): Delete no-op scheduler hooks.
	(MD_SCHED_REORDER): Ditto.
	(MD_SCHED_VARIABLE_ISSUE): Ditto.

Thu Jul 27 11:19:42 2000  Michael Meissner  <meissner@redhat.com>

	* frv.h (REGISTER_NAMES): Use "cc0".."cc7" instead of
	"cr0".."cr7".

2000-07-24  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.c (cirrus_memory_offset): remove
	allowance of CONSTANT_ADDRESS_P.

	* config/arm/arm.h (HARD_REGNO_MODE_OK): only allow MODE_FLOAT,
	SImode, and DImode in Cirrus regs.

Mon Jul 24 17:01:29 2000  Michael Meissner  <meissner@redhat.com>

	* generic.h (FUNCTION_ARG_KEEP_AS_REFERENCE): Delete 2nd commented
	out version of the macro.

	* d10v.md (cond_exec_hi_binary): Fix typo from cond_exec
	conversion.
	(cond_exec_si_binary): Ditto.
	(cond_exec_call): Disable, assembler does not like conditional
	calls.
	(cond_exec_call_value): Ditto.

Mon Jul 24 14:28:44 CDT 2000  Clinton Popetz  <cpopetz@cygnus.com>

	* mips.c (simple_memory_operand): Fix typo.
	(function_arg): Ditto.

Mon Jul 24 13:54:01 CDT 2000  Clinton Popetz  <cpopetz@cygnus.com>

	* mips.md (mul_acc_si): Fix typo.

2000-07-24  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/t-cirrus-elf (MULTILIB_EXCEPTIONS): new file

	* configure.in: new case for arm9e-*-elf.  New multilib file.

	* configure: same.

	* config/arm/arm.md (*call_value_symbol): Add "*v" constraint.
	(*sibcall_value_insn): Same.
	(*cirrus_sibcall_value_insn): Remove pattern.
	(*cirrus_call_value_symbol): Remove pattern.

	* config/arm/arm.md (subsf3, subdf3): force operand 1 into a
	register if in Cirrus mode.

	* config/arm/arm.h (SECONDARY_INPUT_RELOAD_CLASS): Disallow
	loading constants into Cirrus registers.

	* config/arm/arm.md (*movdf_soft_insn): Disable pattern in Cirrus
	mode.
	(*cirrus_movdf_hard_insn): added Arm register alternatives.  Added
	pool_range and neg_pool_range attributes for these.  Use
	general_operand for operand 1.
	(*arm_movsf_soft_insn): Disable pattern in Cirrus mode.
	(*call_value_symbol): Disable pattern in Cirrus mode.

2000-07-24  Vladimir Makarov  <vmakarov@toke.to.cygnus.com>

	* haifa-sched.c (choose_ready): Use
	FIRST_CYCLE_MULTIPASS_SCHEDULING_LOOKAHEAD only when
	FIRST_CYCLE_MULTIPASS_SCHEDULING is not zero.

2000-07-21  Aldy Hernandez  <aldyh@redhat.com>

	* config/arm/arm.md (adddf3, subsf3, subdf3, mulsf3, muldf3):
	force operand 2 into a register for cirrus.
	(*cirrus_call_value_symbol): same as *call_value_symbol, but
	handles cirrus registers as well.
	(*call_value_symbol): do not choose pattern when in cirrus mode.
	(*cirrus_fp_call_value_symbol): remove pattern.
	(*sibcall_value_insn): do not choose pattern when in cirrus mode.
	(*cirrus_sibcall_value_insn): same as *sibcall_value_insn, but
	handles cirrus registers as well.

	(*cirrus_arm_movdi, *cirrus_arm_movsi_insn,
	*cirrus_movdf_hard_insn): Ignore cirrus registers when choosing
	register preferences.
	(*cirrus_movsf_hard_insn, *cirrus_movdf_hard_insn): use
	nonimmediate_operand predicate instead of cirrus_general_operand.
	(*cirrus_movdf_hard_insn): Incorporate arm movdf pattern into this
	cirrus/arm movdf pattern.

